{Ce fichier est un fichier Include de Modunit.Pas,
 il s'agit en fait du coeur du dcodage mod.
 Dcode remplit le buffer qui lui a t confi
 par Sound.Pas (voir Sound.Txt), et appelle au
 besoin UpDateTick (Modunit.Pas) pour continuer
 le dcodage du mod}

Procedure DecodeBuffer(Pntr:Pointer;Var MInfo:Pointer);
Var RRep:LongInt;
    RRep1:LongInt;
Var LRep:LongInt;
    LRep1:LongInt;
    B1:Integer;

Var Adr:LongWord;
    C:LongWord;
    I:Byte;
Var W1:LongWord;
Var Depl:Word;
Var S:LongInt;

Var LOld,ROld:Integer;
    Sature:LongWord;


Var TailleBuffer:LongWord;

{Var F:File;}

Begin
(*  TailleBuffer:=GetSb(19);*)
  TailleBuffer:=SoundDevice.BufferSize;
  Adr:=0;
  {S est la valeur par laquelle on divise la somme des
   canaux aprs leur mixage}
  S:=1 SHL (10-E.Ampli)*D.NChan;
  Sature:=0;
  {Dbut de la boucle principale,
   nous allons dcoder un octet}
  Repeat
    {Rempli ventuellement le buffer avec des informations
     utiles pour l'interface}
    If (Adr AND 255=0) Then Begin
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].Note:=D.Note;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].Tick:=D.Tick;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].Pos:=D.Pos;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].LoopCount:=Info.LoopCount;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].ShouldStop:=Info.ShouldStop;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].Speed:=D.Speed;
      TInfoBuff(MInfo^).Nfo[Adr SHR 8].Tempo:=D.Bpm;
    End;
    LRep:=0;
    RRep:=0;

    If (E.Interpolation=1) Then Begin
      {Dcode avec interpolation linaire}
      For C:=0 To MaxChan-1 Do Begin
        With Chan[C] Do Begin
          If Used Then Begin
            Case Dir Of
              0:Begin
                {Une avance simple}
                B1:=0;
                If Ofs<LoopF Then Begin
                  W1:=Ofs SHR Fixed;
                  B1:=Ptr[W1-Deca]-32768;
                End;
                Inc(Ofs,Speed);

                If Ofs>=LoopF Then Begin
                  Inc(D.BaseLeft,V1*B1);
                  Inc(D.BaseRight,V2*B1);
                  Used:=False;
                  Ofs:=Deca SHL Fixed;
                  V1:=0;
                  V2:=0;
                End;
              End;
              1:Begin
                {Un Loop}
                Inc(Ofs,Speed);
                If Ofs>=LoopF Then Begin
                  Repeat Dec(Ofs,Decr) Until Ofs<LoopF;
                End;
              End;
              2:Begin
                {Un BidiLoop qui avance}
                Inc(Ofs,Speed);
                If Ofs>=LoopF Then Begin
                  Dir:=3;
                  Dec(Ofs,Speed);
                End;
              End;
              3:Begin
                {Un BidiLoop qui recule}
                Dec(Ofs,Speed);
                If Ofs<=LoopD Then Begin
                  Dir:=2;
                  Inc(Ofs,Speed);
                End;
              End;
            End;
            {Prise de l'offset courant du sample, avec
             interpolation avec ses "voisins" en fonction
             de la valeur de la "virgule" de cet offset,
             stock en fixed point 32-Fixed:Fixed}
{            If (Ofs>=LoopF) Then Begin
              Used:=False;
              Assign(F,'c:\chan.bin');
              ReWrite(F);
              BlockWrite(F,Chan[C],SizeOf(TChan));
              Close(F);
            End Else Begin;}
              W1:=Ofs SHR Fixed-Deca;
              Depl:=Ofs AND (MFixed-1);
              B1:=-32768+((Ptr[W1] SHL Fixed)+(Ptr[W1+1]-Ptr[W1])*Depl) SHR Fixed;
              Inc(LRep,V1*B1);
              Inc(RRep,V2*B1);
{            End;}
          End;
        End;
      End;
    End Else Begin
      {Dcode sans interpolation linaire}
      For C:=0 To MaxChan-1 Do Begin
        With Chan[C] Do Begin
          If (Used) Then Begin
            Case Dir Of
              0:Begin
                {Une avance simple}
                B1:=0;
                If Ofs<LoopF Then Begin
                  W1:=Ofs SHR Fixed;
                  B1:=Ptr[W1-Deca]-32768;
                End;
                Inc(Ofs,Speed);
                If Ofs>=LoopF Then Begin
                  Inc(D.BaseLeft,V1*B1);
                  Inc(D.BaseRight,V2*B1);
                  Used:=False;
                  Ofs:=Deca SHL Fixed;
                  V1:=0;
                  V2:=0;
                End;
              End;
              1:Begin
                {Un Loop}
                Inc(Ofs,Speed);
                If Ofs>=LoopF Then Begin
                  Repeat Dec(Ofs,Decr) Until Ofs<LoopF;
                End;
              End;
              2:Begin
                {Un BidiLoop qui avance}
                Inc(Ofs,Speed);
                If Ofs>=LoopF Then Begin
                  Dir:=3;
                  Dec(Ofs,Speed);
                End;
              End;
              3:Begin
                {Un BidiLoop qui recule}
                Dec(Ofs,Speed);
                If Ofs<=LoopD Then Begin
                  Dir:=2;
                  Inc(Ofs,Speed);
                End;
              End;
            End;
            {Exctracte l'offset du sample, pondration
             avec le volume gauche/droite, et ajout
             au rsultat global}
            W1:=Ofs SHR Fixed-Deca;
            B1:=Ptr[W1]-32768;
            Inc(LRep,V1*B1);
            Inc(RRep,V2*B1);
          End;
        End;
      End;
    End;
    {Gestion tickremove}
    If E.TickRemove Then Begin
      Inc(LRep,D.BaseLeft);
      Inc(RRep,D.BaseRight);
    End;
    Inc(D.BaseLeft,D.BaseSpeedLeft);
    Inc(D.BaseRight,D.BaseSpeedRight);
    D.LastLeft:=LRep;
    D.LastRight:=RRep;

    {Division du rsultat du mixage des pistes}
    LRep1:=LRep Div S;
    RRep1:=RRep Div S;

    {Effet Reverb}
    LOld:=LRep1;
    ROld:=RRep1;
    If E.UseDel Then Begin
      For I:=0 To E.NDel-1 Do Begin
        LRep1:=((LRep1 SHL 4)+E.Del.L[I].D[D.Del[I]]*E.TaDel[I]);
        RRep1:=((RRep1 SHL 4)+E.Del.R[I].D[D.Del[I]]*E.TaDel[I]);
        E.Del.L[I].D[D.Del[I]]:=LOld;
        E.Del.R[I].D[D.Del[I]]:=ROld;
        Inc(D.Del[I]);If D.Del[I]=E.MaxDel[I] Then D.Del[I]:=0;
        ASM
          SAR LRep1, 4
          SAR RRep1, 4
        End;
      End;
    End;
    {Effet surround}
    If E.UseSur Then Begin
      For I:=0 To E.NSur-1 Do Begin
        LRep1:=((LRep1 SHL 4)+E.Sur.R[I].S[D.Sur[I]]*E.TaSur[I]);
        RRep1:=((RRep1 SHL 4)+E.Sur.L[I].S[D.Sur[I]]*E.TaSur[I]);
        E.Sur.L[I].S[D.Sur[I]]:=LOld;
        E.Sur.R[I].S[D.Sur[I]]:=ROld;
        Inc(D.Sur[I]);If D.Sur[I]=E.MaxSur[I] Then D.Sur[I]:=0;
        ASM
          SAR LRep1, 4
          SAR RRep1, 4
        End;
      End;
    End;



    {Vrification du range et de la saturation}
    If LRep1<-32768 Then Begin LRep1:=-32768;Inc(Sature);End;
    If RRep1<-32768 Then Begin RRep1:=-32768;Inc(Sature);End;
    If LRep1>32767 Then Begin LRep1:=32767;Inc(Sature);End;
    If RRep1>32767 Then Begin RRep1:=32767;Inc(Sature);End;

    {Ecriture dans le buffer en fonction du mode de
     mixage}
    Case D.Mode Of
      1:Begin
        Byte(Pointer(LongWord(Pntr)+Adr)^):=(LRep1+RRep1+65536) SHR 9;
        Inc(Adr);
      End;
      2:Begin
        Byte(Pointer(LongWord(Pntr)+Adr)^):=(LRep1+32768) SHR 8;
        Byte(Pointer(LongWord(Pntr)+Adr+1)^):=(RRep1+32768) SHR 8;
        Inc(Adr,2);
      End;
      3:Begin
        Word(Pointer(LongWord(Pntr)+Adr)^):=(LRep1+RRep1) Div 2;
        Inc(Adr,2);
      End;
      4:Begin
        Word(Pointer(LongWord(Pntr)+Adr)^):=LRep1;
        Word(Pointer(LongWord(Pntr)+Adr+2)^):=RRep1;
        Inc(Adr,4);
      End;
    End;
    Inc(D.TickOfs);

    UpDateTick;
  Until Adr>=TailleBuffer;
  {Avertit PMP d'une saturation ventuelle}
  If Sature>0 Then MakeError(3,Sature,0,'Saturation');
End;
