Program Bump;

Uses Crt;

Type
  TScreen=Array[0..199,0..319] Of Byte;
  TNorm=Array[-127..127,-127..127] Of Byte;

Var
  Buf1,Buf2:Pointer;
  I,J:Integer;
  X,Y:Integer;
  Lx,Ly:Integer;
  Norm:Pointer;
  S:Single;

Procedure SetColor(N,R,V,B:byte);Assembler;
ASM
  MOV dx, 3c8h
  MOV al, N
  OUT dx, al
  INC dx
  MOV al, R
  OUT dx, al
  MOV al, V
  OUT dx, al
  MOV al, B
  OUT dx, al
End;

Function Mousex:Integer;Assembler;
ASM
  MOV ax, 03h
  INT 33h
  MOV ax, cx
End;

Function Mousey:Integer;Assembler;
ASM
  MOV ax, 03h
  INT 33h
  MOV ax, dx
End;

Begin

  GetMem(Buf1,64000);
  GetMem(Buf2,64000);
  GetMem(Norm,255*255);

  For Y:=-127 To 127 Do Begin
    For X:=-127 To 127 Do Begin
      I:=Trunc((1-Sqr(X/128)-Sqr(Y/128))*255);
      If I<0 then I:=0;
      TNorm(Norm^)[Y,X]:=I;
    End;
  End;

  For Y:=0 To 199 Do Begin
    For X:=0 To 319 Do Begin
      TScreen(Buf1^)[Y,X]:=Abs(Trunc((Cos(X/10)+Sin(Y/10)+Sin(X/20)+Cos(Y/20))*63));
    End;
  End;
  FillChar(Buf2^,64000,0);

  ASM
    MOV ax, 13h
    INT 10h
  End;
  For I:=0 To 255 Do SetColor(I,I Div 4,I Div 4,I Div 4);

  Repeat

    Lx:=Mousex Div 2;
    Ly:=Mousey;
    For Y:=1 To 198 Do Begin
      For X:=1 To 318 Do Begin
        I:=TScreen(Buf1^)[Y,X+1]-TScreen(Buf1^)[Y,X-1]+Lx-X;
        J:=TScreen(Buf1^)[Y+1,X]-TScreen(Buf1^)[Y-1,X]+Ly-Y;
        If I<-127 Then I:=-127;
        If J<-127 Then J:=-127;
        If I>127 Then I:=127;
        If J>127 Then J:=127;
        TScreen(Buf2^)[Y,X]:=TNorm(Norm^)[J,I];
      End;
    End;

    Move(Buf2^,Ptr($a000,0)^,64000);
  Until KeyPressed;

  ASM
    MOV ax, 03h
    INT 10h
  End;

  FreeMem(Buf1,64000);
  FreeMem(Buf2,64000);
  FreeMem(Norm,255*255);

End.