{exemple de programmation de la mmoire xms par Plouf
 pour Prograzine : dcembre 1999

 contact : plouf@win.be
 }

program xms;
type
  (*la structure utilise pour la communication avec le handler xms*)
  temm=record
    count:longint;
    shandle:word;
    soffset:longint;
    dhandle:word;
    doffset:longint;
  end;

var
  xmshandler:pointer; (*notre handler xms*)
  xmsblock:word; (*le handle du block xms que nous allouons*)
  txt:string; (*un texte qui va nous servir de test*)
  emm:temm; (*de la mmoire pour communiquer*)

(*charge le handler du xms dans xmshandler*)
procedure xmsloadhandler;assembler;
asm
  mov ax, 4310h
  int 2fh
  mov [offset xmshandler+0], bx
  mov [offset xmshandler+2], es
end;

(*retourne la mmoire allouable en ko*)
function xmsgetfree:word;assembler;
asm
  mov ah, 08h
  xor bl, bl
  call xmshandler
end;

(*alloue de la mmoire xms et retourne un handle vers le block allou.
 size est en ko*)
function xmsallocate(size:word):word;assembler;
asm
  mov ah, 09h
  mov dx, size
  call xmshandler
  mov ax, dx
end;

(*libre le block de mmoire xms dont le handle est envoy comme paramtre*)
procedure xmsfree(handle:word);assembler;
asm
  mov ah, 0ah
  mov dx, handle
  call xmshandler
end;

(*opration de manipulation xms, le segment et l'offset d'une structure
  de communication sont envoys comme paramtres*)
procedure xmscopy(sg,os:word);assembler;
asm
  mov ah, 0bh
  mov si, os
  push ds
  mov bx, ds
  mov es, bx
  mov bx, sg
  mov ds, bx
  call es:xmshandler
  pop ds
end;


begin
  (*on initialise*)
  xmsloadhandler;
  writeln('Mmoire disponible : ',xmsgetfree,'ko');

  (*on alloue 1 ko de mmoire xms*)
  xmsblock:=xmsallocate(1);

  txt:='Ce texte va voyager un peu';
  writeln('Avant : ',txt);

  (*on fait une copie de ce texte en xms*)
  emm.count:=256;
  emm.shandle:=0;
  emm.soffset:=longint(@txt);
  emm.dhandle:=xmsblock;
  emm.doffset:=0;
  xmscopy(seg(emm),ofs(emm));

  (*le texte est  prsent en mmoire xms, crasons-le dans la mmoire
    conventionelle*)
  txt:='Ce texte crase le texte prcdant';

  (*nous allons  prsent rechercher l'original inchang en xms*)
  emm.count:=256;
  emm.shandle:=xmsblock;
  emm.soffset:=0;
  emm.dhandle:=0;
  emm.doffset:=longint(@txt);
  xmscopy(seg(emm),ofs(emm));

  (*et bingo!*)
  writeln('Aprs : ',txt);

  (*n'oublions pas de librer la mmoire, tp7 ne le fera pas pour nous!!*)
  xmsfree(xmsblock);

end.