{Grosse unit qui se charge de l'interface de communication
 entre PMP et la skin, et prend galement en relai la
 communication entre la skin et la visualisation.

 Global->Gui}

unit gui;

interface

uses windows,forms,classes,sysutils,global;

{Equivalant PMP du contenu de Skin.Pas}

type tloadproc=function(param:longint;var proc:pointer):boolean;

type tpmod=record
  GetMod:Function(Cmd:Byte):LongInt;
  GetModS:Function(Cmd:Byte):ShortString;
  GetPattern:Function(Patt,Note,Chan,What:Byte):Word;
  GetPatternS:Function(Patt,Note,Chan,What:Byte):ShortString;
  GetInstrS:Function(Cmd:Word):ShortString;
  GetSmplS:Function(Cmd:Word):ShortString;
  GetString:function(param:longint):ShortString;
end;

type TVis=record
  newplay:procedure;stdcall;
  initdc:procedure(hn:hwnd;tx,ty:longword);stdcall;
  uninitdc:procedure;stdcall;
  dodc:procedure(hn:hwnd;pl:boolean);stdcall;
  cleandc:procedure(hn:hwnd);stdcall;
  initpatt:procedure(hn:hwnd;tx,ty:LongWord);stdcall;
  uninitpatt:procedure;stdcall;
  dopatt:procedure(hn:hwnd;pos:byte;pl:boolean);stdcall;
  cleanpatt:procedure(hn:hwnd);stdcall;
  getvisinfo:function(param:longword):longint;stdcall;
  initgraphs:function(hn1,hn2:hwnd;tx1,ty1,tx2,ty2:LongWord):boolean;
  endgraphs:procedure;
end;

type tskin=record
  sksendmessage:function(msg:longint;param:longint):longint;stdcall;
  skmsg:procedure(txt:shortstring;glob:boolean);stdcall;
  skinit:procedure(loadproc:tloadproc);stdcall;
  skend:procedure;stdcall;
  skgetinfo:function(param:longword):longint;stdcall;
end;

type tgui=record
  sendmessage:Function(msg:longint;param:longint):longint;
  getinfo:Function(what:longint):longint;
  setinfo:Function(what:longint;param:longint):longint;
  gui_setinfo:Function(what:longint;param:longint):longint;
  getinfos:Function(what:longint):shortstring;
  setplaylist:Procedure(newplist:tplaylist);
  getplaylist:Function:tplaylist;
end;

const
  msg_gui_play=1;
  msg_gui_pause=2;
  msg_gui_stop=3;
  msg_gui_prev=4;
  msg_gui_next=5;
  msg_gui_select=6;
  msg_gui_moveto=7;
  msg_gui_remove=8;
  msg_gui_open=9;
  msg_gui_setup=10;
  msg_gui_info=11;
  msg_gui_playlist=12;
  msg_gui_repeat=13;
  msg_gui_surround=14;
  msg_gui_reverb=15;
  msg_gui_stereo=16;
  msg_gui_ampli=17;
  msg_gui_aampli=18;
  msg_gui_goto=19;
  msg_gui_volume=20;
  msg_gui_quit=21;

  msg_skin_anim=1;
  msg_skin_redraw=2;
  msg_skin_play=3;
  msg_skin_stop=4;
  msg_skin_initgraphs=5;
  msg_skin_endgraphs=6;
  msg_skin_setwindow=7;
  msg_skin_pause=8;
  msg_skin_resume=9;
  msg_skin_entermenu=10;
  msg_skin_leavemenu=11;

  msg_skin_setwindow_enable=1;
  msg_skin_setwindow_disable=2;
  msg_skin_setwindow_bringtotop=3;

  addr_mod_getmod=1;
  addr_mod_getmods=2;
  addr_mod_getpattern=3;
  addr_mod_getpatterns=4;
  addr_mod_getinstrs=5;
  addr_mod_getsmpls=6;
  addr_mod_getstringmod=7;

  addr_vis_newplay=8;
  addr_vis_initdc=9;
  addr_vis_uninitdc=10;
  addr_vis_dodc=11;
  addr_vis_cleandc=12;
  addr_vis_initpatt=13;
  addr_vis_uninitpatt=14;
  addr_vis_dopatt=15;
  addr_vis_cleanpatt=16;
  addr_vis_getvisinfo=17;
  addr_vis_initgraphs=18;
  addr_vis_endgraphs=19;
  addr_vis_setupvis=27;
  addr_vis_setuppattern=28;

  addr_gui_sendmessage=21;
  addr_gui_getinfo=22;
  addr_gui_getinfos=23;
  addr_gui_setplaylist=24;
  addr_gui_getplaylist=25;
  addr_gui_setinfo=26;

  get_gui_status_plistversion=1;
  get_gui_status_modposition=2;
  get_gui_setup_freq=3;
  get_gui_setup_stereo=4;
  get_gui_setup_b16=5;
  get_gui_setup_device=6;
  get_gui_setup_sepastereo=7;
  get_gui_setup_ampli=8;
  get_gui_setup_devicename=9;
  get_gui_setup_freqconv=10;
  get_gui_setup_devices=11;
  get_gui_setup_reverb=12;
  get_gui_setup_surround=13;
  get_gui_setup_autoampli=14;
  get_gui_setup_nmodloop=15;
  get_gui_setup_replay=16;
  get_gui_setup_priority=17;
  get_gui_setup_interpolation=18;
  get_gui_setup_tickremove=19;
  get_gui_setup_taillebuffer=20;
  get_gui_setup_nbuffers=21;
  get_gui_setup_sature=22;
  get_gui_setup_volume=23;
  get_gui_setup_pitch=24;
  get_gui_setup_speed=25;
  get_gui_setup_prebuff=26;
  get_gui_setup_copyonmove=27;
  get_gui_setup_deleteonremove=28;
  get_gui_status_isplaying=29;
  get_gui_status_ispause=30;
  get_gui_status_sature=31;
  get_gui_status_insetup=32;
  get_gui_setup_delnb=33;
  get_gui_setup_deldelay=34;
  get_gui_setup_delint=35;
  get_gui_setup_surnb=36;
  get_gui_setup_surdelay=37;
  get_gui_setup_surint=38;


  set_gui_setup_freq=1;
  set_gui_setup_stereo=2;
  set_gui_setup_b16=3;
  set_gui_setup_device=4;
  set_gui_setup_sepastereo=5;
  set_gui_setup_ampli=6;
  set_gui_setup_reverb=7;
  set_gui_setup_surround=8;
  set_gui_setup_autoampli=9;
  set_gui_setup_nmodloop=10;
  set_gui_setup_priority=11;
  set_gui_setup_interpolation=12;
  set_gui_setup_tickremove=13;
  set_gui_setup_taillebuffer=14;
  set_gui_setup_nbuffers=15;
  set_gui_setup_sature=16;
  set_gui_setup_volume=17;
  set_gui_setup_pitch=18;
  set_gui_setup_speed=19;
  set_gui_setup_prebuff=20;
  set_gui_setup_copyonmove=21;
  set_gui_setup_deleteonremove=22;
  set_gui_setup_delnb=23;
  set_gui_setup_deldelay=24;
  set_gui_setup_delint=25;
  set_gui_setup_surnb=26;
  set_gui_setup_surdelay=27;
  set_gui_setup_surint=28;

  get_gui_currentfilename=1;
  get_gui_skindirectory=2;
  get_gui_visfilename=3;
  get_gui_skinfilename=4;
  get_gui_pmpversion=5;


  get_mod_moddirectory=1;

  get_vis_nbchan=1;
  get_vis_pmpversion=2;

  get_skin_pmpversion=1;


function gui_sendmessage(msg:longint;param:longint):longint;
function gui_getinfo(what:longint):longint;
function gui_getinfos(what:longint):shortstring;
procedure gui_setplaylist(newplist:tplaylist);
function gui_getplaylist:tplaylist;
function gui_setinfo(what:longint;param:longint):longint;


function skin_sendmessage(msg:longint;param:longint):longint;
function skin_getinfo(what:longint):longint;
procedure skin_msg(txt:string;glob:boolean);
function skin_init(loadproc:tloadproc):boolean;
procedure skin_end;

function getstringmod(param:longint):shortstring;


implementation

uses realmain, modunit,graphs,setup,playlist,select,info,mloop,moveto;

var handle:integer;
    skin:tskin;

procedure gui_setplaylist(newplist:tplaylist);
begin
  PList:=newplist;
  skin_sendmessage(msg_skin_redraw,0);
end;

function gui_getplaylist:tplaylist;
begin
  gui_getplaylist:=plist;
end;

function gui_sendmessage(msg:longint;param:longint):longint;
var tomove,tolist:longword;
    t,ts:string;
var ps:byte;
    sps:double;
    nte:byte;
    npos:byte;
    nnote:byte;
    pc:double;
    f:file;
begin
  gui_sendmessage:=0;
  case msg of
    msg_gui_play:begin
      if not globalinfo.status.ispause then begin
        playcurrent;
      end else begin
        gui_sendmessage(msg_gui_pause,0);
      end;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_pause:begin
      if globalinfo.status.isplaying then begin
        if not globalinfo.status.ispause then begin
          skin_msg('Pause...',true);
          globalinfo.status.ispause:=true;
          modoptions(7,1);
          skin_sendmessage(msg_skin_pause,0);
        end else begin
          modoptions(7,0);
          globalinfo.status.ispause:=false;
          skin_sendmessage(msg_skin_resume,0);
          skin_msg('Resumed',false);
          skin_msg('Playing',true);
        end;
      end;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_stop:begin
      stop;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_prev:begin
      dec(plist.sublist[plist.nlist].current);
      if plist.sublist[plist.nlist].current=-1 then plist.sublist[plist.nlist].current:=plist.sublist[plist.nlist].list.count-1;
      if plist.sublist[plist.nlist].list.count=0 then plist.sublist[plist.nlist].current:=0;
      if globalinfo.status.isplaying then playcurrent;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_next:begin
      inc(plist.sublist[plist.nlist].current);
      if plist.sublist[plist.nlist].current>=plist.sublist[plist.nlist].list.count then plist.sublist[plist.nlist].current:=0;
      if globalinfo.status.isplaying then playcurrent;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_select:begin
      prepareselect;
      skin_sendmessage(msg_skin_entermenu,0);
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_disable);
      form5.show;
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_moveto:begin
      if plist.sublist[plist.nlist].list.count>0 then begin
        tomove:=plist.sublist[plist.nlist].current;
        skin_sendmessage(msg_skin_entermenu,0);
        tolist:=gettolist;
        skin_sendmessage(msg_skin_leavemenu,0);
        if tolist>0 then begin
          ts:=plist.sublist[plist.nlist].list.strings[tomove];
          plist.sublist[tolist].list.add(ts);
          if not globalinfo.config.copyonmove then begin
            plist.sublist[plist.nlist].list.delete(tomove);
            if globalinfo.status.isplaying then playcurrent;
          end;
        end;
        skin_sendmessage(msg_skin_redraw,0);
      end;
    end;
    msg_gui_remove:begin
      if plist.sublist[plist.nlist].list.count>0 then begin
        t:=plist.sublist[plist.nlist].list.strings[plist.sublist[plist.nlist].current];
        assign(f,t);
        if globalinfo.config.deleteonremove and fileexists(t) then erase(f);
        plist.sublist[plist.nlist].list.delete(plist.sublist[plist.nlist].current);
        if globalinfo.status.isplaying then playcurrent;
        skin_sendmessage(msg_skin_redraw,0);
      end;
    end;
    msg_gui_open:begin
      skin_sendmessage(msg_skin_entermenu,0);
      if form9.opendialog1.Execute then begin
        plist.nlist:=0;
        plist.sublist[0].current:=0;
        plist.sublist[0].list:=TStringList.Create;
        plist.sublist[0].list.addstrings(form9.opendialog1.Files);
        playcurrent;
        skin_sendmessage(msg_skin_redraw,0);
      end;
      skin_sendmessage(msg_skin_leavemenu,0);
    end;
    msg_gui_setup:begin;
      globalinfo.status.insetup:=true;
      preparesetup;
      skin_sendmessage(msg_skin_entermenu,0);
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_disable);
      form2.show;
    end;
    msg_gui_info:begin
      prepareinfo;
      form6.show;
    end;
    msg_gui_playlist:begin
      preparelist;
      skin_sendmessage(msg_skin_entermenu,0);
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_disable);
      form4.show;
    end;
    msg_gui_repeat:begin
      if getmod(45)=0 then begin
        if param=-1 then begin
          inc(globalinfo.config.nmodloop);
          if globalinfo.config.nmodloop=5 then globalinfo.config.nmodloop:=255;
        end else begin
          globalinfo.config.nmodloop:=param;
        end;
        updatesetup(false);
        skin_sendmessage(msg_skin_redraw,0);
      end;
    end;
    msg_gui_surround:begin
      case param of
        -1:globalinfo.config.surround:=not globalinfo.config.surround;
        0:globalinfo.config.surround:=false;
        1:globalinfo.config.surround:=true;
      end;
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_reverb:begin
      case param of
        -1:globalinfo.config.reverb:=not globalinfo.config.reverb;
        0:globalinfo.config.reverb:=false;
        1:globalinfo.config.reverb:=true;
      end;
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_aampli:begin
      case param of
        -1:globalinfo.config.autoampli:=not globalinfo.config.autoampli;
        0:globalinfo.config.autoampli:=false;
        1:globalinfo.config.autoampli:=true;
      end;
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_stereo:begin
      if param=-1 then begin
        inc(globalinfo.config.sepastereo);
        if globalinfo.config.sepastereo=7 then globalinfo.config.sepastereo:=0;
      end else begin
        globalinfo.config.sepastereo:=param mod 7;
      end;
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_ampli:begin
      if param=-1 then begin
        inc(globalinfo.config.ampli);
        if globalinfo.config.ampli=6 then globalinfo.config.ampli:=0;
      end else begin
        globalinfo.config.ampli:=param mod 6;
      end;
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_goto:begin
      npos:=getmod(13);
      pc:=param/1000;

      ps:=trunc(pc*npos);

      sps:=pc*npos-ps;
      nnote:=getpattern(ps,0,0,6);
      nte:=trunc(sps*nnote)+1;
      gopos(ps,nte*0+1);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_volume:begin
      globalinfo.config.volume:=param;
      str(globalinfo.config.volume*100 div 256,t);
      skin_msg('Volume : '+t+'%',False);
      updatesetup(globalinfo.config.replay);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    msg_gui_quit:begin
      if param<>0 then globalinfo.status.saveplist:=true else globalinfo.status.saveplist:=false;
      skin_end;
      appfin:=true;
    end;

  end;
end;

function gui_getinfo(what:longint):longint;
var v1,v2:longint;
begin
  gui_getinfo:=0;
  case what of
    get_gui_status_plistversion:gui_getinfo:=2;
    get_gui_status_modposition:begin
      v1:=GetPattern(Getmod(8),0,0,6);
      v2:=getmod(13);
      if (v1<>0) and (v2<>0) then gui_getinfo:=trunc((getmod(8)+getmod(7)/v1)/v2*1000);
    end;
    get_gui_setup_freq:gui_getinfo:=globalinfo.config.freq;
    get_gui_setup_stereo:gui_getinfo:=longint(globalinfo.config.stereo);
    get_gui_setup_b16:gui_getinfo:=longint(globalinfo.config.b16);
    get_gui_setup_device:gui_getinfo:=globalinfo.config.device;
    get_gui_setup_sepastereo:gui_getinfo:=globalinfo.config.sepastereo;
    get_gui_setup_ampli:gui_getinfo:=globalinfo.config.ampli;
    get_gui_setup_devicename:gui_getinfo:=longint(@globalinfo.config.devicename);
    get_gui_setup_freqconv:gui_getinfo:=longint(@globalinfo.config.freqconv);
    get_gui_setup_devices:gui_getinfo:=longint(@globalinfo.config.devices);
    get_gui_setup_reverb:gui_getinfo:=longint(globalinfo.config.reverb);
    get_gui_setup_surround:gui_getinfo:=longint(globalinfo.config.surround);
    get_gui_setup_autoampli:gui_getinfo:=longint(globalinfo.config.autoampli);
    get_gui_setup_nmodloop:gui_getinfo:=globalinfo.config.nmodloop;
    get_gui_setup_replay:gui_getinfo:=longint(globalinfo.config.replay);
    get_gui_setup_priority:gui_getinfo:=longint(globalinfo.config.priority);
    get_gui_setup_interpolation:gui_getinfo:=globalinfo.config.interpolation;
    get_gui_setup_tickremove:gui_getinfo:=longint(globalinfo.config.tickremove);
    get_gui_setup_taillebuffer:gui_getinfo:=globalinfo.config.taillebuffer;
    get_gui_setup_nbuffers:gui_getinfo:=globalinfo.config.nbuffers;
    get_gui_setup_sature:gui_getinfo:=globalinfo.config.sature;
    get_gui_setup_volume:gui_getinfo:=globalinfo.config.volume;
    get_gui_setup_pitch:gui_getinfo:=globalinfo.config.pitch;
    get_gui_setup_speed:gui_getinfo:=globalinfo.config.speed;
    get_gui_setup_prebuff:gui_getinfo:=globalinfo.config.prebuff;
    get_gui_setup_copyonmove:gui_getinfo:=longint(globalinfo.config.copyonmove);
    get_gui_setup_deleteonremove:gui_getinfo:=longint(globalinfo.config.deleteonremove);
    get_gui_status_isplaying:gui_getinfo:=longint(globalinfo.status.isplaying);
    get_gui_status_ispause:gui_getinfo:=longint(globalinfo.status.ispause);
    get_gui_status_sature:gui_getinfo:=longint(globalinfo.status.sature);
    get_gui_status_insetup:gui_getinfo:=longint(globalinfo.status.insetup);
    get_gui_setup_delnb:gui_getinfo:=globalinfo.config.del_nb;
    get_gui_setup_deldelay:gui_getinfo:=globalinfo.config.del_delay;
    get_gui_setup_delint:gui_getinfo:=globalinfo.config.del_int;
    get_gui_setup_surnb:gui_getinfo:=globalinfo.config.sur_nb;
    get_gui_setup_surdelay:gui_getinfo:=globalinfo.config.sur_delay;
    get_gui_setup_surint:gui_getinfo:=globalinfo.config.sur_int;
  end;
end;

function gui_setinfo(what:longint;param:longint):longint;
var repl:boolean;
begin
  repl:=false;
  gui_setinfo:=0;
  case what of
    set_gui_setup_freq:begin globalinfo.config.freq:=param;repl:=true;end;
    set_gui_setup_stereo:begin globalinfo.config.stereo:=boolean(param);repl:=true;end;
    set_gui_setup_b16:begin globalinfo.config.b16:=boolean(param);repl:=true;end;
    set_gui_setup_device:begin globalinfo.config.device:=param;repl:=true;end;
    set_gui_setup_sepastereo:globalinfo.config.sepastereo:=param;
    set_gui_setup_ampli:globalinfo.config.ampli:=param;
    set_gui_setup_reverb:globalinfo.config.reverb:=boolean(param);
    set_gui_setup_surround:globalinfo.config.surround:=boolean(param);
    set_gui_setup_autoampli:globalinfo.config.autoampli:=boolean(param);
    set_gui_setup_nmodloop:globalinfo.config.nmodloop:=param;
    set_gui_setup_priority:globalinfo.config.priority:=tthreadpriority(param);
    set_gui_setup_interpolation:globalinfo.config.interpolation:=param;
    set_gui_setup_tickremove:globalinfo.config.tickremove:=boolean(param);
    set_gui_setup_taillebuffer:begin globalinfo.config.taillebuffer:=param;repl:=true;end;
    set_gui_setup_nbuffers:begin globalinfo.config.nbuffers:=param;repl:=true;end;
    set_gui_setup_sature:globalinfo.config.sature:=param;
    set_gui_setup_volume:globalinfo.config.volume:=param;
    set_gui_setup_pitch:globalinfo.config.pitch:=param;
    set_gui_setup_speed:globalinfo.config.speed:=param;
    set_gui_setup_prebuff:globalinfo.config.prebuff:=param;
    set_gui_setup_copyonmove:globalinfo.config.copyonmove:=boolean(param);
    set_gui_setup_deleteonremove:globalinfo.config.deleteonremove:=boolean(param);
    set_gui_setup_delnb:globalinfo.config.del_nb:=param;
    set_gui_setup_deldelay:globalinfo.config.del_delay:=param;
    set_gui_setup_delint:globalinfo.config.del_int:=param;
    set_gui_setup_surnb:globalinfo.config.sur_nb:=param;
    set_gui_setup_surdelay:globalinfo.config.sur_delay:=param;
    set_gui_setup_surint:globalinfo.config.sur_int:=param;
  end;
  updatesetup(repl);
  skin_sendmessage(msg_skin_redraw,0);
end;

function gui_getinfos(what:longint):shortstring;
var cn,cu:longword;
begin
  gui_getinfos:='';
  case what of
    get_gui_currentfilename:begin
      cn:=plist.sublist[plist.nlist].list.count;
      cu:=plist.sublist[plist.nlist].current;
      if (cn>0) and (cu<cn) then
        gui_getinfos:=plist.sublist[plist.nlist].list.strings[plist.sublist[plist.nlist].current]
      else
        gui_getinfos:='';
    end;
    get_gui_skindirectory:gui_getinfos:=globalinfo.status.skindirectory;
    get_gui_visfilename:gui_getinfos:=globalinfo.Config.visfilename;
    get_gui_skinfilename:gui_getinfos:=globalinfo.config.skinfilename;
    get_gui_pmpversion:gui_getinfos:=globalinfo.pmpversion;
  end;
end;

function skin_sendmessage(msg:longint;param:longint):longint;
var t:string;
const conv:array[1..6] of string=('Msg_Skin_Anim','Msg_Skin_Redraw','Msg_Skin_Play','Msg_Skin_Stop','Msg_Skin_InitGraphs','Msg_Skin_EndGraphs');
begin
  skin_sendmessage:=0;
  str(param,t);
  if isreadyskin then skin_sendmessage:=skin.sksendmessage(msg,param);
end;

function skin_getinfo(what:longint):longint;
begin
  skin_getinfo:=0;
  if isreadyskin then skin_getinfo:=skin.skgetinfo(what);
end;

procedure skin_msg(txt:string;glob:boolean);
begin
  if isreadyskin then skin.skmsg(txt,glob);
end;

function getstringmod(param:longint):shortstring;
begin
  case param of
    get_mod_moddirectory:getstringmod:=globalinfo.status.visdirectory;
  end;
end;

function skin_init(loadproc:tloadproc):boolean;
var f:string;
label re,echec,ok;
begin
  skin_init:=true;
re:
  f:=globalinfo.Config.SkinFileName;
  globalinfo.Status.SkinDirectory:=getdir(2);
  f:=f+#0;
  handle:=loadlibrary(@f[1]);
  if handle=0 then goto echec;
  @skin.sksendmessage:=GetProcAddress(Handle, 'SkSendMessage');
  if @skin.sksendmessage=nil then goto echec;
  @skin.skmsg:=GetProcAddress(Handle, 'SkMsg');
  if @skin.skmsg=nil then goto echec;
  @skin.skinit:=GetProcAddress(Handle, 'SkInit');
  if @skin.skinit=nil then goto echec;
  @skin.skend:=GetProcAddress(Handle, 'SkEnd');
  if @skin.skend=nil then goto echec;
  @skin.skgetinfo:=GetProcAddress(Handle, 'SkGetInfo');
  if @skin.skgetinfo=nil then goto echec;
  goto ok;

echec:
  if globalinfo.config.skinfilename<>'' then
    application.messagebox('Invalid PMP Skin','Error',mb_iconerror)
  else
    application.messagebox('You should choose a skin','First launch message',mb_iconstop);

  if form2.opendialog1.execute then begin
    globalinfo.config.skinfilename:=form2.opendialog1.filename;
    goto re;
  end else begin
    skin_init:=false;
    exit;
  end;

ok:
  isreadyskin:=true;
  skin.skinit(loadproc);
end;

procedure skin_end;
begin
  skin_sendmessage(msg_skin_endgraphs,0);
  isreadyskin:=false;
  skin.skend;
end;

end.

