{Si on nglige l'interface, on peut dire que PMP est
 cette unit, il s'agit de l'unit module autonome qui
 se charge du dcodage mod et de l'interface entre la carte
 son...}

Unit ModUnit;

Interface
Uses Windows;
Type TErrh=Procedure(Err1,Err2:LongInt;Fatal:Boolean;Txt:String;From:Byte);
Procedure DoMod;
Procedure UnInitMod;
Function InitMod(Fle:String;ErrH:TErrH;Speed:Word;Vs,Vb:Boolean;DeviceType:Word;Device:LongInt;Auto:Boolean;Loop:Byte;FileN:String;Pre:Single;CBWin:HWnd):Boolean;
Procedure ModOptions(Cmd,Param:LongWord);
Function GetMod(Cmd:Byte):LongInt;
Function GetModS(Cmd:Byte):ShortString;
Function GetPattern(Patt,Note,Chan,What:Byte):Word;
Function GetPatternS(Patt,Note,Chan,What:Byte):ShortString;
Function UpdateSoundConfig(DeviceType:Word;Device:LongInt;Speed:Word;Vs,Vb:Boolean;Pos,Note:Byte;FileN:String;Pre:Single;CBWin:HWnd):Boolean;
Function GetInstrS(Cmd:Word):ShortString;
Function GetSmplS(Cmd:Word):ShortString;

Implementation
Uses Sound,NewUtils,SysUtils;

Const VibTab1:Array[0..31] Of Byte=(0,24,49,74,97,120,141,161,180,197,212,224,235,244,250,253,
                            255,253,250,244,235,224,212,197,180,161,141,120,97,74,49,24);
Const VibTab2:Array[0..31] Of Byte=(248,240,232,224,216,208,200,192,184,176,168,160,152,144,136,128,
                            120,112,104,96,88,80,72,64,56,48,40,32,24,16,8,0);
Const Period:Array[0..11] Of Word=(1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,907);
Const PeriodTab:Array[0..12*8-1] Of Word=(
      907,900,894,887,881,875,868,862,856,850,844,838,832,826,820,814,
      808,802,796,791,785,779,774,768,762,757,752,746,741,736,730,725,
      720,715,709,704,699,694,689,684,678,675,670,665,660,655,651,646,
      640,636,632,628,623,619,614,610,604,601,597,592,588,584,580,575,
      570,567,563,559,555,551,547,543,538,535,532,528,524,520,516,513,
      508,505,502,498,494,491,487,484,480,477,474,470,467,463,460,457);
Const AmigaTab:Array[0..15] Of Word=(7895,7941,7985,8046,8107,8169,8232,8280,8363,8413,8463,8529,8581,8651,8723,8757);

Const Deca=256;
Const MaxChan=32;
Const Fixed=12;
      MFixed=1 SHL Fixed;

Var SoundDevice:TSound;
Var Eff_Speed,Eff_Jump,Eff_Break,Eff_VolSlide,Eff_PortDown,
    Eff_PortUp,Eff_PortNote,Eff_Vibrato,Eff_Tremor,
    Eff_Arpeggio,Eff_Offset,Eff_Retrig,{Eff_SetFilter,}
    {Eff_FineTune,Eff_PatLoop,}Eff_SetVolume{,Eff_CutNote},
    {Eff_DelayNote,Eff_DelayPat,}Eff_Tempo,Eff_GlobVol,
    Eff_Pan,{Eff_Pan16,Eff_FinePortUp,Eff_FinePortDn,
    Eff_FineVolUp,Eff_FineVolDn,Eff_PanSlideLeft,
    Eff_PanSlideRight,}Eff_KeyOff,Eff_GlobSlide,
    Eff_XTend1,Eff_XTend2,Eff_Tremolo:Byte;

Var IsErr:Boolean;    

Type TDelChan=Record
  D:Array Of LongInt;
End;

Type TSurChan=Record
  S:Array Of LongInt;
End;

Type TDel=Record
  L:Array Of TDelChan;
  R:Array Of TDelChan;
End;
Type TSur=Record
  L:Array Of TSurChan;
  R:Array Of TSurChan;
End;

NoteInfo=Record
  Note:Byte;
  Tick:Byte;
  Pos:Byte;
  Speed:Byte;
  Tempo:Byte;
  LoopCount:Byte;
  ShouldStop:Boolean;
End;

TInfoBuff=Record
  Nfo:Array[0..255] Of NoteInfo;
End;


Type
TD=Record
  WantLast:Boolean;
  Mode:Byte;
  TickOfs:Word;
  Tick:Byte;
  Pattern:Byte;
  Note:Word;
  Speed:Byte;
  Pos:Byte;
  Max:Byte;
  CurSend:LongWord;
  PosSend:LongWord;
  OpTicks:LongWord;
  Bpm:Byte;
  Restart:Byte;

  NChan:Byte;
  NInstr:Word;
  NSmpl:Word;

  LPS:Array[0..MaxChan-1] Of Word;
  NTP:Array[0..MaxChan-1] Of Word;
  VibPos:Array[0..MaxChan-1] Of Byte;
  VibNeg:Array[0..MaxChan-1] Of Byte;
  TremPos:Array[0..MaxChan-1] Of Byte;
  TremNeg:Array[0..MaxChan-1] Of Byte;
  LastVib:Array[0..MaxChan-1] Of Word;
  LastVibD:Array[0..MaxChan-1] Of Word;
  LastVibV:Array[0..MaxChan-1] Of Word;
  LastTrem:Array[0..MaxChan-1] Of Word;
  LastTremD:Array[0..MaxChan-1] Of Word;
  LastTremV:Array[0..MaxChan-1] Of Word;
  LastVS:Array[0..MaxChan-1] Of Byte;
  LastSU:Array[0..MaxChan-1] Of Byte;
  LastSD:Array[0..MaxChan-1] Of Byte;
  LastArp:Array[0..MaxChan-1] Of Byte;
  LastTre:Array[0..MaxChan-1] Of Byte;
  LastRet:Array[0..MaxChan-1] Of Byte;
  LastSR:Array[0..MaxChan-1] Of Byte;
  LastSL:Array[0..MaxChan-1] Of Byte;
  LastGS:Array[0..MaxChan-1] Of Byte;

  PatternLoop:Array[0..MaxChan-1] Of Byte;
  LoopPoint:Array[0..MaxChan-1] Of Byte;
  WaitPat:Byte;
  WaitSpeed:Array[0..MaxChan-1] Of Byte;


  Del:Array Of Word;
  Sur:Array Of Word;

  LastPer:Array[0..MaxChan-1] Of Word;
  LastIns:Array[0..MaxChan-1] Of Word;
  LastSmp:Array[0..MaxChan-1] Of Word;
  LastEffCmd:Array[0..MaxChan-1] Of Word;
  LastVol:Array[0..MaxChan-1] Of Word;
  LastInfo:Array[0..MaxChan-1] Of Word;
  LastPan:Array[0..MaxChan-1] Of Word;
  LastVolCmd:Array[0..MaxChan-1] Of Byte;

  GlobPer:Array[0..MaxChan-1] Of Word;
  GlobIns:Array[0..MaxChan-1] Of Word;
  GlobSmp:Array[0..MaxChan-1] Of Word;
  GlobEff:Array[0..MaxChan-1] Of Word;
  GlobVol:Array[0..MaxChan-1] Of Word;
  GlobPan:Array[0..MaxChan-1] Of Word;

  WasUsed:Array[0..MaxChan-1] Of Boolean;

  GVol:Byte;
  MVol:Byte;

  NextNote:Word;
  NextPos:Byte;
  NextPattern:Byte;
  IsWaitJump:Boolean;
  IsAskJump:Boolean;

  BaseLeft:LongInt;
  BaseRight:LongInt;
  LastLeft:LongInt;
  LastRight:LongInt;

  BaseSpeedLeft:LongInt;
  BaseSpeedRight:LongInt;

  VibType:Array[0..MaxChan-1] Of Byte;
  TremType:Array[0..MaxChan-1] Of Byte;
  Gliss:Array[0..MaxChan-1] Of Byte;
  ShouldPort:Array[0..MaxChan-1] Of Word;
  LastPS:Array[0..MaxChan-1] Of Word;

End;

TE=Record
  UseDel:Boolean;
  NDel:Byte;
  MaxDel:Array Of Word;
  TaDel:Array Of Byte;
  DelD,DelS:LongWord;
  ValD,ValS:Byte;

  UseSur:Boolean;
  NSur:Byte;
  MaxSur:Array Of Word;
  TaSur:Array Of Byte;

  Ampli:Byte;
(*  Volume:Integer;*)
  Pitch:Single;
  Speed:Single;

  Interpolation:Byte;
  TickRemove:Boolean;
  Del:TDel;
  Sur:TSur;
End;

Type TI=Record
  LoopCount:Byte;
  NLoop:Byte;
  NoGVolUpdate:Boolean;
  ShouldStop:Boolean;
  WhereLoop:Word;
End;

Var D:TD;
    E:TE;
    Info:TI;

    Duree:Word;

Var MainProgErr:TErrh;

Var MixSpeed:Word;
Var Stereo:Boolean;
    Out16B:Boolean;
    Sepa_Stereo:Byte;

Var TotTimer:LongWord;
Var DebTimer,BaseTimer:LongWord;
    Joue:Boolean;

Var LastCpu:Double;

Var MType:Byte;
Var ModTitle:String;
Var FreqTable:Byte;
    PUsed:Array[0..255] Of Boolean;

Type TDyn=Array Of Word;

Type TSmpl=Record
  Pntr:TDyn;
  Size:LongWord;
  Loop:Byte;
  LoopF:LongWord;
  LoopD:LongWord;
  Volume:Byte;
  Fine:ShortInt;
  Amiga:Word;
  Pan:Integer;
  Rel:ShortInt;
  FileName:String;
  B16:Boolean;
End;

Var Smpl:Array Of TSmpl;

Type TInstr=Record
  Defined:Boolean;

  List:Array[0..95] Of Word;
  NSmpl:Byte;
  VolEnvX:Array[0..11] Of Word;
  VolEnvY:Array[0..11] Of Byte;
  PanEnvX:Array[0..11] Of Word;
  PanEnvY:Array[0..11] Of ShortInt;
  UseVolEnv:Boolean;
  UsePanEnv:Boolean;

  UseVolSus:Boolean;
  LoopDVolEnv:Word;
  LoopFVolEnv:Word;
  SusVolEnv:Byte;
  NPntVolEnv:Byte;
  LoopVolEnv:Boolean;

  UsePanSus:Boolean;
  LoopDPanEnv:Word;
  LoopFPanEnv:Word;
  SusPanEnv:Byte;
  NPntPanEnv:Byte;
  LoopPanEnv:Boolean;

  FadeOut:LongWord;
  FileName:String;
End;

Type TChan=Record
  Instru:Byte;
  Sample:Byte;
  Ofs:LongWord;
  Speed:LongWord;
  Dir:Byte;
  VolCmd:Byte;
  EffCmd:Byte;
  EffParam:Byte;
  Period:Integer;
  Pan:Integer;
  Volume:Byte;

  Loop:Byte;
  LoopF:LongWord;
  LoopD:LongWord;
  Decr:LongWord;

  Ptr:TDyn;
  V1:LongInt;
  V2:longInt;

  UseVolEnv:Boolean;
  UsePanEnv:Boolean;

  PosVolEnv:Word;
  CurVolEnv:Byte;
  ViteVolEnv:ShortInt;
  NextVolEnv:Byte;
  IsVolSustain:Boolean;
  VolEnv:Byte;
  UseVolSus:Boolean;

  PosPanEnv:Word;
  CurPanEnv:Byte;
  VitePanEnv:ShortInt;
  NextPanEnv:Byte;
  IsPanSustain:Boolean;
  PanEnv:ShortInt;
  UsePanSus:Boolean;

  FadeOut:LongWord;
  VFadeOut:LongWord;
  Used:Boolean;
  ReservedAling:Array[1..256-81] Of Byte;
End;

Type PatChanT=Record
  Instru,Sample:Array[1..256] Of Word;
  Period:Array[1..256] Of Integer;
  EffCmd,EffParam:Array[1..256] Of Byte;
  VolCmd:Array[1..256] Of Byte;
End;

Var Pattern:Array[0..255,0..MaxChan-1] Of ^PatChanT;
Var PRow:Array[0..255] Of Word;

Var Instr:Array[0..255] Of TInstr;
Var Chan:Array[0..MaxChan-1] Of TChan;

Var PatPos:Array[0..255] Of Byte;
Var PosSpeed:Array[0..255] Of Byte;
    PosTempo:Array[0..255] Of Byte;

Procedure VerifPos;
Begin
  While (PatPos[D.Pos]>=254) Or (Pattern[PatPos[D.Pos],0]=Nil) Do Begin
    Inc(D.Pos);
    If D.Pos>=D.Max Then D.Pos:=0;
  End;
End;

Procedure CheckLoop;
Var I:Integer;
Begin
  If PUsed[D.Pos] Then Begin
    For I:=0 To 255 Do PUsed[I]:=False;
    Inc(Info.LoopCount);
    If Info.LoopCount>Info.NLoop Then Begin
      D.GVol:=0;
      Info.NoGVolUpdate:=True;
      Info.ShouldStop:=True;
    End;
  End;
End;

Procedure CalcPer(C:Byte);
Var Mult:Single;
Begin
  If Not Joue Then Exit;
  (*conversion frequence/pas*)
  If Chan[C].Period<>0 Then Begin
    Case FreqTable Of
      0:Begin
        Chan[C].Speed:=Round(14317456/Chan[C].Period*MFixed/MixSpeed*E.Pitch);
      End;
      1:Begin
        Mult:=(4608-Chan[C].Period)/768;
        Chan[C].Speed:=Round(8363*Exp(Mult*Ln(2))*MFixed/MixSpeed*E.Pitch);
       End;
    End;
  End Else Begin
    Chan[C].Used:=False;
  End;
End;

Procedure StopNote(C:Byte);
{Var I:Byte;
Label Fin;}
Begin
{  For I:=D.NChan To MaxChan-1 Do Begin
    If Not Chan[I].Used Then Begin
      Chan[I]:=Chan[C];
      Chan[I].VFadeOut:=24000;
      Goto Fin;
    End;
  End;
  Fin:}
End;

Procedure ReInit(C:Byte);
Begin
  (*reinitialisation du channel aux valeurs globales*)
  If Chan[C].Used Then Begin
    Chan[C].Period:=D.GlobPer[C];
    Chan[C].Volume:=D.GlobVol[C];
    CalcPer(C);
  End;
End;

Procedure Init(C,E:Byte);
Var I:Byte;
Begin
  If Not Joue Then Exit;
  I:=Chan[C].Instru;
  If E=2 Then Begin
    Chan[C].Used:=True;
    Chan[C].Ofs:=Deca SHL Fixed;
  End;
  Chan[C].FadeOut:=65535;
  Chan[C].VFadeOut:=0;

  (*volume envelop*)
  Chan[C].CurVolEnv:=0;
  Chan[C].NextVolEnv:=1;
  Chan[C].PosVolEnv:=0;
  Chan[C].ViteVolEnv:=1;
  Chan[C].IsVolSustain:=False;
  Chan[C].UseVolEnv:=Instr[I].UseVolEnv;
  Chan[C].UseVolSus:=Instr[I].UseVolSus;
  Chan[C].VolEnv:=Instr[I].VolEnvY[0];

  If Instr[I].NPntVolEnv=1 Then Chan[C].UseVolEnv:=False;
  If Not Chan[C].UseVolEnv Then Chan[C].VolEnv:=64;
  If (Instr[I].SusVolEnv=0) And Instr[I].UseVolSus Then Begin
    Chan[C].IsVolSustain:=True;
    Chan[C].UseVolSus:=False;
  End;

  (*pan envelop*)
  Chan[C].CurPanEnv:=0;
  Chan[C].NextPanEnv:=1;
  Chan[C].PosPanEnv:=0;
  Chan[C].VitePanEnv:=1;
  Chan[C].IsPanSustain:=False;
  Chan[C].UsePanEnv:=Instr[I].UsePanEnv;
  Chan[C].UsePanSus:=Instr[I].UsePanSus;
  Chan[C].PanEnv:=Instr[I].PanEnvY[0];
  If Instr[I].NPntPanEnv=1 Then Chan[C].UsePanEnv:=False;
  If Not Chan[C].UsePanEnv Then Chan[C].PanEnv:=0;
  If (Instr[I].SusPanEnv=0) And Instr[I].UsePanSus Then Begin
    Chan[C].IsPanSustain:=True;
    Chan[C].UsePanSus:=False;
  End;

End;

Procedure DoEnv(C:Byte);
Var X,Lx:Word;
    Y1,Y2,I:Integer;

Begin
  If Not Joue Then Exit;
  If Chan[C].FadeOut>Chan[C].VFadeOut Then Dec(Chan[C].FadeOut,Chan[C].VFadeOut) Else Chan[C].Used:=False;

  If Chan[C].UseVolEnv Then Begin
    I:=Chan[C].Instru;
    If Not Chan[C].IsVolSustain Then Begin
      Inc(Chan[C].PosVolEnv,Chan[C].ViteVolEnv);
      X:=Chan[C].PosVolEnv-Instr[I].VolEnvX[Chan[C].CurVolEnv];
      Lx:=Instr[I].VolEnvX[Chan[C].NextVolEnv]-Instr[I].VolEnvX[Chan[C].CurVolEnv]+1;
      Y1:=Instr[I].VolEnvY[Chan[C].CurVolEnv];
      Y2:=Instr[I].VolEnvY[Chan[C].NextVolEnv];
      Chan[C].VolEnv:=Trunc(Y2*X/Lx+Y1*(1-X/Lx));
      If Chan[C].PosVolEnv=Instr[I].VolEnvX[Chan[C].NextVolEnv] Then Begin
        If (Chan[C].UseVolSus) And (Chan[C].NextVolEnv=Instr[I].SusVolEnv) Then Begin
          Chan[C].IsVolSustain:=True;
          Chan[C].UseVolSus:=False;
          Inc(Chan[C].CurVolEnv);
          Inc(Chan[C].NextVolEnv);
        End Else Begin
          If (Chan[C].NextVolEnv=Instr[I].LoopFVolEnv) AND Instr[I].LoopVolEnv Then Begin
            Chan[C].CurVolEnv:=Instr[I].LoopDVolEnv;
            Chan[C].NextVolEnv:=Instr[I].LoopDVolEnv+1;
            Chan[C].PosVolEnv:=Instr[I].VolEnvX[Chan[C].CurVolEnv];
          End Else Begin
            If Chan[C].NextVolEnv=Instr[I].NPntVolEnv-1 Then Begin
              Chan[C].ViteVolEnv:=0;
            End Else Begin
              Inc(Chan[C].CurVolEnv);
              Inc(Chan[C].NextVolEnv);
            End;
          End;
        End;
      End;
    End;
  End;

  If Chan[C].UsePanEnv Then Begin
    I:=Chan[C].Instru;
    If Not Chan[C].IsPanSustain Then Begin
      Inc(Chan[C].PosPanEnv,Chan[C].VitePanEnv);
      X:=Chan[C].PosPanEnv-Instr[I].PanEnvX[Chan[C].CurPanEnv];
      Lx:=Instr[I].PanEnvX[Chan[C].NextPanEnv]-Instr[I].PanEnvX[Chan[C].CurPanEnv]+1;
      Y1:=Instr[I].PanEnvY[Chan[C].CurPanEnv];
      Y2:=Instr[I].PanEnvY[Chan[C].NextPanEnv];
      Chan[C].PanEnv:=Round(Y2*X/Lx+Y1*(1-X/Lx));
      If Chan[C].PosPanEnv=Instr[I].PanEnvX[Chan[C].NextPanEnv] Then Begin
        If (Chan[C].UsePanSus) And (Chan[C].NextPanEnv=Instr[I].SusPanEnv) Then Begin
          Chan[C].IsPanSustain:=True;
          Chan[C].UsePanSus:=False;
          Inc(Chan[C].CurPanEnv);
          Inc(Chan[C].NextPanEnv);
        End Else Begin
          If (Chan[C].NextPanEnv=Instr[I].LoopFPanEnv) AND Instr[I].LoopPanEnv Then Begin
            Chan[C].CurPanEnv:=Instr[I].LoopDPanEnv;
            Chan[C].NextPanEnv:=Instr[I].LoopDPanEnv+1;
            Chan[C].PosPanEnv:=Instr[I].PanEnvX[Chan[C].CurPanEnv];
          End Else Begin
            If Chan[C].NextPanEnv=Instr[I].NPntPanEnv-1 Then Begin
              Chan[C].VitePanEnv:=0;
            End Else Begin
              Inc(Chan[C].CurPanEnv);
              Inc(Chan[C].NextPanEnv);
            End;
          End;
        End;
      End;
    End;
  End;
End;

Procedure ErrHandler(NErr1,NErr2:LongWord;Txt:String);Forward;
Procedure Decode(Pntr:Pointer;Info:Pointer);Forward;

Procedure Do_Note;Forward;
Procedure Do_Effects;Forward;


{$I Utils.Pas}
{$I Effects.Pas}


Procedure Do_Effects_Xm;
Var C:Byte;
    Cmd:Byte;
    Param:Word;
    T1:Byte;
Label No_effects;
Begin
(*  Goto No_Effects;*)
  D.WantLast:=False;
  D.IsAskJump:=False;
  For C:=0 To MaxChan-1 Do DoEnv(C);
  For C:=0 To D.NChan-1 Do Begin
    (*colonne volume*)
    Cmd:=Chan[C].VolCmd;
    Case Cmd Of
      $10..$50:SetVolume(C,Cmd-$10);
      $60..$6f:VolSlide(C,(Cmd-$60));
      $70..$7f:VolSlide(C,(Cmd-$70) SHL 4);
      $80..$8f:FineVolDn(C,Cmd-$80);
      $90..$9f:FineVolUp(C,Cmd-$90);
      $a0..$af:D.LastVibV[C]:=Cmd-$a0;
      $b0..$bf:Vibrato(C,Cmd-$b0);
      $c0..$cf:Pan16(C,Cmd-$c0);
      $d0..$df:PanSlideLeft(C,Cmd-$d0);
      $e0..$ef:PanSlideRight(C,Cmd-$e0);
      $f0..$ff:PortNote(C,Cmd-$f0);
    End;

    Cmd:=Chan[C].EffCmd;
    Param:=Chan[C].EffParam;
    T1:=Param SHR 4;

    Case Cmd Of
      $0:Arpeggio(C,Param);
      $1:PortUp(C,Param);
      $2:PortDown(C,Param);
      $3:PortNote(C,Param);
      $4:Vibrato(C,Param);
      $5:Begin
        PortNote(C,0);
        VolSlide(C,Param);
      End;
      $6:Begin
        Vibrato(C,0);
        VolSlide(C,Param);
      End;
      $7:Tremolo(C,Param);
      $8:Pan(C,Param);
      $9:Offset(C,Param);
      $a:VolSlide(C,Param);
      $b:Jump(C,Param);
      $c:SetVolume(C,Param);
      $d:Break(C,Param);
      $e:Begin
        Case T1 Of
          $1:FinePortUp(C,Param);
          $2:FinePortDn(C,Param);
          $3:SetGliss(C,Param);
          $4:SetVibrato(C,Param);
(*          $5:FineTune(C,Param);*)
          $7:SetTremolo(C,Param);
          $6:PatLoop(C,Param);
          $9:Retrig(C,Param);
          $a:FineVolUp(C,Param);
          $b:FineVolDn(C,Param);
          $c:CutNote(C,Param);
          $d:DelayNote(C,Param);
          $e:DelayPat(C,Param);
        End;
      End;
      $f:Speed(C,Param);
      16:GlobVol(C,Param);
      17:GlobSlide(C,Param);
      20:KeyOff(C,Param);
      21:SetEnvPos(C,Param);
      25:PanSlide(C,Param);
      27:MultiRetrig(C,Param);
      29:Tremor(C,Param);
      34:Case T1 Of
        1:XUp(C,Param);
        2:XDown(C,Param);
      End;
    End;
  End;
No_Effects:
End;


Procedure Do_Effects_S3m;
Var C:Byte;
    Cmd:Byte;
    Param:Word;
(*    Deja:Boolean;*)

Label No_effects;
Begin
(*  Goto No_Effects;*)
(*  Deja:=False;*)
  D.WantLast:=False;
  D.IsAskJump:=False;
  For C:=0 To MaxChan-1 Do DoEnv(C);
  For C:=0 To D.NChan-1 Do Begin
    (*colonne volume*)
    If (Pattern[D.Pattern,C]^.VolCmd[D.Note]<>0) And (D.Tick=0) Then Begin
      Chan[C].Volume:=Pattern[D.Pattern,C]^.VolCmd[D.Note]-$10;
      If Chan[C].Volume>64 Then Chan[C].Volume:=64;
      D.GlobVol[C]:=Chan[C].Volume;
    End;

    Cmd:=Chan[C].EffCmd;
    Param:=Chan[C].EffParam;

    Case Cmd Of
      0:Reinit(C);
      1:Speed(C,Param);
      2:Jump(C,Param);
      3:Break(C,Param);
      4:VolSlide(C,Param);
      5:PortDown(C,Param);
      6:PortUp(C,Param);
      7:PortNote(C,Param);
      8:Vibrato(C,Param);
      9:Tremor(C,Param);
      10:Arpeggio(C,Param);
      11:Begin
        Vibrato(C,0);
        VolSlide(C,Param);
      End;
      12:Begin
        PortNote(C,0);
        VolSlide(C,Param);
      End;
      15:Offset(C,Param);
      17:Retrig(C,Param);
      18:Tremolo(C,Param);
      19:Begin
        Case Param SHR 4 Of
          0:SetFilter(C,Param);
          1:SetGliss(C,Param);
          2:FineTune(C,Param);
          4:SetTremolo(C,Param);
          8:Pan16(C,Param);
          $b:PatLoop(C,Param);
          $c:CutNote(C,Param);
          $d:DelayNote(C,Param);
          $e:DelayPat(C,Param);
        End;
      End;
      20:Tempo(C,Param);
      22:GlobVol(C,Param);
      24:Pan(C,Param);
    End;
  End;
No_Effects:
End;

Procedure Do_Effects_Mod;
Var C:Byte;
    Cmd:Byte;
    Param:Byte;
    T1:Byte;
Label No_effects;
Begin
(*  Goto No_Effects;*)
  D.WantLast:=False;
  D.IsAskJump:=False;
  For C:=0 To MaxChan-1 Do DoEnv(C);
  For C:=0 To D.NChan-1 Do Begin
    Cmd:=Chan[C].EffCmd;
    Param:=Chan[C].EffParam;
    T1:=Param SHR 4;

    Case Cmd Of
      $00:Arpeggio(C,Param);
      $01:PortUp(C,Param);
      $02:PortDown(C,Param);
      $03:PortNote(C,Param);
      $04:Vibrato(C,Param);
      $05:Begin
        PortNote(C,0);
        VolSlide(C,Param);
      End;
      $06:Begin
        Vibrato(C,0);
        VolSlide(C,Param);
      End;
      $07:Tremolo(C,Param);
      $08:Pan(C,Param);
      $09:Offset(C,Param);
      $0a:VolSlide(C,Param);
      $0b:Jump(C,Param);
      $0c:SetVolume(C,Param);
      $0d:Break(C,Param);
      $0e:Begin
        Case T1 Of
          $0:SetFilter(C,Param);
          $1:FinePortUp(C,Param);
          $2:FinePortDn(C,Param);
          $3:SetGliss(C,Param);
          $5:FineTune(C,Param);
          $6:PatLoop(C,Param);
          $7:SetTremolo(C,Param);
          $8:Pan16(C,Param);
          $9:Retrig(C,Param);
          $a:FineVolUp(C,Param);
          $b:FineVolDn(C,Param);
          $c:CutNote(C,Param);
          $d:DelayNote(C,Param);
          $e:DelayPat(C,Param);
        End;
      End;
      $0f:Speed(C,Param);
    End;
  End;
No_Effects:
End;

Procedure Do_Effects;
Var V:LongInt;
    C:Byte;
    FPan:Integer;
    NewLeft,NewRight:LongInt;
Var W1:LongWord;
    B1:Integer;
    Depl:Word;
{    F:File;}    
Begin
  For C:=0 To D.NChan-1 Do If Chan[C].Used Then Chan[C].Ptr:=Smpl[Chan[C].Sample].Pntr;
  Case MType Of
    1:Do_Effects_Mod;
    2:Do_Effects_S3m;
    3:Do_Effects_Xm;
  End;
  If D.WantLast Then D.Tick:=D.Speed-1;
  If Not Joue Then Exit;

  For C:=0 To D.NChan-1 Do Begin
    If Chan[C].Used Then Begin
      Chan[C].Ptr:=Smpl[Chan[C].Sample].Pntr;
      V:=Round((Chan[C].FadeOut/65536)*Chan[C].Volume*D.GVol*Chan[C].VolEnv);
      FPan:=(Chan[C].Pan+Chan[C].PanEnv*4)*2;
      FPan:=FPan*Sepa_Stereo Div 8;If FPan>256 Then FPan:=256;If FPan<-256 Then Fpan:=-256;
      Chan[C].V1:=V*(256-FPan) SHR 17;
      Chan[C].V2:=V*(256+FPan) SHR 17;
    End;
  End;
  If E.TickRemove Then Begin
    NewLeft:=0;
    NewRight:=0;
    If E.Interpolation=1 Then Begin
      For C:=0 To MaxChan-1 Do Begin
        With Chan[C] Do Begin
          If (Used) Then Begin
{            If (Ofs>=LoopF) Then Begin
              Used:=False;
              Assign(F,'c:\chan.bin');
              ReWrite(F);
              BlockWrite(F,Chan[C],SizeOf(TChan));
              Close(F);
            End Else Begin}
              W1:=Ofs SHR Fixed-Deca;
              Depl:=Ofs AND (MFixed-1);
              B1:=-32768+((Ptr[W1] SHL Fixed)+(Ptr[W1+1]-Ptr[W1])*Depl) SHR Fixed;
              Inc(NewLeft,V1*B1);
              Inc(NewRight,V2*B1);
{            End;}
          End;
        End;
      End;
    End Else Begin
      For C:=0 To MaxChan-1 Do Begin
        If Chan[C].Used Then Begin
          W1:=(Chan[C].Ofs SHR Fixed)-Deca;
          B1:=Chan[C].Ptr[W1]-32768;
          Inc(NewLeft,Chan[C].V1*B1);
          Inc(NewRight,Chan[C].V2*B1);
        End;
      End;
    End;
    Inc(NewLeft,D.BaseLeft);
    Inc(NewRight,D.BaseRight);
    Dec(D.BaseLeft,NewLeft-D.LastLeft);
    Dec(D.BaseRight,NewRight-D.LastRight);

    V:=(D.CurSend-D.PosSend) SHR 7;

    D.BaseSpeedLeft:=-D.BaseLeft Div V;
    D.BaseSpeedRight:=-D.BaseRight Div V;
  End;
End;


Procedure Do_Note;
Var V,W:Word;
Var C:Byte;
Var Mult:Single;

Var Cnd:Boolean;

Var Note,Octave:Byte;
Var Fine:ShortInt;
Label NextChan;
Var NewSmp:Boolean;
Var SlowStop:Boolean;
    Used:Boolean;

Begin
  For C:=0 To D.NChan-1 Do Begin
    V:=Pattern[D.Pattern,C]^.Period[D.Note];
    W:=Pattern[D.Pattern,C]^.Instru[D.Note];
    Used:=Chan[C].Used;
    SlowStop:=False;

    (*cut note : ignore ici*)
    If W=254 Then W:=0;
    If (MType=3) AND (V=97) Then Begin
      KeyOff(C,0);
      V:=0;
      W:=0;
    End;
    (*instrument prcis*)
    NewSmp:=False;
    If W<>0 Then Begin
      D.LastIns[C]:=W;
      (*diferent de l'actuel*)
      If W<>Chan[C].Instru Then Begin
        (*periode precisee*)
        NewSmp:=True;
        If V<>0 Then Begin
          SlowStop:=True;
          StopNote(C);
          Chan[C].Instru:=W;
          Init(C,2);

          Chan[C].Loop:=Smpl[Chan[C].Sample].Loop;
          Chan[C].LoopF:=(Deca+Smpl[Chan[C].Sample].LoopF) SHL Fixed;
          Chan[C].LoopD:=(Deca+Smpl[Chan[C].Sample].LoopD) SHL Fixed;
          Chan[C].Decr:=Chan[C].LoopF-Chan[C].LoopD;
          If Chan[C].Decr<2 SHL Fixed Then Chan[C].Loop:=0;
          Chan[C].Dir:=Chan[C].Loop;
          If (Chan[C].Decr=0) And (Chan[C].Loop=1) Then Chan[C].Used:=False;
        End;
      End;
    End;

    D.LastVolCmd[C]:=Chan[C].VolCmd;
    D.LastEffCmd[C]:=Chan[C].EffCmd;

    Chan[C].VolCmd:=Pattern[D.Pattern,C]^.VolCmd[D.Note];
    Chan[C].EffCmd:=Pattern[D.Pattern,C]^.EffCmd[D.Note];
    Chan[C].EffParam:=Pattern[D.Pattern,C]^.EffParam[D.Note];

    (*periode precisee*)
    If V<>0 Then Begin
      Chan[C].Instru:=D.LastIns[C];
      Chan[C].Volume:=D.GlobVol[C];

      (*ne pas mettre a jour si les effets sont...*)
      Cnd:=True;
      If MType=1 Then Cnd:=(Chan[C].EffCmd<>$3) AND (Chan[C].EffCmd<>$5);
      If MType=2 Then Cnd:=(Chan[C].EffCmd<>7) AND (Chan[C].EffCmd<>12);
      If MType=3 Then Cnd:=(Chan[C].EffCmd<>$3) AND (Chan[C].EffCmd<>$5) Or NewSmp;
      Cnd:=Cnd OR Not Used;
      If Cnd And Not SlowStop And (Chan[C].EffCmd<>Eff_Offset) Then StopNote(C);
      Init(C,1);
      If Cnd Then Begin
        (*periodes initiales*)
        Init(C,2);
        Case MType Of
          (*pour le mod : le finetune*)
          1:Begin
            Mult:=V*4;
            Chan[C].Sample:=Chan[C].Instru;
            If Smpl[Chan[C].Sample].Amiga<>0 Then
              Mult:=Mult*8363/Smpl[Chan[C].Sample].Amiga;
            Chan[C].Period:=Round(Mult);
            D.NTP[C]:=Chan[C].Period;
          End;
          2:Begin
            (*pour le s3m : l'octave/note*)
            Note:=V AND $f;
            Octave:=(V AND $ff) SHR 4;
            Mult:=0;
            Chan[C].Sample:=Chan[C].Instru;

            If Smpl[Chan[C].Sample].Amiga<>0 Then Begin
              Mult:=16*(Period[Note]/(1 Shl Octave));
              Mult:=Mult*8363/Smpl[Chan[C].Sample].Amiga;
            End;
            Chan[C].Period:=Round(Mult);
            D.NTP[C]:=Chan[C].Period;
          End;
          3:Begin
            Note:=V;
            Chan[C].Sample:=Instr[Chan[C].Instru].List[V-1];
            If NewSmp Then Chan[C].Pan:=Smpl[Chan[C].Sample].Pan;
            Inc(Note,Smpl[Chan[C].Sample].Rel);
            Fine:=Smpl[Chan[C].Sample].Fine;
            Case FreqTable Of
              0:Begin
                Mult:=PeriodTab[(Note MOD 12)*8 + Fine Div 16]*(1-Frac(Fine/16));
                Mult:=Mult+PeriodTab[(Note MOD 12)*8 + Fine Div 16]*(Frac(Fine/16));
                Mult:=16*Mult/(1 Shl (Note DIV 12));
                Chan[C].Period:=Round(Mult*2);
              End;
              1:Begin
                Dec(Note);
                Chan[C].Period:=Round(7680-Note*64-Fine/2);
              End;
            End;
            D.NTP[C]:=Chan[C].Period;
          End;
        End;

        CalcPer(C);
        D.GlobPer[C]:=Chan[C].Period;
        D.LastPer[C]:=Chan[C].Period;

        Chan[C].Loop:=Smpl[Chan[C].Sample].Loop;
        Chan[C].LoopF:=(Deca+Smpl[Chan[C].Sample].LoopF) SHL Fixed;
        Chan[C].LoopD:=(Deca+Smpl[Chan[C].Sample].LoopD) SHL Fixed;
        Chan[C].Decr:=Chan[C].LoopF-Chan[C].LoopD;
        If Chan[C].Decr<2 SHL Fixed Then Chan[C].Loop:=0;
        If (Chan[C].Decr=0) And (Chan[C].Loop=1) Then Chan[C].Used:=False;
        Chan[C].Dir:=Chan[C].Loop;
      End;
    End;

    If W<>0 Then Begin
      Chan[C].Volume:=Smpl[Chan[C].Sample].Volume;
      D.LastVol[C]:=Chan[C].Volume;
      D.GlobVol[C]:=Chan[C].Volume;
    End;

    If (Chan[C].LoopF=Deca SHL Fixed) Or Not Instr[Chan[C].Instru].Defined Then Chan[C].Used:=False;
    (*cut note : on agit enfin*)
    If Pattern[D.Pattern,C]^.Instru[D.Note]=254 Then Begin
      StopNote(C);
      Chan[C].Used:=False;
    End;
    NextChan:
  End;
End;


Procedure MakeError(N1,N2:LongWord;From:Byte;Txt:String);
Begin
  If IsErr Then Begin
    SoundDevice.Stop;
    Exit;
  End;
  IsErr:=True;
  Case From Of
    (*modunit*)
    0:Begin
      Case N1 Of
        1:MainProgErr(N1,N2,True,Txt,0);
        2:MainProgErr(N1,N2,True,Txt,0);
        3:MainProgErr(N1,N2,False,Txt,0);
      End;
    End;
    1:MainProgErr(N1,N2,True,Txt,1);
  End;
  IsErr:=False;
End;

Procedure ErrHandler(NErr1,NErr2:LongWord;Txt:String);
Begin
  MakeError(NErr1,NErr2,1,Txt);
End;

Procedure DoTick;
Var NoLoop:Boolean;
Label Re;
Begin
Re:
  Inc(D.CurSend,D.OpTicks);
  Inc(D.PosSend,D.TickOfs SHL 8);
  D.TickOfs:=0;
  Inc(D.Tick);

  If D.Tick=D.Speed Then Begin
    D.Tick:=0;
    If D.WaitPat>0 Then Dec(D.WaitPat);
    If D.WaitPat=0 Then Begin
      If D.IsWaitJump Then Begin
        NoLoop:=False;
        If (D.NextPos=D.Pos) And (D.NextNote>D.Note) Then NoLoop:=True;
        D.Note:=D.NextNote;
        D.Pos:=D.NextPos;
        VerifPos;
        If Not NoLoop Then CheckLoop;
        PosSpeed[D.Pos]:=D.Speed;
        PosTempo[D.Pos]:=D.Bpm;
        PUsed[D.Pos]:=True;
        D.Pattern:=PatPos[D.Pos];
        D.IsWaitJump:=False;
        D.PosSend:=0;
        D.CurSend:=D.OpTicks;
      End Else Begin
        Inc(D.Note);
        If D.Note-1=PRow[D.Pattern] Then Begin
          D.Note:=1;
          Inc(D.Pos);
          If D.Pos=D.Max Then D.Pos:=D.Restart;
          VerifPos;
          D.Pattern:=PatPos[D.Pos];
          CheckLoop;
          PosSpeed[D.Pos]:=D.Speed;
          PosTempo[D.Pos]:=D.Bpm;
          PUsed[D.Pos]:=True;
          D.PosSend:=0;
          D.CurSend:=D.OpTicks;
        End;
      End;
      Do_Note;
      If D.Note=0 Then Goto Re;
    End;
  End;
  Do_Effects;
End;

Procedure UpDateTick;
Begin
  If D.TickOfs>=(D.CurSend-D.PosSend) SHR 8 Then DoTick;
End;

{$i decode.pas}


Procedure Decode(Pntr:Pointer;Info:Pointer);
Var Time:LongWord;
Begin
  Time:=GetTickCount;
  DecodeBuffer(Pntr,Info);
  Inc(TotTimer,GetTickCount-Time);
End;

{$I Load.Pas}
(*{$I Extract.Pas}*)

Function DetectForm(Fle:String):Byte;
Var Buffer:Array[0..$2f] Of Byte;
Var F:LongWord;
    Id:String;
Var I:Integer;
    Bid:LongWord;
Begin
  F:=NFileOpen(Fle);
  NFileRead(F,@Buffer,$30,Bid);
  FileClose(F);
  DetectForm:=1;
  Id:='';
  For I:=$2c To $2f Do Id:=Id+Chr(Buffer[I]);
  If Id='SCRM' Then DetectForm:=2;
  Id:='';
  For I:=0 To 16 Do Id:=Id+Chr(Buffer[I]);
  If Id='Extended Module: ' Then DetectForm:=3;
End;

Procedure ZeroMod;
Var I:Word;
Var C:Byte;
Begin
  Info.LoopCount:=0;
  Info.NoGVolUpdate:=False;
  Info.ShouldStop:=False;
(*  SetLength(Smpl,0);*)
  I:=0;
  While I<D.NSmpl Do Begin
    If Smpl[I].Size>0 Then Begin
      Case Smpl[I].Loop Of
        0:Smpl[I].Pntr[Smpl[I].LoopF]:=Smpl[I].Pntr[Smpl[I].LoopF-1];
        1:Smpl[I].Pntr[Smpl[I].LoopF]:=Smpl[I].Pntr[Smpl[I].LoopD];
        2:Smpl[I].Pntr[Smpl[I].LoopF]:=Smpl[I].Pntr[Smpl[I].LoopF-1];
      End;
    End;
    Inc(I);
  End;


  D.Tick:=0;
  D.TickOfs:=1;
  D.Pos:=0;
  VerifPos;
  D.Pattern:=PatPos[D.Pos];
  D.Note:=1;
  D.OpTicks:=Round(MixSpeed/(D.Bpm*2/5*E.Speed)*256);
  D.PosSend:=0;
  D.CurSend:=D.OpTicks;
  D.WaitPat:=0;

  While (PatPos[D.Restart]>=254) Or (Pattern[D.Restart,0]=Nil) Do Begin
    Inc(D.Restart);
    If D.Restart=D.Max Then D.Restart:=0;
  End;


  For C:=0 To MaxChan-1 Do Begin
    D.PatternLoop[C]:=0;
    D.LoopPoint[C]:=1;
    Chan[C].Used:=False;
    Chan[C].Speed:=0;
    Chan[C].Period:=0;
    Chan[C].Sample:=0;
    Chan[C].Instru:=0;
    Chan[C].Volume:=0;
    Chan[C].EffCmd:=0;
    Chan[C].EffParam:=0;
    Chan[C].VolCmd:=0;

    Chan[C].Ofs:=Deca SHL Fixed;

    D.LastPer[C]:=0;
    D.LastIns[C]:=0;
    D.LastSmp[C]:=0;
    D.LastEffCmd[C]:=0;
    D.LastVol[C]:=0;
    D.LastInfo[C]:=0;
    D.LastPan[C]:=0;
    D.LastVolCmd[C]:=0;

    D.VibPos[C]:=0;
    D.VibNeg[C]:=0;
    D.LastVib[C]:=0;
    D.LastVibD[C]:=0;
    D.LastVibV[C]:=0;
    D.TremPos[C]:=0;
    D.TremNeg[C]:=0;
    D.LastTrem[C]:=0;
    D.LastTremD[C]:=0;
    D.LastTremV[C]:=0;
    D.LastVS[C]:=0;
    D.LastSU[C]:=0;
    D.LastSD[C]:=0;

    D.LastVS[C]:=0;
    D.LastSU[C]:=0;
    D.LastSD[C]:=0;
    D.LastArp[C]:=0;
    D.LastTre[C]:=0;
    D.LastRet[C]:=0;


    D.GlobPer[C]:=0;
    D.GlobSmp[C]:=0;
    D.GlobEff[C]:=0;
    D.GlobVol[C]:=0;
    D.VibType[C]:=0;
    D.TremType[C]:=0;
    D.Gliss[C]:=0;
    D.ShouldPort[C]:=0;
    D.LastPS[C]:=0;

    D.WasUsed[C]:=False;

  End;
(*  D.Speed:=6;
  D.Bpm:=164;*)


  D.BaseLeft:=0;
  D.BaseRight:=0;
  D.LastLeft:=0;
  D.LastRight:=0;
  D.BaseSpeedLeft:=0;
  D.BaseSpeedRight:=0;

  D.IsWaitJump:=False;

  TotTimer:=0;
  DebTimer:=GetTickCount;
  BaseTimer:=0;
End;

Function InitMod(Fle:String;ErrH:TErrH;Speed:Word;Vs,Vb:Boolean;DeviceType:Word;Device:LongInt;Auto:Boolean;Loop:Byte;FileN:String;Pre:Single;CBWin:HWnd):Boolean;
Var I,J:Word;
    Rep:Boolean;

Var OldD:TD;
    OldE:TE;
    OldI:TI;
Var OldChan:Array[0..MaxChan-1] Of TChan;
Var OldSmpl:Array Of TSmpl;
Var OldInstr:Array[0..255] Of TInstr;

Var Oct:LongWord;

Label Fin;
Begin
  Info.NLoop:=Loop;
  MainProgErr:=ErrH;
  InitMod:=False;
  If Not FileExists(Fle) Then Begin
    MakeError(1,1,0,'File not found');
    Exit;
  End;
  If Joue Then UnInitMod;
  For I:=0 To 255 Do Instr[I].Defined:=False;
  For I:=0 To 255 Do For J:=0 To MaxChan-1 Do Pattern[I,J]:=Nil;
(*  For I:=0 To 32767 Do Smpl[I].Pntr:=Nil;*)

  (*  P_MDeb:=MaxAvail;*)

  MixSpeed:=Speed;
  Stereo:=Vs;
  Out16B:=Vb;
  If Stereo Then
    If Out16B Then D.Mode:=4 Else D.Mode:=2
  Else
    If Out16B Then D.Mode:=3 Else D.Mode:=1;

  ReDel;
  ReSur;

  FreqTable:=0;
  D.Restart:=0;
  For I:=0 To 255 Do PRow[I]:=64;

  D.Speed:=6;
  D.Bpm:=125;
  D.GVol:=64;
  D.MVol:=64;

  MType:=DetectForm(Fle);
  Case MType Of
    1:Rep:=LoadMod(Fle);
    2:Rep:=LoadS3m(Fle);
    3:Rep:=LoadXm(Fle);
    Else Rep:=False;
  End;

  ModTitle:=Trim(ModTitle);

  If Not Rep Then Begin
    MakeError(1,2,0,'Error while loading : file may be corrupted');
    Goto Fin;
  End;
  ZeroMod;
  OldD:=D;
  OldE:=E;
  OldI:=Info;
  For I:=0 To MaxChan-1 Do OldChan[I]:=Chan[I];
  SetLength(OldSmpl,D.NSmpl);
  For I:=0 To D.NSmpl-1 Do OldSmpl[I]:=Smpl[I];
  For I:=0 To 255 Do OldInstr[I]:=Instr[I];
  For I:=0 To 255 Do PUsed[I]:=False;
  PUsed[D.Pos]:=True;
  PosSpeed[D.Pos]:=D.Speed;
  PosTempo[D.Pos]:=D.Bpm;

  Oct:=0;
  Do_Note;
  Do_Effects;
  Repeat
    D.TickOfs:=(D.CurSend-D.PosSend) SHR 8;
    Inc(Oct,D.TickOfs);
    DoTick;
  Until Info.LoopCount>0;
  Duree:=Round(Oct/MixSpeed);

  D:=OldD;
  E:=OldE;
  Info:=OldI;
  For I:=0 To MaxChan-1 Do Chan[I]:=OldChan[I];
  For I:=0 To D.NSmpl-1 Do Smpl[I]:=OldSmpl[I];
  SetLength(OldSmpl,0);
  For I:=0 To 255 Do Instr[I]:=OldInstr[I];
  For I:=0 To 255 Do PUsed[I]:=False;
  PUsed[D.Pos]:=True;


  If Auto Then Begin
    Case D.NChan Of
       1..4 :E.Ampli:=0;
       5..8 :E.Ampli:=1;
       9..16:E.Ampli:=2;
      17..32:E.Ampli:=3;
      33..64:E.Ampli:=4;
    End;
  End;

  Joue:=True;
  TotTimer:=0;
  DebTimer:=GetTickCount;
  InitMod:=True;

  Do_Note;
  Do_Effects;

  SoundDevice.DeviceType:=DeviceType;
  SoundDevice.DeviceIndex:=Device;
  SoundDevice.OutFrequency:=MixSpeed;
  SoundDevice.OutStereo:=Stereo;
  SoundDevice.Out16Bits:=Out16B;
  SoundDevice.DecodeHandler:=Decode;
  SoundDevice.ErrorHandler:=ErrHandler;
  SoundDevice.InfoStructureSize:=SizeOf(TInfoBuff);
  SoundDevice.OutFileName:=FileN;
  SoundDevice.PreBuffering:=Pre;


  If Not SoundDevice.Play Then Begin
    Joue:=False;
    InitMod:=False;
    UnInitMod;
    Exit;
  End;

  Fin:
End;

Procedure UnInitMod;
Var I,J:Word;
Begin
  If Joue Then Begin
    SoundDevice.Stop;
    Joue:=False;
(*    For I:=0 To 4095 Do Smpl[I].Pntr:=Nil;*)
    For I:=0 To 255 Do For J:=0 To MaxChan-1 Do If Pattern[I,J]<>Nil Then Dispose(Pattern[I,J]);
  End;
End;


Procedure DoMod;
Begin
  If Joue Then SoundDevice.Perform;
End;


Begin
  SoundDevice:=TSound.Create;
  Joue:=False;
  LastCpu:=0;
  IsErr:=False;
End.
