unit playlist;

interface

uses Windows, Dialogs, StdCtrls, Classes, Controls, Forms, ComCtrls,
  ExtCtrls;

type
  TForm4 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Button5: TButton;
    Button6: TButton;
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Button12: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure sel(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure preparelist;
function getn:integer;

var
  Form4: TForm4;

implementation

uses Global, adddir, rename, gui;

{$R *.DFM}

var willstop:boolean;

function getn:integer;
begin
  getn:=form4.combobox1.itemindex+1;
end;

procedure tonew;
var i:integer;
begin
  newplist.nblist:=plist.nblist;
  newplist.nlist:=plist.nlist;
  newplist.filename:=plist.filename;
  setlength(newplist.sublist,newplist.nblist+1);
  for i:=0 to newplist.nblist do begin
    newplist.sublist[i].name:=plist.sublist[i].name;
    newplist.sublist[i].current:=plist.sublist[i].current;
    newplist.sublist[i].list:=tstringlist.create;
    newplist.sublist[i].list:=plist.sublist[i].list;
  end;
end;

function tolist:boolean;
var i:integer;
begin
  tolist:=not willstop;
  plist.nblist:=newplist.nblist;
  plist.nlist:=newplist.nlist;
  plist.filename:=newplist.filename;
  setlength(plist.sublist,plist.nblist+1);
  for i:=0 to plist.nblist do begin
    plist.sublist[i].name:=newplist.sublist[i].name;
    plist.sublist[i].current:=newplist.sublist[i].current;
    plist.sublist[i].list:=tstringlist.create;
    plist.sublist[i].list:=newplist.sublist[i].list;
  end;
end;

procedure preparelist;
var i:word;
begin
  willstop:=false;
  tonew;
  form4.listbox1.items:=TStringList.Create;
  form4.listbox1.clear;
  if newplist.nblist>0 then form4.listbox1.items.addstrings(newplist.sublist[1].list);
  form4.combobox1.items:=TStringList.Create;
  form4.combobox1.clear;
  for i:=1 to newplist.nblist do form4.combobox1.items.add(newplist.sublist[i].name);
  form4.combobox1.itemindex:=0;
  if newplist.nblist=0 then begin
    form4.button11.enabled:=false;
    form4.button12.enabled:=false;
    form4.button1.enabled:=false;
    form4.button8.enabled:=false;
    form4.button2.enabled:=false;
    form4.button9.enabled:=false;
    form4.button7.enabled:=false;
  end else begin
    form4.button11.enabled:=true;
    form4.button12.enabled:=true;
    form4.button1.enabled:=true;
    form4.button8.enabled:=true;
    form4.button2.enabled:=true;
    form4.button9.enabled:=true;
    form4.button7.enabled:=true;
  end;
end;


procedure TForm4.Button4Click(Sender: TObject);
begin
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
  form4.hide;
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
end;

procedure TForm4.Button3Click(Sender: TObject);
begin
  if not tolist then stop;
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
  skin_sendmessage(msg_skin_redraw,0);
  form4.hide;
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
end;

procedure TForm4.Button1Click(Sender: TObject);
begin
  if opendialog1.execute then begin
    listbox1.items.addstrings(opendialog1.Files);
    newplist.sublist[getn].list.addstrings(opendialog1.Files);
  end;
end;

procedure TForm4.Button2Click(Sender: TObject);
var i:longint;
begin
  for i:=listbox1.items.count-1 downto 0 do begin
    if listbox1.selected[i] then begin
      listbox1.items.delete(i);
      newplist.sublist[getn].list.delete(i);
    end;
  End;
  willstop:=true;
end;

procedure TForm4.Button5Click(Sender: TObject);
begin
  savedialog1.filename:=newplist.filename;
  if form4.savedialog1.execute then begin
    newplist.filename:=form4.savedialog1.Filename;
    saveplaylist(newplist,newplist.filename);
  end;
end;

procedure TForm4.Button6Click(Sender: TObject);
var i:integer;
begin
  opendialog2.filename:=newplist.filename;
  if opendialog2.execute then begin
    newplist.filename:=opendialog2.filename;
    loadplaylist(newplist.filename,newplist);

    listbox1.items:=TStringList.Create;
    listbox1.clear;
    if newplist.nblist>0 then listbox1.items.addstrings(newplist.sublist[1].list);
    combobox1.items:=TStringList.Create;
    combobox1.clear;
    for i:=1 to newplist.nblist do form4.combobox1.items.add(newplist.sublist[i].name);
    combobox1.itemindex:=0;
    willstop:=true;

    if newplist.nblist=0 then begin
      form4.button11.enabled:=false;
      form4.button12.enabled:=false;
      form4.button1.enabled:=false;
      form4.button8.enabled:=false;
      form4.button2.enabled:=false;
      form4.button9.enabled:=false;
      form4.button7.enabled:=false;
    end else begin
      form4.button11.enabled:=true;
      form4.button12.enabled:=true;
      form4.button1.enabled:=true;
      form4.button8.enabled:=true;
      form4.button2.enabled:=true;
      form4.button9.enabled:=true;
      form4.button7.enabled:=true;
    end;
  end;
end;

procedure TForm4.Button7Click(Sender: TObject);
var i:word;
    t:string;
    j,n:integer;
    nb:integer;
begin
  willstop:=true;
  n:=form4.listbox1.items.count;
  nb:=getn;
  for i:=0 to n-1 do begin
    j:=random(n);
    t:=form4.listbox1.items.strings[i];
    listbox1.items.strings[i]:=listbox1.items.strings[j];
    listbox1.items.strings[j]:=t;

    newplist.sublist[nb].list.strings[i]:=newplist.sublist[nb].list.strings[j];
    newplist.sublist[nb].list.strings[j]:=t;
  end;
end;

procedure TForm4.sel(Sender: TObject);
begin
  if listbox1.itemindex<>-1 then begin
    if not tolist then stop;
    playcurrent;
    skin_sendmessage(msg_skin_leavemenu,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
    skin_sendmessage(msg_skin_redraw,0);
    form4.hide;
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
  end;
end;


procedure TForm4.Button8Click(Sender: TObject);
begin
  form7.show;
  form4.enabled:=false;
end;

procedure TForm4.Button9Click(Sender: TObject);
begin
  listbox1.clear;
  newplist.sublist[getn].list.clear;
  willstop:=true;
end;

procedure TForm4.ComboBox1Change(Sender: TObject);
begin
  listbox1.items:=TStringList.Create;
  listbox1.items.addstrings(newplist.sublist[getn].list);
end;

procedure TForm4.Button10Click(Sender: TObject);
var nl:integer;
begin
  inc(newplist.nblist);
  nl:=newplist.nblist;
  setlength(newplist.sublist,nl+1);

  newplist.sublist[nl].list:=TStringList.Create;
  newplist.sublist[nl].list.clear;
  newplist.sublist[nl].current:=0;
  newplist.sublist[nl].name:=getrename('',form4);
  combobox1.itemindex:=combobox1.items.add(newplist.sublist[nl].name);
  form4.combobox1change(form4);

  if newplist.nblist>0 then begin
    form4.button11.enabled:=true;
    form4.button12.enabled:=true;
    form4.button1.enabled:=true;
    form4.button8.enabled:=true;
    form4.button2.enabled:=true;
    form4.button9.enabled:=true;
    form4.button7.enabled:=true;
  end;

end;

procedure TForm4.Button12Click(Sender: TObject);
var t:string;
    s:word;
begin
  t:=newplist.sublist[getn].name;
  t:=getrename(t,form4);
  newplist.sublist[getn].name:=t;
  s:=combobox1.itemindex;
  combobox1.Items.Strings[s]:=t;
  combobox1.Refresh;
  combobox1.itemindex:=s;
end;

procedure TForm4.Button11Click(Sender: TObject);
var i:word;
    n:word;
begin
  n:=getn;
  for i:=n to newplist.nblist-1 do
    newplist.sublist[i]:=newplist.sublist[i+1];
  dec(newplist.nblist);
  setlength(newplist.sublist,newplist.nblist+1);

  combobox1.items.Delete(combobox1.itemindex);
  combobox1.Refresh;
  combobox1.itemindex:=0;
  willstop:=true;
  form4.combobox1change(form4);

  if newplist.nblist=0 then begin
    form4.button11.enabled:=false;
    form4.button12.enabled:=false;
    form4.button1.enabled:=false;
    form4.button8.enabled:=false;
    form4.button2.enabled:=false;
    form4.button9.enabled:=false;
    form4.button7.enabled:=false;
  end;

end;

end.
