library pmpskin;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  Forms, ExtCtrls, StdCtrls,
  Classes, Menus, Buttons, skin,windows,messages,sysutils,controls;

type tstatus=record
  PattPos:Byte;
  VisLoaded:Boolean;
  View:Byte;
  AOTop:Boolean;
end;
var status:tstatus;

  oldmsg:pointer;

type tmyform=record
  form:tform;
  image1:timage;
  image2:timage;
  bevel1:tbevel;
  bevel2:tbevel;
  scrollbar1:tscrollbar;
  scrollbar2:tscrollbar;
  scrollbar3:tscrollbar;
  label2:tlabel;
  label3:tlabel;
  edit1:tedit;
  find:tbutton;
  button3:tbutton;
  button7:tbutton;
  button8:tbutton;
  bitbtn1:tbitbtn;
  bitbtn2:tbitbtn;
  bitbtn3:tbitbtn;
  bitbtn4:tbitbtn;
  bitbtn5:tbitbtn;
  bitbtn6:tbitbtn;
  bitbtn7:tbitbtn;
  bitbtn8:tbitbtn;
  speedbutton1:tspeedbutton;
  speedbutton2:tspeedbutton;
  speedbutton3:tspeedbutton;
  speedbutton4:tspeedbutton;
  speedbutton5:tspeedbutton;
  speedbutton6:tspeedbutton;
  bitbtn9:tbitbtn;
  bitbtn10:tbitbtn;
  timer1:ttimer;
  popupmenu1:tpopupmenu;
  setup1:tmenuitem;
  quit1:tmenuitem;
  Quitbutdontsaveplaylist1:tmenuitem;
  aotop1:tmenuitem;
  traymenu1:tpopupmenu;
  restore1:tmenuitem;
  separate1:tmenuitem;
  separate2:tmenuitem;
  setup2:tmenuitem;
  quit2:tmenuitem;
  Quitbutdontsaveplaylist2:tmenuitem;
end;


var myform:tmyform;

type tmsg=record
  global:boolean;
  lastmsg:string;
  globmsg:string;
  count:word;
end;
var smsg:tmsg;

var inenvir:boolean;
    inmsg:boolean;

var dir:string;
Var InfoStr:String;

Const Version=1 SHL 16+62;

type
  TNid=record
    cbSize:LongWord;
    hWnd:Hwnd;
    uID:LongWord;
    uFlags:LongWord;
    uCallbackMessage:LongWord;
    Icon:HIcon;
    Tip:Array[1..64] Of Char;
  end;
  PNid=^TNid;

const Nim_Add=0;
      Nim_Delete=2;
      Nim_Modify=1;
      Nif_Icon=2;
      Nif_Message=1;
      Nif_Tip=4;

var Nid:TNid;

function Shell_NotifyIcon(Id:LongWord;Nid:PNid):boolean;stdcall
external 'shell32.dll' name 'Shell_NotifyIconA';

procedure affiche;
var t,t1,t2:string;
begin
  if boolean(gui.getinfo(get_gui_status_isplaying)) then myform.scrollbar2.position:=gui.getinfo(2) div 10;
  str(pmod.getmod(25) div 60:2,t);str(pmod.getmod(25) mod 60:2,t1);
  if t1[1]=' ' then t1[1]:='0';t:=t+':'+t1;
  t2:=t;

  str(pmod.getmod(26) div 60:2,t);str(pmod.getmod(26) mod 60:2,t1);
  if t1[1]=' ' then t1[1]:='0';t:=t+':'+t1;
  myform.label2.caption:=t+'  '+t2;
end;

procedure showpatt(t:byte);
begin
  case t of
    0:begin
      myform.bevel2.visible:=false;
      myform.image2.visible:=false;
      myform.scrollbar1.visible:=false;
    end;
    1:begin
      vis.uninitpatt;
      myform.image2.width:=6*16*3+12;
      myform.bevel2.width:=6*16*3+12+2;
      myform.image2.height:=80;
      myform.bevel2.height:=82;
      myform.bevel2.visible:=true;
      myform.image2.visible:=true;
      myform.scrollbar1.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scrollbar1.top:=myform.image2.top+myform.image2.height+2;
      myform.scrollbar1.width:=myform.image2.width;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        myform.scrollbar1.enabled:=true;
        myform.scrollbar1.min:=0;
        myform.scrollbar1.max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
      end else begin;
        myform.scrollbar1.enabled:=false;
      end;
    end;
    2:begin
      vis.uninitpatt;
      myform.image2.width:=9*16*3+12;
      myform.bevel2.width:=9*16*3+12+2;
      myform.image2.height:=80;
      myform.bevel2.height:=82;
      myform.bevel2.visible:=true;
      myform.image2.visible:=true;
      myform.scrollbar1.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scrollbar1.top:=myform.image2.top+myform.image2.height+2;
      myform.scrollbar1.width:=myform.image2.width;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        myform.scrollbar1.enabled:=true;
        myform.scrollbar1.min:=0;
        myform.scrollbar1.max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
      end else begin;
        myform.scrollbar1.enabled:=false;
      end;
    end;
    3:begin
      vis.uninitpatt;
      myform.image2.width:=9*16*3+12;
      myform.bevel2.width:=9*16*3+12+2;
      myform.image2.height:=150;
      myform.bevel2.height:=152;
      myform.bevel2.visible:=true;
      myform.image2.visible:=true;
      myform.scrollbar1.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scrollbar1.top:=myform.image2.top+myform.image2.height+2;
      myform.scrollbar1.width:=myform.image2.width;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        myform.scrollbar1.enabled:=true;
        myform.scrollbar1.min:=0;
        myform.scrollbar1.max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
      end else begin;
        myform.scrollbar1.enabled:=false;
      end;
    end;
  end;
end;

procedure showdc(t:byte);
begin
  case t of
    0:begin
      myform.bevel1.visible:=false;
      myform.image1.visible:=false;
      myform.label3.visible:=false;
    end;
    1:begin
      vis.uninitdc;
      myform.label3.visible:=true;
      myform.bevel1.visible:=true;
      myform.image1.visible:=true;
      myform.image1.width:=128;
      myform.bevel1.width:=130;
      myform.image1.height:=80;
      myform.bevel1.height:=82;
      myform.image1.left:=324;
      myform.bevel1.left:=myform.image1.left-1;
      myform.image1.top:=73;
      myform.bevel1.top:=72;
      vis.initdc(myform.image1.canvas.handle,128,80);
    end;
    2:begin
      vis.uninitdc;
      myform.label3.visible:=false;
      myform.bevel1.visible:=true;
      myform.image1.visible:=true;
      myform.image1.width:=320;
      myform.bevel1.width:=322;
      myform.image1.height:=100;
      myform.bevel1.height:=102;
      myform.image1.left:=(myform.form.width-myform.image1.width) div 2;
      myform.bevel1.left:=myform.image1.left-1;
      myform.image1.top:=78;
      myform.bevel1.top:=77;
      vis.initdc(myform.image1.canvas.handle,320,100);
    end;
    3:begin
      vis.uninitdc;
      myform.label3.visible:=false;
      myform.bevel1.visible:=true;
      myform.image1.visible:=true;
      myform.image1.width:=320;
      myform.bevel1.width:=322;
      myform.image1.height:=200;
      myform.bevel1.height:=202;
      myform.image1.left:=(myform.form.width-myform.image1.width) div 2;
      myform.bevel1.left:=myform.image1.left-1;
      myform.image1.top:=78;
      myform.bevel1.top:=77;
      vis.initdc(myform.image1.canvas.handle,320,200);
    end;
  end;
end;

procedure resizevis;
begin
  if (status.view=0) or not status.visloaded then begin
    myform.form.height:=99;
    showpatt(0);
    showdc(0);
  end;
  if status.visloaded then begin
    case status.view of
      1:begin
        myform.form.height:=266;
        showpatt(3);
        showdc(0);
      end;
      2:begin
        myform.form.height:=196;
        showpatt(2);
        showdc(0);
      end;
      3:begin
        myform.form.height:=196;
        showpatt(1);
        showdc(1);
      end;
      4:begin
        myform.form.height:=209;
        showpatt(0);
        showdc(2);
      end;
      5:begin
        myform.form.height:=309;
        showpatt(0);
        showdc(3);
      end;
    end;
  end;
end;

procedure SkRedraw;
begin
  if inenvir then exit;
  inenvir:=true;
  myform.edit1.text:=gui.getinfos(get_gui_currentfilename);

  if myform.edit1.text<>'' then begin
    myform.bitbtn1.enabled:=true;
    myform.bitbtn4.enabled:=true;
    myform.bitbtn5.enabled:=true;
    myform.bitbtn7.enabled:=true;
    myform.bitbtn8.enabled:=true;
  end else begin
    myform.bitbtn1.enabled:=false;
    myform.bitbtn4.enabled:=false;
    myform.bitbtn5.enabled:=false;
    myform.bitbtn7.enabled:=false;
    myform.bitbtn8.enabled:=false;
  end;


  myform.scrollbar1.position:=0;
  status.pattpos:=0;
  myform.scrollbar1.enabled:=true;
  if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
    myform.scrollbar1.enabled:=true;
    myform.scrollbar1.min:=0;
    myform.scrollbar1.max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
  end else begin;
    myform.scrollbar1.enabled:=false;
  end;
  myform.scrollbar3.position:=gui.getinfo(get_gui_setup_volume);


  if boolean(gui.getinfo(get_gui_setup_surround)) then myform.SpeedButton2.caption:='S' else myform.SpeedButton2.caption:='';
  if boolean(gui.getinfo(get_gui_setup_reverb)) then myform.SpeedButton3.caption:='R' else myform.SpeedButton3.caption:='';
  if boolean(gui.getinfo(get_gui_setup_autoampli)) then myform.SpeedButton6.caption:='A' else myform.SpeedButton6.caption:='';
  case gui.getinfo(get_gui_setup_sepastereo) of
    0:myform.SpeedButton4.caption:='x1/8';
    1:myform.SpeedButton4.caption:='x1/4';
    2:myform.SpeedButton4.caption:='x1/2';
    3:myform.SpeedButton4.caption:='x1';
    4:myform.SpeedButton4.caption:='x2';
    5:myform.SpeedButton4.caption:='x4';
    6:myform.SpeedButton4.caption:='x8';
  end;
  case gui.getinfo(get_gui_setup_ampli) of
    0:myform.SpeedButton5.caption:='x1';
    1:myform.SpeedButton5.caption:='x2';
    2:myform.SpeedButton5.caption:='x4';
    3:myform.SpeedButton5.caption:='x8';
    4:myform.SpeedButton5.caption:='x16';
    5:myform.SpeedButton5.caption:='x32';
  end;
  myform.scrollbar1.enabled:=boolean(gui.getinfo(get_gui_status_isplaying));
  myform.scrollbar3.position:=gui.getinfo(get_gui_setup_volume);

  case gui.getinfo(get_gui_setup_nmodloop) of
    0:myform.speedbutton1.caption:='1';
    1:myform.speedbutton1.caption:='2';
    2:myform.speedbutton1.caption:='3';
    3:myform.speedbutton1.caption:='4';
    4:myform.speedbutton1.caption:='5';
    255:myform.speedbutton1.caption:='Inf';
  end;
  inenvir:=false;
end;

function SkSendMessage(msg:longint;param:longint):longint;stdcall;
begin
  sksendmessage:=0;
  case msg of
    msg_skin_anim:begin
      inenvir:=true;
      vis.dodc(myform.image1.canvas.handle,boolean(gui.getinfo(get_gui_status_isplaying)));
      vis.dopatt(myform.image2.canvas.handle,status.pattpos,boolean(gui.getinfo(get_gui_status_isplaying)));
      myform.image1.refresh;
      myform.image2.refresh;
      affiche;
      inenvir:=false;
    end;
    msg_skin_redraw:begin
      skredraw;
    end;
    msg_skin_play:begin
      inenvir:=true;
      vis.newplay;
      myform.scrollbar2.position:=0;
      myform.bitbtn2.enabled:=true;
      myform.bitbtn3.enabled:=true;
      myform.scrollbar2.enabled:=true;
      if pmod.getmods(1)<>'' then myform.form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion)+' : '+pmod.getmods(1) else myform.form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion);
      StrPCopy(@Nid.Tip,MyForm.Form.Caption);
      Shell_NotifyIcon(Nim_Modify,@Nid);

      inenvir:=false;
    end;
    msg_skin_stop:begin
      inenvir:=true;
      myform.scrollbar1.enabled:=false;
      myform.scrollbar2.enabled:=false;
      myform.BitBtn2.enabled:=false;
      myform.BitBtn3.enabled:=false;
      vis.cleanpatt(myform.image2.canvas.handle);
      vis.cleandc(myform.image1.canvas.handle);
      myform.image1.refresh;
      myform.image2.refresh;
      inenvir:=false;
    end;
    msg_skin_initgraphs:begin
      status.visloaded:=vis.initgraphs(myform.image1.canvas.handle,myform.image2.canvas.handle,myform.image1.width,myform.image1.height,myform.image2.width,myform.image2.height);
      resizevis;
    end;
    msg_skin_endgraphs:begin
      vis.endgraphs;
    end;
    msg_skin_setwindow:begin
      case param of
        msg_skin_setwindow_enable:begin
          if myform.form.visible then begin
            myform.form.enabled:=true;
          end;
        end;
        msg_skin_setwindow_disable:begin
          if myform.form.visible then begin
            myform.form.enabled:=false;
          end;
        end;
        msg_skin_setwindow_bringtotop:begin
          if not myform.form.enabled then if myform.form.visible then myform.form.enabled:=true;
          myform.form.show;myform.form.enabled:=true;
          bringwindowtotop(myform.form.handle);
          myform.form.setfocus;
        end;
      end;
    end;
  end;
end;


procedure SkEnd;stdcall;
begin
  Shell_NotifyIcon(Nim_Delete,@Nid);
  with myform do begin
    form.hide;
(*    image1.free;
    image2.free;
    bevel1.free;
    bevel2.free;
    scrollbar1.free;
    scrollbar2.free;
    scrollbar3.free;
    label2.free;
    label3.free;
    edit1.free;
    find.free;
    button3.free;
    button7.free;
    button8.free;
    bitbtn1.free;
    bitbtn2.free;
    bitbtn3.free;
    bitbtn4.free;
    bitbtn5.free;
    bitbtn6.free;
    bitbtn7.free;
    bitbtn8.free;
    bitbtn9.free;
    bitbtn10.free;
    speedbutton1.free;
    speedbutton2.free;
    speedbutton3.free;
    speedbutton4.free;
    speedbutton5.free;
    speedbutton6.free;
    timer1.free;
    setup1.free;
    quit1.free;
    Quitbutdontsaveplaylist1.free;
    aotop1.free;
    restore1.free;
    separate1.free;
    separate2.free;
    setup2.free;
    quit2.free;
    Quitbutdontsaveplaylist2.free;

    popupmenu1.free;
    traymenu1.free;*)
    form.release;
  end;
end;

function SkGetInfo(param:longword):longint;stdcall;
begin
  skgetinfo:=0;
  case param of
    Get_Skin_PMPVersion:skgetinfo:=version;
  end;
end;

procedure SkMsg(txt:shortstring;glob:boolean);stdcall;
begin
  if inmsg then exit;
  inmsg:=true;
  if txt<>'' then begin
    if glob then begin
      smsg.globmsg:=txt;
      if smsg.global then myform.label3.caption:=txt;
    end else begin
      smsg.global:=false;
      smsg.count:=0;
      if txt<>smsg.lastmsg then begin
        smsg.lastmsg:=txt;
        myform.label3.caption:=txt;
      end;
    end;
  end else begin
    smsg.global:=true;
    smsg.count:=0;
    smsg.lastmsg:='';
    myform.label3.caption:='';
  end;
  smsg.lastmsg:=txt;
  inmsg:=false;
end;

procedure fin(Sender: TObject; var CanClose: Boolean);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,1);
end;

procedure ScrollBar1Change(Sender:TObject);
begin
  status.pattpos:=MyForm.ScrollBar1.position;
end;

procedure ScrollBar2Change(Sender:TObject);
begin
  if inenvir then exit;
  gui.sendmessage(msg_gui_goto,myform.scrollbar2.position*10);
end;

procedure ScrollBar3Change(Sender:TObject);
begin
  if inenvir then exit;
  inenvir:=true;
  if (myform.scrollbar3.position>112) and (myform.scrollbar3.position<144) then begin
    myform.scrollbar3.position:=128;
    gui.sendmessage(msg_gui_volume,128);
  end else begin
    gui.sendmessage(msg_gui_volume,myform.scrollbar3.position);
  end;
  inenvir:=false;
end;

procedure BitBtn9Click(Sender:TObject);
Begin
  if status.view>0 then dec(status.view) else status.view:=5;
  resizevis;
End;

procedure BitBtn10Click(Sender:TObject);
Begin
  if status.view<5 then inc(status.view) else status.view:=0;;
  resizevis;
End;


procedure FindClick(Sender:TObject);
begin
  gui.sendmessage(msg_gui_open,0);
end;

procedure Button3Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_setup,0);
end;

procedure Button7Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_info,0);
end;

procedure Button8Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_playlist,0);
end;

procedure SpeedButton1Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_repeat,-1);
end;

procedure SpeedButton2Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_surround,-1);
end;

procedure SpeedButton3Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_reverb,-1);
end;

procedure SpeedButton4Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_stereo,-1);
end;

procedure SpeedButton5Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_ampli,-1);
end;

procedure SpeedButton6Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_aampli,-1);
end;

procedure BitBtn1Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_play,0);
end;

procedure BitBtn2Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_pause,0);
end;

procedure BitBtn3Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
end;

procedure BitBtn4Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_prev,0);
end;

procedure BitBtn5Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_next,0);
end;

procedure BitBtn6Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_select,0);
end;

procedure BitBtn7Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_moveto,0);
end;

procedure BitBtn8Click(Sender:TObject);
begin
  gui.sendmessage(msg_gui_remove,0);
end;

var Timer1Timer:TNotifyEvent;

procedure Timer1OnTimer(Sender:TObject);
begin
  inc(smsg.count);
  if smsg.count>=30 then begin
    smsg.count:=0;
    myform.label3.caption:=smsg.globmsg;
    smsg.global:=true;
    smsg.lastmsg:='';
  end;
end;

procedure Quitbutdontsaveplaylist1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,0);
end;

procedure Quit1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,1);
end;

procedure Setup1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_setup,0);
end;
procedure msg(win:hwnd;msg:word;wparam,lparam:longword);stdcall;forward

procedure bring;
begin
  showwindow(myform.form.handle,sw_shownormal);
  SetForegroundWindow(myform.form.handle);
  myform.restore1.enabled:=false;
  myform.form.visible:=true;
end;

procedure Restore1Click(Sender: TObject);
begin
  bring;
end;

procedure AOTop1Click(Sender:TObject);
Begin
  myform.aotop1.checked:=not myform.aotop1.checked;
  if myform.aotop1.checked then begin
    setwindowpos(myform.form.handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  end else begin
    setwindowpos(myform.form.handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  end;
End;


procedure msg(win:hwnd;msg:word;wparam,lparam:longword);stdcall
begin
  case msg of
    wm_size:begin
      if wparam=1 then begin
        showwindow(myform.form.handle,sw_hide);
        myform.form.visible:=false;
        myform.restore1.enabled:=true;
      end else begin
        bring;
      end;
    end;
    wm_user:begin
      case lparam of
        wm_LBUTTONDBLCLK:bring;
        wm_RBUTTONDOWN:begin
          if myform.form.visible then bring;
          myform.TrayMenu1.popup(mouse.cursorpos.x,mouse.cursorpos.y);
        end;
      end;
    end;
    else begin
      callwindowproc(oldmsg,win,msg,wparam,lparam);
    end;
  end;
end;

procedure create_my_window;
begin
  With MyForm Do Begin
    Form:=TForm.Create(Nil);

    Form.Position:=podesktopcenter;
    Form.Width:=468;
    Form.Height:=99;
    Form.Scaled:=False;

    Form.Icon.LoadFromfile(dir+'img\pmps.ico');

    Form.borderStyle:=bsSingle;
    Form.BorderIcons:=[biSystemMenu,biMinimize];
    Form.Caption:='Plouf''s ModPlayer';
    @Form.OnCloseQuery:=@Fin;

    oldmsg:=pointer(setwindowlong(form.handle,GWL_WNDPROC,longword(@msg)));

    Image1:=TImage.Create(Form);
    Image1.Parent:=Form;

    Bevel1:=TBevel.Create(Form);
    Bevel1.Parent:=Form;

    Image2:=TImage.Create(Form);
    Image2.Parent:=Form;
    Image2.Left:=9;
    Image2.Top:=73;
    Bevel2:=TBevel.Create(Form);
    Bevel2.Parent:=Form;
    Bevel2.Left:=8;
    Bevel2.Top:=72;

    ScrollBar1:=TScrollBar.Create(Form);
    ScrollBar1.Parent:=Form;
    ScrollBar1.Left:=9;
    ScrollBar1.Height:=12;
    @ScrollBar1.OnChange:=@ScrollBar1Change;

    ScrollBar2:=TScrollBar.Create(Form);
    ScrollBar2.Parent:=Form;
    ScrollBar2.Left:=9;
    ScrollBar2.Height:=12;
    ScrollBar2.Top:=57;
    ScrollBar2.Width:=190;
    ScrollBar2.Min:=0;
    ScrollBar2.Max:=99;
    ScrollBar2.LargeChange:=10;
    ScrollBar2.ShowHint:=True;
    ScrollBar2.Hint:='Current song position';
    @ScrollBar2.OnChange:=@ScrollBar2Change;


    ScrollBar3:=TScrollBar.Create(Form);
    ScrollBar3.Parent:=Form;
    ScrollBar3.Left:=208;
    ScrollBar3.Height:=12;
    ScrollBar3.Top:=57;
    ScrollBar3.Width:=113;
    ScrollBar3.Min:=0;
    ScrollBar3.Max:=256;
    ScrollBar3.LargeChange:=16;
    ScrollBar3.ShowHint:=True;
    ScrollBar3.Hint:='Volume control';
    @ScrollBar3.OnChange:=@ScrollBar3Change;

    Label2:=TLabel.Create(Form);
    Label2.Autosize:=False;
    Label2.Parent:=Form;
    Label2.Left:=330;
    Label2.Top:=56;
    Label2.alignment:=tacenter;
    Label2.Width:=92;
    Label2.Height:=15;
    Label2.ShowHint:=True;
    Label2.Hint:='Elapsed time';

    Label3:=TLabel.Create(Form);
    Label3.Parent:=Form;
    Label3.AutoSize:=False;
    Label3.Left:=323;
    Label3.Width:=130;
    Label3.Top:=155;
    Label3.Height:=15;

    Edit1:=TEdit.Create(Form);
    Edit1.Parent:=Form;
    Edit1.Height:=21;
    Edit1.Left:=8;
    Edit1.ReadOnly:=True;
    Edit1.Top:=8;
    Edit1.Width:=192;

    Find:=TButton.Create(Form);
    Find.Parent:=Form;
    Find.Caption:='Open';
    Find.Left:=208;
    Find.Height:=23;
    Find.Top:=8;
    Find.Width:=57;
    Find.ShowHint:=True;
    Find.Hint:='Open files';
    @Find.OnClick:=@FindClick;

    Button3:=TButton.Create(Form);
    Button3.Parent:=Form;
    Button3.Caption:='Setup';
    Button3.Left:=208;
    Button3.Height:=23;
    Button3.Top:=31;
    Button3.Width:=57;
    Button3.ShowHint:=True;
    Button3.Hint:='Setup the player';
    @Button3.OnClick:=@Button3Click;

    Button7:=TButton.Create(Form);
    Button7.Parent:=Form;
    Button7.Caption:='Info';
    Button7.Left:=265;
    Button7.Height:=23;
    Button7.Top:=8;
    Button7.Width:=57;
    Button7.ShowHint:=True;
    Button7.Hint:='Infos on current song';
    @Button7.OnClick:=@Button7Click;

    Button8:=TButton.Create(Form);
    Button8.Parent:=Form;
    Button8.Caption:='PlayList';
    Button8.Left:=265;
    Button8.Height:=23;
    Button8.Top:=31;
    Button8.Width:=57;
    Button8.ShowHint:=True;
    Button8.Hint:='Playlists management';
    @Button8.OnClick:=@Button8Click;

    SpeedButton1:=TSpeedButton.Create(Form);
    SpeedButton1.Parent:=Form;
    SpeedButton1.Left:=330;
    SpeedButton1.Top:=8;
    SpeedButton1.Width:=23;
    SpeedButton1.Height:=23;
    SpeedButton1.ShowHint:=True;
    SpeedButton1.Hint:='Song repeat';
    @SpeedButton1.OnClick:=@SpeedButton1Click;

    SpeedButton2:=TSpeedButton.Create(Form);
    SpeedButton2.Parent:=Form;
    SpeedButton2.Left:=353;
    SpeedButton2.Top:=8;
    SpeedButton2.Width:=23;
    SpeedButton2.Height:=23;
    SpeedButton2.ShowHint:=True;
    SpeedButton2.Hint:='Toggle surround On/Off';
    @SpeedButton2.OnClick:=@SpeedButton2Click;

    SpeedButton3:=TSpeedButton.Create(Form);
    SpeedButton3.Parent:=Form;
    SpeedButton3.Left:=376;
    SpeedButton3.Top:=8;
    SpeedButton3.Width:=23;
    SpeedButton3.Height:=23;
    SpeedButton3.ShowHint:=True;
    SpeedButton3.Hint:='Toggle reverb On/Off';
    @SpeedButton3.OnClick:=@SpeedButton3Click;

    SpeedButton4:=TSpeedButton.Create(Form);
    SpeedButton4.Parent:=Form;
    SpeedButton4.Left:=330;
    SpeedButton4.Top:=31;
    SpeedButton4.Width:=23*2;
    SpeedButton4.Height:=23;
    SpeedButton4.ShowHint:=True;
    SpeedButton4.Hint:='Stereo separation';
    @SpeedButton4.OnClick:=@SpeedButton4Click;

    SpeedButton5:=TSpeedButton.Create(Form);
    SpeedButton5.Parent:=Form;
    SpeedButton5.Left:=376;
    SpeedButton5.Top:=31;
    SpeedButton5.Width:=23*2;
    SpeedButton5.Height:=23;
    SpeedButton5.ShowHint:=True;
    SpeedButton5.Hint:='Amplification factor';
    @SpeedButton5.OnClick:=@SpeedButton5Click;

    SpeedButton6:=TSpeedButton.Create(Form);
    SpeedButton6.Parent:=Form;
    SpeedButton6.Left:=399;
    SpeedButton6.Top:=8;
    SpeedButton6.Width:=23;
    SpeedButton6.Height:=23;
    SpeedButton6.ShowHint:=True;
    SpeedButton6.Hint:='Toggle auto amplification On/Off';
    @SpeedButton6.OnClick:=@SpeedButton6Click;

    BitBtn1:=TBitBtn.Create(Form);
    BitBtn1.Parent:=Form;
    BitBtn1.Caption:='';
    BitBtn1.Left:=8;
    BitBtn1.Top:=30;
    BitBtn1.Height:=24;
    BitBtn1.Width:=24;
    BitBtn1.Margin:=5;
    BitBtn1.NumGlyphs:=2;
    BitBtn1.Glyph.LoadFromFile(dir+'img\play.bmp');
    BitBtn1.ShowHint:=True;
    BitBtn1.Hint:='Play the current song';
    @BitBtn1.OnClick:=@BitBtn1Click;

    BitBtn2:=TBitBtn.Create(Form);
    BitBtn2.Parent:=Form;
    BitBtn2.Caption:='';
    BitBtn2.Left:=32;
    BitBtn2.Top:=30;
    BitBtn2.Height:=24;
    BitBtn2.Width:=24;
    BitBtn2.Margin:=5;
    BitBtn2.NumGlyphs:=2;
    BitBtn2.Glyph.LoadFromFile(dir+'img\pause.bmp');
    BitBtn2.ShowHint:=True;
    BitBtn2.Hint:='Pause song';
    @BitBtn2.OnClick:=@BitBtn2Click;

    BitBtn3:=TBitBtn.Create(Form);
    BitBtn3.Parent:=Form;
    BitBtn3.Caption:='';
    BitBtn3.Left:=56;
    BitBtn3.Top:=30;
    BitBtn3.Height:=24;
    BitBtn3.Width:=24;
    BitBtn3.Margin:=5;
    BitBtn3.NumGlyphs:=2;
    BitBtn3.Glyph.LoadFromFile(dir+'img\stop.bmp');
    BitBtn3.ShowHint:=True;
    BitBtn3.Hint:='Stop song';
    @BitBtn3.OnClick:=@BitBtn3Click;

    BitBtn4:=TBitBtn.Create(Form);
    BitBtn4.Parent:=Form;
    BitBtn4.Caption:='';
    BitBtn4.Left:=80;
    BitBtn4.Top:=30;
    BitBtn4.Height:=24;
    BitBtn4.Width:=24;
    BitBtn4.Margin:=5;
    BitBtn4.NumGlyphs:=2;
    BitBtn4.Glyph.LoadFromFile(dir+'img\prev.bmp');
    BitBtn4.ShowHint:=True;
    BitBtn4.Hint:='Previous song';
    @BitBtn4.OnClick:=@BitBtn4Click;

    BitBtn5:=TBitBtn.Create(Form);
    BitBtn5.Parent:=Form;
    BitBtn5.Caption:='';
    BitBtn5.Left:=104;
    BitBtn5.Top:=30;
    BitBtn5.Height:=24;
    BitBtn5.Width:=24;
    BitBtn5.Margin:=5;
    BitBtn5.NumGlyphs:=2;
    BitBtn5.Glyph.LoadFromFile(dir+'img\next.bmp');
    BitBtn5.ShowHint:=True;
    BitBtn5.Hint:='Next song';
    @BitBtn5.OnClick:=@BitBtn5Click;

    BitBtn6:=TBitBtn.Create(Form);
    BitBtn6.Parent:=Form;
    BitBtn6.Caption:='';
    BitBtn6.Left:=128;
    BitBtn6.Top:=30;
    BitBtn6.Height:=24;
    BitBtn6.Width:=24;
    BitBtn6.Margin:=5;
    BitBtn6.NumGlyphs:=1;
    BitBtn6.Glyph.LoadFromFile(dir+'img\select.bmp');
    BitBtn6.ShowHint:=True;
    BitBtn6.Hint:='Select song';
    @BitBtn6.OnClick:=@BitBtn6Click;

    BitBtn7:=TBitBtn.Create(Form);
    BitBtn7.Parent:=Form;
    BitBtn7.Caption:='';
    BitBtn7.Left:=152;
    BitBtn7.Top:=30;
    BitBtn7.Height:=24;
    BitBtn7.Width:=24;
    BitBtn7.Margin:=5;
    BitBtn7.NumGlyphs:=2;
    BitBtn7.Glyph.LoadFromFile(dir+'img\moveto.bmp');
    BitBtn7.ShowHint:=True;
    BitBtn7.Hint:='Move to another playlist';
    @BitBtn7.OnClick:=@BitBtn7Click;

    BitBtn8:=TBitBtn.Create(Form);
    BitBtn8.Parent:=Form;
    BitBtn8.Caption:='';
    BitBtn8.Left:=176;
    BitBtn8.Top:=30;
    BitBtn8.Height:=24;
    BitBtn8.Width:=24;
    BitBtn8.Margin:=5;
    BitBtn8.NumGlyphs:=2;
    BitBtn8.Glyph.LoadFromFile(dir+'img\remove.bmp');
    BitBtn8.ShowHint:=True;
    BitBtn8.Hint:='Remove from playlist';
    @BitBtn8.OnClick:=@BitBtn8Click;

    BitBtn9:=TBitBtn.Create(Form);
    BitBtn9.Parent:=Form;
    BitBtn9.Caption:='<';
    BitBtn9.Left:=430;
    BitBtn9.Top:=8;
    BitBtn9.Height:=23;
    BitBtn9.Width:=23;
    BitBtn9.ShowHint:=True;
    BitBtn9.Hint:='Previous viewmode';
    @BitBtn9.OnClick:=@BitBtn9Click;

    BitBtn10:=TBitBtn.Create(Form);
    BitBtn10.Parent:=Form;
    BitBtn10.Caption:='>';
    BitBtn10.Left:=BitBtn9.Left;
    BitBtn10.Top:=BitBtn9.Top+23;
    BitBtn10.Height:=BitBtn9.Height;
    BitBtn10.Width:=BitBtn9.Width;
    BitBtn10.ShowHint:=True;
    BitBtn10.Hint:='Next viewmode';
    @BitBtn10.OnClick:=@BitBtn10Click;


    Timer1:=TTimer.Create(Form);
    Timer1.Interval:=10;
    @Timer1Timer:=@Timer1OnTimer;
    Timer1.OnTimer:=Timer1Timer;

    PopupMenu1:=TPopupMenu.Create(Form);
    PopupMenu1.Autopopup:=true;

    aotop1:=tmenuitem.create(popupmenu1);
    aotop1.caption:='&Always on top';
    @aotop1.OnClick:=@aotop1click;
    PopupMenu1.Items.Add(aotop1);

    Separate2:=TMenuItem.Create(PopupMenu1);
    Separate2.Caption:='-';
    PopupMenu1.Items.Add(separate2);

    setup1:=TMenuItem.Create(PopupMenu1);
    setup1.Caption:='&Setup...';
    @setup1.OnClick:=@Setup1Click;
    PopupMenu1.Items.Add(setup1);

    quit1:=TMenuItem.Create(PopupMenu1);
    quit1.Caption:='&Quit : save';
    @quit1.OnClick:=@Quit1Click;
    PopupMenu1.Items.Add(quit1);

    Quitbutdontsaveplaylist1:=TMenuItem.Create(PopupMenu1);
    Quitbutdontsaveplaylist1.Caption:='Q&uit : don''t save';
    @Quitbutdontsaveplaylist1.OnClick:=@Quitbutdontsaveplaylist1Click;
    PopupMenu1.Items.Add(Quitbutdontsaveplaylist1);

    Separate1:=TMenuItem.Create(PopupMenu1);
    Separate1.Caption:='-';

    Restore1:=TMenuItem.Create(PopupMenu1);
    Restore1.Caption:='Restore';
    Restore1.default:=true;
    restore1.enabled:=false;
    @Restore1.OnClick:=@Restore1Click;

    setup2:=TMenuItem.Create(PopupMenu1);
    setup2.Caption:='&Setup...';
    @setup2.OnClick:=@Setup1Click;

    quit2:=TMenuItem.Create(PopupMenu1);
    quit2.Caption:='&Quit : save';
    @quit2.OnClick:=@Quit1Click;

    Quitbutdontsaveplaylist2:=TMenuItem.Create(PopupMenu1);
    Quitbutdontsaveplaylist2.Caption:='Q&uit : don''t save';
    @Quitbutdontsaveplaylist2.OnClick:=@Quitbutdontsaveplaylist1Click;


    TrayMenu1:=TPopupMenu.Create(Form);
    TrayMenu1.Autopopup:=false;
    TrayMenu1.Items.Add(Restore1);
    TrayMenu1.Items.Add(Separate1);
    TrayMenu1.Items.Add(Setup2);
    TrayMenu1.Items.Add(Quit2);
    TrayMenu1.Items.Add(Quitbutdontsaveplaylist2);

    Form.PopupMenu:=PopupMenu1;

  End;

end;



procedure SkInit(loadproc:tloadproc);stdcall;
begin
  loadallstuff(loadproc);
  dir:=gui.getinfos(get_gui_skindirectory);

  status.visloaded:=false;
  status.aotop:=false;

  create_my_window;

  Nid.cbSize:=SizeOf(TNid);
  Nid.hWnd:=MyForm.Form.Handle;
  GetWindowThreadProcessId(Application.Handle,@Nid.uId);

  Nid.uFlags:=Nif_Icon OR Nif_Message OR Nif_Tip;
  Nid.uCallbackMessage:=WM_USER;
  Nid.Icon:=MyForm.Form.Icon.Handle;
  StrPCopy(@Nid.Tip,MyForm.Form.Caption);
  Shell_NotifyIcon(Nim_Add,@Nid);


  inenvir:=false;
  inmsg:=false;

  myform.bitbtn1.enabled:=false;
  myform.bitbtn2.enabled:=false;
  myform.bitbtn3.enabled:=false;
  myform.bitbtn4.enabled:=false;
  myform.bitbtn5.enabled:=false;
  myform.bitbtn7.enabled:=false;
  myform.bitbtn8.enabled:=false;


  myform.image2.width:=9*16*3+12;
  myform.image2.height:=150;
  myform.image1.width:=320;
  myform.image1.height:=200;


  smsg.global:=false;
  smsg.lastmsg:='';
  smsg.count:=0;
  smsg.globmsg:='';
  status.view:=3;
  skredraw;

  myform.form.Show;
end;

function GetInfoStr:pstring;stdcall;
begin
  getinfostr:=@infostr;
end;


exports
  SkSendMessage index 1,
  SkMsg index 2,
  SkInit index 3,
  SkEnd index 4,
  SkGetInfo index 5,
  GetInfoStr index 6;

begin
  infostr:='Default pmp skin';
end.
