unit select;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm5 = class(TForm)
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure sel(Sender: TObject);
    procedure mdu(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure close(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox2Click(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form5: TForm5;
  procedure prepareselect;


implementation
uses global, gui, search;

var searchstring:string;
    casesens:boolean;

{$R *.DFM}

procedure prepareselect;
var i:integer;
begin
  form5.listbox1.items:=TStringList.Create;
  form5.listbox1.clear;
  form5.listbox1.items:=plist.sublist[plist.nlist].list;
  form5.listbox1.itemindex:=plist.sublist[plist.nlist].current;
  form5.combobox1.items:=TStringList.Create;
  form5.combobox1.clear;
  for i:=0 to plist.nblist do form5.combobox1.items.add(plist.sublist[i].name);
  form5.combobox1.itemindex:=plist.nlist;
end;

procedure gosearch;
var i:integer;
    tempstring:string;
label trouve;
begin
  if casesens then tempstring:=searchstring else tempstring:=lowercase(searchstring);
  with form5.listbox1 do begin
    if itemindex<>items.count-1 then begin
      if casesens then begin
        for i:=itemindex+1 to Items.count-1 do begin
          if ansipos(tempstring,items.strings[i])<>0 then begin
            itemindex:=i;
            goto trouve;
          end;
        end;
      end else begin
        for i:=itemindex+1 to Items.count-1 do begin
          if ansipos(tempstring,lowercase(items.strings[i]))<>0 then begin
            itemindex:=i;
            goto trouve;
          end;
        end;
      end;
    end;

    if casesens then begin
      for i:=0 to itemindex do begin
        if ansipos(tempstring,items.strings[i])<>0 then begin
          itemindex:=i;
          goto trouve;
        end;
      end;
    end else begin
      for i:=0 to itemindex do begin
        if ansipos(tempstring,lowercase(items.strings[i]))<>0 then begin
          itemindex:=i;
          goto trouve;
        end;
      end;
    end;
  end;
  application.MessageBox('Text entered not found','Select',mb_ok);
trouve:
end;

procedure TForm5.sel(Sender: TObject);
var list:word;
begin
  if listbox1.itemindex<>-1 then begin
    list:=combobox1.itemindex;
    plist.sublist[list].current:=form5.listbox1.itemindex;
    if plist.sublist[list].current>=plist.sublist[list].list.count then plist.sublist[list].current:=0;
    plist.nlist:=list;
    playcurrent;
  end;
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
  form5.hide;
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
end;

procedure TForm5.mdu(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button=mbright then begin
    skin_sendmessage(msg_skin_leavemenu,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
    form5.hide;
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
  end;
end;

procedure TForm5.close(Sender: TObject; var Action: TCloseAction);
begin
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
  form5.hide;
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
(*  skin_getwindowhandle.enabled:=true;
  skin_getwindowhandle.setfocus;*)
end;

procedure TForm5.ListBox1KeyPress(Sender: TObject; var Key: Char);
var list:word;
begin
  case ord(key) of
    13:begin
      if listbox1.itemindex<>-1 then begin
        list:=combobox1.itemindex;
        plist.sublist[list].current:=form5.listbox1.itemindex;
        if plist.sublist[list].current>=plist.sublist[list].list.count then plist.sublist[list].current:=0;
        plist.nlist:=list;
        playcurrent;
      end;
      skin_sendmessage(msg_skin_leavemenu,0);
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
      form5.hide;
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);

(*      skin_getwindowhandle.enabled:=true;
      skin_getwindowhandle.setfocus;*)
    end;
    27:begin
      skin_sendmessage(msg_skin_leavemenu,0);
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
      form5.hide;
      skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
(*      skin_getwindowhandle.enabled:=true;
      skin_getwindowhandle.setfocus;*)
    end;
  end;
end;


procedure TForm5.ListBox2Click(Sender: TObject);
var i:word;
begin
  i:=combobox1.itemindex;
  listbox1.items:=plist.sublist[i].list;
  listbox1.itemindex:=plist.sublist[i].current;
end;

procedure TForm5.ComboBox1Click(Sender: TObject);
var i:word;
begin
  i:=combobox1.itemindex;
  listbox1.items:=plist.sublist[i].list;
  listbox1.itemindex:=plist.sublist[i].current;
end;

procedure TForm5.Button2Click(Sender: TObject);
begin
  if searchstring='' then begin
    if peeksearch(searchstring,casesens) then gosearch;
  end else begin
    gosearch;
  end;    
end;

procedure TForm5.Button1Click(Sender: TObject);
begin
  if peeksearch(searchstring,casesens) then gosearch;
end;

begin
  searchstring:='';
  casesens:=false;
end.
