unit billyunit;
interface
uses unit3d;

{dfinition de billy}

  const init=0;
        bassin=1;
        jambe1g=2;
        jambe2g=3;
        piedg=4;
        jambe1d=5;
        jambe2d=6;
        piedd=7;
        torse=8;
        bras1g=9;
        bras2g=10;
        bras1d=11;
        bras2d=12;
        tete=13;


  type atspoint=array of tspoint;

  tmembre=record
    obj:t3dobj;
    pntattache:longint;
    objattache:word;
    p3d:atspoint;
  end;

  tbilly=record
    membre:array[0..13] of tmembre;
  end;

  type tcolor=record
    peau,short,blouse,shoes,cheveux:longword;
  end;

{dfinition des scripts}
type
  PEntry=^TEntry;
  TEntry=Record
    Prev:PEntry;
    Next:PEntry;
    Angle:TAngle;
    Pos:LongInt;
  End;
  TList=Record
    FirstEntry:TEntry;
    LastEntry:TEntry;
    Count:LongWord;
    Current:PEntry;
    Init:Boolean;
  End;

  tscript=record
    length:longint;
    tempo:longint;
    order:array[0..13] of tlist;
  end;

procedure initbilly(var billy:tbilly;var world:tworld;cols:tcolor;render:trender);
procedure showbilly(billy:tbilly;world:tworld;where:tbmp);
function getangle(var script:tscript;pos:longint;membre:integer):tangle;
function isfixed(var script:tscript;pos:longint;membre:integer):boolean;
procedure delangle(var script:tscript;pos:longint;membre:integer);
procedure setangle(var script:tscript;pos:longint;membre:integer;angle:tangle);
Function NewEntry(Var NList:TList;Base:PEntry):PEntry;
Procedure DelEntry(Var DList:TList;DEntry:PEntry);
Procedure NewList(Var NList:TList);
Procedure FreeList(Var FList:TList);
procedure nlist(var script:tscript);
procedure load(fle:string;var script:tscript);
procedure save(fle:string;var script:tscript);
procedure setbilly(var billy:tbilly;var script:tscript;pos:longint);
procedure setviewangle(var billy:tbilly;angle:tangle);overload;
procedure setviewangle(var billy:tbilly;a1,a2,a3:integer);overload;


implementation
var color:tcolor;
    debug:longword;

{Cette fonction cre un nouvel lment au dpart
 de Base, et retourne son pointeur}
Function NewEntry(Var NList:TList;Base:PEntry):PEntry;
Var NEntry:PEntry;
Begin
  With Nlist Do Begin
    New(NEntry);
    Base^.Next^.Prev:=NEntry;
    NEntry^.Next:=Base^.Next;
    Base^.Next:=NEntry;
    NEntry^.Prev:=Base;
    NewEntry:=NEntry;
    Inc(Count);
  End;
End;

{Cette procdure dtruit l'lment point par DEntry}
Procedure DelEntry(Var DList:TList;DEntry:PEntry);
Var PrevEntry,NextEntry:PEntry;
Begin
  With DList Do Begin
    PrevEntry:=DEntry^.Prev;
    NextEntry:=DEntry^.Next;
    Dispose(DEntry);
    PrevEntry^.Next:=NextEntry;
    NextEntry^.Prev:=PrevEntry;
    Dec(Count);
  End;
End;

Procedure NewList(Var NList:TList);
Begin
  NList.FirstEntry.Prev:=Nil;
  NList.FirstEntry.Next:=@NList.LastEntry;
  NList.LastEntry.Prev:=@NList.FirstEntry;
  NList.LastEntry.Next:=Nil;
  NList.Count:=0;
  NList.Init:=True;
  NList.Current:=@NList.FirstEntry;
End;

Procedure FreeList(Var FList:TList);
Begin
  While FList.Count>0 Do DelEntry(FList,FList.FirstEntry.Next);
End;

function getangle(var script:tscript;pos:longint;membre:integer):tangle;
var el:pentry;
    cpos,dpos:longint;

label re;
begin
  debug:=pos;
  if debug=999 then begin
    debug:=0;
  end;
  script.order[membre].lastentry.pos:=script.length-1;
  el:=@script.order[membre].firstentry;
  repeat
    el:=el^.next;
  until (el^.pos>pos) or (el=@script.order[membre].lastentry);
re:
  el:=el^.prev;
  dpos:=el^.next^.pos-el^.pos;
  if (dpos=0) and (el<>@script.order[membre].firstentry) then goto re;
  if dpos<>0 then begin
    cpos:=pos-el^.pos;
    getangle.a1:=(el^.next.Angle.a1*cpos+el^.angle.a1*(dpos-cpos)) div dpos;
    getangle.a2:=(el^.next.Angle.a2*cpos+el^.angle.a2*(dpos-cpos)) div dpos;
    getangle.a3:=(el^.next.Angle.a3*cpos+el^.angle.a3*(dpos-cpos)) div dpos;
  end else begin
    getangle.a1:=0;
    getangle.a2:=0;
    getangle.a3:=0;
  end;
end;

function isfixed(var script:tscript;pos:longint;membre:integer):boolean;
var el:pentry;
begin
  isfixed:=false;
  script.order[membre].lastentry.pos:=script.length-1;
  el:=@script.order[membre].firstentry;
  repeat
    if el^.pos=pos then isfixed:=true;
    el:=el^.next;
  until el=@script.order[membre].lastentry;
end;

procedure delangle(var script:tscript;pos:longint;membre:integer);
var el:pentry;
begin
  if not isfixed(script,pos,membre) then exit;
  script.order[membre].lastentry.pos:=script.length-1;
  el:=@script.order[membre].firstentry;
  repeat
    el:=el^.next;
  until el^.pos=pos;
  delentry(script.order[membre],el);
end;

procedure setangle(var script:tscript;pos:longint;membre:integer;angle:tangle);
var el:pentry;
begin
  script.order[membre].lastentry.pos:=script.length-1;
  el:=@script.order[membre].firstentry;
  repeat
    el:=el^.next;
  until (el^.pos>pos) or (el=@script.order[membre].lastentry);
  el:=el^.prev;
  if el^.pos=pos then begin
    el^.angle:=angle;
  end else begin
    el:=newentry(script.order[membre],el);
    el^.angle:=angle;
    el^.pos:=pos;
  end;
end;

procedure nlist(var script:tscript);
var i:integer;
    angle:tangle;
begin
  script.length:=1000;
  script.tempo:=500;
  for i:=0 to 13 do begin
    if script.order[i].init then freelist(script.order[i]);
    newlist(script.order[i]);
    script.order[i].lastentry.angle.a1:=0;
    script.order[i].lastentry.angle.a2:=0;
    script.order[i].lastentry.angle.a3:=0;
  end;
  script.order[0].lastentry.angle.a1:=0;
  script.order[0].lastentry.angle.a2:=0;
  script.order[0].lastentry.angle.a3:=1000;
  for i:=1 to 13 do begin
    angle.a1:=0;
    angle.a2:=0;
    angle.a3:=0;
    setangle(script,0,i,angle);
  end;
  angle.a3:=1000;
  setangle(script,0,0,angle);
end;

procedure save(fle:string;var script:tscript);
var t:string;
    f:file;
    i:integer;
    el:pentry;
    j:longword;
begin
  assignfile(f,fle);
  rewrite(f,1);
  t:='BillyScript';
  blockwrite(f,t[1],11);
  blockwrite(f,script.tempo,sizeof(script.tempo));
  blockwrite(f,script.length,sizeof(script.length));
  for i:=0 to 13 do begin
    blockwrite(f,script.order[i].count,sizeof(script.order[i].count));
    el:=@script.order[i].firstentry;
    for j:=0 to script.order[i].count do begin
      blockwrite(f,el^.Pos,sizeof(el^.pos));
      blockwrite(f,el^.Angle,sizeof(el^.angle));
      el:=el^.next;
    end;
  end;
  closefile(f);
end;

procedure load(fle:string;var script:tscript);
var t:string;
    f:file;
    i:integer;
    pos:integer;
    angle:tangle;
    count,j:longword;
begin
  nlist(script);
  assignfile(f,fle);
  reset(f,1);
  t:='01234567891';
  blockread(f,t[1],11);
  if t<>'BillyScript' then begin
    closefile(f);
    exit;
  end;
  blockread(f,script.tempo,sizeof(script.tempo));
  blockread(f,script.length,sizeof(script.length));
  for i:=0 to 13 do begin
    blockread(f,count,sizeof(count));
    for j:=0 to count do begin
      blockread(f,pos,sizeof(pos));
      blockread(f,angle,sizeof(angle));
      setangle(script,pos,i,angle);
    end;
  end;
  closefile(f);
end;

procedure setbilly(var billy:tbilly;var script:tscript;pos:longint);
var k:integer;
begin
  billy.membre[0].obj.coo.x:=getangle(script,pos,0).a1;
  billy.membre[0].obj.coo.y:=getangle(script,pos,0).a2;
  billy.membre[0].obj.coo.z:=getangle(script,pos,0).a3;
  for k:=1 to 13 do billy.membre[k].obj.angle:=getangle(script,pos,k);
end;

procedure createbox(var box:t3dobj;p1,p2:tpoint;render:trender;psupp:longint;color:longword);
var i:integer;
    x1,x2,y1,y2,z1,z2,cx,cy,cz:longint;
    l:single;
begin
  with box do begin
    nsurface:=6;
    npoint:=8;
    inc(npoint,nsurface+psupp);
    setlength(surface,nsurface);
    setlength(point,npoint);
    point[0].coo.x:=p1.coo.x;point[0].coo.y:=p1.coo.y;point[0].coo.z:=p1.coo.z;
    point[1].coo.x:=p2.coo.x;point[1].coo.y:=p1.coo.y;point[1].coo.z:=p1.coo.z;
    point[2].coo.x:=p2.coo.x;point[2].coo.y:=p2.coo.y;point[2].coo.z:=p1.coo.z;
    point[3].coo.x:=p1.coo.x;point[3].coo.y:=p2.coo.y;point[3].coo.z:=p1.coo.z;
    point[4].coo.x:=p1.coo.x;point[4].coo.y:=p1.coo.y;point[4].coo.z:=p2.coo.z;
    point[5].coo.x:=p2.coo.x;point[5].coo.y:=p1.coo.y;point[5].coo.z:=p2.coo.z;
    point[6].coo.x:=p2.coo.x;point[6].coo.y:=p2.coo.y;point[6].coo.z:=p2.coo.z;
    point[7].coo.x:=p1.coo.x;point[7].coo.y:=p2.coo.y;point[7].coo.z:=p2.coo.z;

    surface[0].npoint:=4;setlength(surface[0].point,surface[0].npoint);
    surface[1].npoint:=4;setlength(surface[1].point,surface[1].npoint);
    surface[2].npoint:=4;setlength(surface[2].point,surface[2].npoint);
    surface[3].npoint:=4;setlength(surface[3].point,surface[3].npoint);
    surface[4].npoint:=4;setlength(surface[4].point,surface[4].npoint);
    surface[5].npoint:=4;setlength(surface[5].point,surface[5].npoint);
    surface[0].normpoint:=8;
    surface[1].normpoint:=9;
    surface[2].normpoint:=10;
    surface[3].normpoint:=11;
    surface[4].normpoint:=12;
    surface[5].normpoint:=13;

    {z}
    surface[0].point[0]:=3;surface[0].point[1]:=2;surface[0].point[2]:=1;surface[0].point[3]:=0;
    surface[1].point[0]:=4;surface[1].point[1]:=5;surface[1].point[2]:=6;surface[1].point[3]:=7;

    {y}
    surface[2].point[0]:=0;surface[2].point[1]:=1;surface[2].point[2]:=5;surface[2].point[3]:=4;
    surface[3].point[0]:=2;surface[3].point[1]:=3;surface[3].point[2]:=7;surface[3].point[3]:=6;

    {x}
    surface[4].point[0]:=1;surface[4].point[1]:=2;surface[4].point[2]:=6;surface[4].point[3]:=5;
    surface[5].point[0]:=4;surface[5].point[1]:=7;surface[5].point[2]:=3;surface[5].point[3]:=0;

    for i:=0 to nsurface-1 do begin
      surface[i].visible:=true;
      surface[i].color:=color;
      surface[i].dir:=1;
      surface[i].render:=render;
    end;

    for i:=0 to nsurface-1 do begin
      x1:=point[surface[i].point[0]].coo.x-point[surface[i].point[1]].coo.x;
      y1:=point[surface[i].point[0]].coo.y-point[surface[i].point[1]].coo.y;
      z1:=point[surface[i].point[0]].coo.z-point[surface[i].point[1]].coo.z;
      x2:=point[surface[i].point[2]].coo.x-point[surface[i].point[1]].coo.x;
      y2:=point[surface[i].point[2]].coo.y-point[surface[i].point[1]].coo.y;
      z2:=point[surface[i].point[2]].coo.z-point[surface[i].point[1]].coo.z;
      cx:=y1*z2-y2*z1;
      cy:=z1*x2-z2*x1;
      cz:=x1*y2-x2*y1;
      l:=sqrt(sqr(cx)+sqr(cy)+sqr(cz))*surface[i].dir;
      point[surface[i].normpoint].coo.x:=round(cx/l*64);
      point[surface[i].normpoint].coo.y:=round(cy/l*64);
      point[surface[i].normpoint].coo.z:=round(cz/l*64);
    end;
    angle.a1:=0;
    angle.a2:=0;
    angle.a3:=0;
  end;
end;

procedure setviewangle(var billy:tbilly;angle:tangle);overload;
begin
  angle.a1:=angle.a1 mod 3600;
  angle.a2:=angle.a2 mod 3600;
  angle.a3:=angle.a3 mod 3600;
  billy.membre[init].obj.angle:=angle;
end;

procedure setviewangle(var billy:tbilly;a1,a2,a3:integer);overload;
begin
  a1:=a1 mod 3600;
  a2:=a2 mod 3600;
  a3:=a3 mod 3600;
  billy.membre[init].obj.angle.a1:=a1;
  billy.membre[init].obj.angle.a2:=a2;
  billy.membre[init].obj.angle.a3:=a3;
end;

procedure initbilly(var billy:tbilly;var world:tworld;cols:tcolor;render:trender);
var p1,p2:tpoint;
    l:single;
    i:word;
begin
  color:=cols;
  with billy.membre[init] do begin
    obj.nsurface:=0;
    obj.npoint:=1;
    setlength(obj.surface,obj.nsurface);
    setlength(obj.point,obj.npoint);
    obj.point[0].coo.x:=0;obj.point[0].coo.y:=0;obj.point[0].coo.z:=0;
    obj.coo.x:=0;obj.coo.y:=0;obj.coo.z:=1000;
    obj.angle.a1:=0;obj.angle.a2:=0;obj.angle.a3:=0;
  end;

  with billy.membre[bassin] do begin
    p1.coo.x:=-10;p1.coo.y:=-25;p1.coo.z:=-15;
    p2.coo.x:=+10;p2.coo.y:=+25;p2.coo.z:=15;
    objattache:=init;
    pntattache:=0;
    createbox(obj,p1,p2,render,3,color.short);
    obj.point[obj.npoint-3].coo.x:=0;
    obj.point[obj.npoint-3].coo.y:=-0;
    obj.point[obj.npoint-3].coo.z:=-15;
    obj.point[obj.npoint-2].coo.x:=0;
    obj.point[obj.npoint-2].coo.y:=-15;
    obj.point[obj.npoint-2].coo.z:=15;
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=15;
    obj.point[obj.npoint-1].coo.z:=15;
  end;


  with billy.membre[jambe1g] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+10;p2.coo.y:=+10;p2.coo.z:=50;
    objattache:=bassin;
    pntattache:=billy.membre[objattache].obj.npoint-2;
    createbox(obj,p1,p2,render,1,color.short);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;
  end;

  with billy.membre[jambe2g] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+10;p2.coo.y:=+10;p2.coo.z:=50;
    objattache:=jambe1g;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,1,color.peau);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;
  end;

  with billy.membre[piedg] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+40;p2.coo.y:=+10;p2.coo.z:=20;
    objattache:=jambe2g;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,0,color.shoes);
  end;

  with billy.membre[jambe1d] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+10;p2.coo.y:=+10;p2.coo.z:=50;
    objattache:=bassin;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,1,color.short);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;
  end;

  with billy.membre[jambe2d] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+10;p2.coo.y:=+10;p2.coo.z:=50;
    objattache:=jambe1d;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,1,color.peau);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;
  end;

  with billy.membre[piedd] do begin
    p1.coo.x:=-10;p1.coo.y:=-10;p1.coo.z:=10;
    p2.coo.x:=+40;p2.coo.y:=+10;p2.coo.z:=20;
    objattache:=jambe2d;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,0,color.shoes);
  end;

  with billy.membre[torse] do begin
    p1.coo.x:=-10;p2.coo.y:=-25;p2.coo.z:=-80;
    p2.coo.x:=+10;p1.coo.y:=+25;p1.coo.z:=-10;
    objattache:=bassin;
    pntattache:=billy.membre[objattache].obj.npoint-3;
    createbox(obj,p1,p2,render,3,color.blouse);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=-80;
    obj.point[obj.npoint-2].coo.x:=0;
    obj.point[obj.npoint-2].coo.y:=-25;
    obj.point[obj.npoint-2].coo.z:=-65;
    obj.point[obj.npoint-3].coo.x:=0;
    obj.point[obj.npoint-3].coo.y:=25;
    obj.point[obj.npoint-3].coo.z:=-65;
  end;

  with billy.membre[tete] do begin
    p1.coo.x:=-10;p2.coo.y:=-15;p2.coo.z:=-40;
    p2.coo.x:=+10;p1.coo.y:=+15;p1.coo.z:=-10;
    objattache:=torse;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,0,color.cheveux);
    obj.surface[0].color:=color.peau;
    obj.surface[4].color:=color.peau;
  end;


  with billy.membre[bras1g] do begin
    p1.coo.x:=-10;p2.coo.y:=-20;p2.coo.z:=10;
    p2.coo.x:=+10;p1.coo.y:=0;p1.coo.z:=50;
    objattache:=torse;
    pntattache:=billy.membre[objattache].obj.npoint-2;
    createbox(obj,p1,p2,render,1,color.blouse);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;

  end;

  with billy.membre[bras2g] do begin
    p1.coo.x:=-10;p2.coo.y:=-20;p2.coo.z:=10;
    p2.coo.x:=+10;p1.coo.y:=0;p1.coo.z:=50;
    objattache:=bras1g;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,0,color.peau);
  end;

  with billy.membre[bras1d] do begin
    p1.coo.x:=-10;p2.coo.y:=0;p2.coo.z:=10;
    p2.coo.x:=+10;p1.coo.y:=20;p1.coo.z:=50;
    objattache:=torse;
    pntattache:=billy.membre[objattache].obj.npoint-3;
    createbox(obj,p1,p2,render,1,color.blouse);
    obj.point[obj.npoint-1].coo.x:=0;
    obj.point[obj.npoint-1].coo.y:=0;
    obj.point[obj.npoint-1].coo.z:=50;

  end;

  with billy.membre[bras2d] do begin
    p1.coo.x:=-10;p2.coo.y:=0;p2.coo.z:=10;
    p2.coo.x:=+10;p1.coo.y:=20;p1.coo.z:=50;
    objattache:=bras1d;
    pntattache:=billy.membre[objattache].obj.npoint-1;
    createbox(obj,p1,p2,render,0,color.peau);
  end;


  l:=sqrt(sqr(world.lumx)+sqr(world.lumy)+sqr(world.lumz));
  if l<>0 then begin
    world.lumx:=round(world.lumx/l*64);
    world.lumy:=round(world.lumy/l*64);
    world.lumz:=round(world.lumz/l*64);
  end;


  for i:=0 to 13 do setlength(billy.membre[i].p3d,billy.membre[i].obj.npoint);
end;

procedure showbilly(billy:tbilly;world:tworld;where:tbmp);
var trv,i,j:integer;
    ntrv,tmp:longint;
    o,z:array[1..13] of word;
    k:longint;
    tomembre:word;
    security:word;
const n=13;
label re;
begin

  for i:=1 to n do begin
    with billy.membre[i] do begin
      obj.coo.x:=round(billy.membre[objattache].p3d[pntattache].coo.x);
      obj.coo.y:=round(billy.membre[objattache].p3d[pntattache].coo.y);
      obj.coo.z:=round(billy.membre[objattache].p3d[pntattache].coo.z);

      inc(obj.coo.x,billy.membre[objattache].obj.coo.x);
      inc(obj.coo.y,billy.membre[objattache].obj.coo.y);
      inc(obj.coo.z,billy.membre[objattache].obj.coo.z);

      for k:=0 to obj.npoint-1 do begin
        p3d[k].coo.x:=obj.point[k].coo.x;
        p3d[k].coo.y:=obj.point[k].coo.y;
        p3d[k].coo.z:=obj.point[k].coo.z;
      end;

      tomembre:=i;
      security:=5;
re:
       rotateobject(obj.npoint,p3d,billy.membre[tomembre].obj.angle);
       tomembre:=billy.membre[tomembre].objattache;
       dec(security);
     if (tomembre<>init) and (security>0) then goto re;
     rotateobject(obj.npoint,p3d,billy.membre[init].obj.angle);

   end;

 end;

  for i:=1 to n do begin
    o[i]:=i;
    z[i]:=round((billy.membre[i].p3d[0].coo.z+billy.membre[i].p3d[6].coo.z)/2)+billy.membre[i].obj.coo.z;
  end;

  for i:=1 to n-1 do begin
    trv:=i;
    ntrv:=z[i];
    for j:=i+1 to n do if z[j]>ntrv then begin
      ntrv:=z[j];
      trv:=j;
    end;
    tmp:=o[i];o[i]:=o[trv];o[trv]:=tmp;
    tmp:=z[i];z[i]:=z[trv];z[trv]:=tmp;
  end;

  for i:=1 to n do drawobject(billy.membre[o[i]].obj,world,where,billy.membre[o[i]].p3d);
end;

end.
