library bmpskin;

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,Skin,StdCtrls,Menus,Registry;

Const NBlocs=4;
      MaxImg=7;
      IsShowPatt:Array[0..5] Of Boolean=(false,true,true,true,false,false);
      IsShowVis:Array[0..5] Of Boolean=(false,false,false,true,true,true);

type tstatus=record
  PattPos:Byte;
  VisLoaded:Boolean;
  View:Byte;
  AOTop:Boolean;
  TitleMode:Byte;
end;
var status:tstatus;

var inenvir,inmsg:boolean;

type tmsg=record
  global:boolean;
  lastmsg:string;
  globmsg:string;
  count:word;
end;
var smsg:tmsg;

var dir:string;

Var OldMsg:Pointer;

Type TImg=Record
  X,Y:Integer;
End;

Type TCtrl=Record
  X,Y,Tx,Ty:Integer;
  Pushed:Boolean;
  State:Byte;
  Index:Byte;
  Animated:Boolean;
  AnimUp:Array[0..MaxImg] Of TImg;
  AnimDn:Array[0..MaxImg] Of TImg;
  DisImg:TImg;
  DirAnim:ShortInt;
  Enabled:Boolean;
End;

Type TBloc=Record
  Image:TImage;
  Ctrl:Array Of TCtrl;
  NCtrl:Integer;
End;

Type TScroll=Record
  Image:TImage;
  Min,Max,Pos:Integer;
  BackImg:TImg;
  DebImg,FinImg,MidImg:TImg;
  DisImg:TImg;
  Enabled:Boolean;
End;

Type TMyLabel=Record
  Image:TImage;
  Text,OldText:String;
  BackImg:TImg;
  Scroll:Boolean;
  PScroll,FScroll,DSCroll:Integer;
End;

Type TMyForm=Record
  Rgn1,Rgn2:HRgn;
  Form:TForm;
  Timer:TTimer;
  BigImage:TImage;
  Clicked:Boolean;
  Move:Boolean;
  FromX,FromY:Integer;
  MouseDn:Boolean;
  MouseDnInScroll:Integer;
  Bloc:Array[0..NBlocs] Of TBloc;
  Scroll:Array[1..3] Of TScroll;
  Labels:Array[1..3] Of TMyLabel;

  MsgTimer:TTimer;
  Image1,Image2:TImage;

  ImgDc1,ImgDc2:HDC;

  popupmenu1:tpopupmenu;
  setup1:tmenuitem;
  quit1:tmenuitem;
  Quitbutdontsaveplaylist1:tmenuitem;
  aotop1:tmenuitem;
  traymenu1:tpopupmenu;
  restore1:tmenuitem;
  separate1:tmenuitem;
  separate2:tmenuitem;
  setup2:tmenuitem;
  quit2:tmenuitem;
  Quitbutdontsaveplaylist2:tmenuitem;
End;

Var MyForm:TMyForm;

Var InfoStr:String;
Const Version=1 SHL 16+72;

Var Mouse:TMouse;

type
  TNid=record
    cbSize:LongWord;
    hWnd:Hwnd;
    uID:LongWord;
    uFlags:LongWord;
    uCallbackMessage:LongWord;
    Icon:HIcon;
    Tip:Array[1..64] Of Char;
  end;
  PNid=^TNid;

const Nim_Add=0;
      Nim_Delete=2;
      Nim_Modify=1;
      Nif_Icon=2;
      Nif_Message=1;
      Nif_Tip=4;

var Nid:TNid;

function Shell_NotifyIcon(Id:LongWord;Nid:PNid):boolean;stdcall
external 'shell32.dll' name 'Shell_NotifyIconA';

procedure drawtext(n,dx:integer;txt:string);
var sy,i,sx,x,y:integer;
begin
  with myform.labels[n] do begin
    sy:=round((image.height-12)/2);
    bitblt(image.canvas.handle,0,0,image.width,image.height,myform.bigimage.canvas.handle,backimg.x,backimg.y,SRCCOPY);
    for i:=1 to length(text) do begin
      sx:=(i-1)*9+dx;
      if byte(text[i])>32 then begin
        x:=552+((byte(text[i])-32) mod 32)*9;
        y:=568+((byte(text[i])-32) div 32)*12;
        bitblt(image.canvas.handle,sx,sy,9,12,myform.bigimage.canvas.handle,x,y,SRCCOPY);
      end;
    end;
    image.refresh;
  end;
end;

procedure dolabel(n:integer);
begin
  with myform.labels[n] do begin
    if not scroll then exit;
    inc(pscroll,dscroll);
    if pscroll=fscroll+1 then begin
      pscroll:=fscroll;
      dscroll:=-1;
    end;
    if pscroll=-1 then begin
      pscroll:=0;
      dscroll:=1;
    end;
    drawtext(n,-pscroll,text);
  end;
end;

procedure settext(n:integer;txt:string);
var d:integer;
begin
  with myform.labels[n] do begin
    if txt=oldtext then exit;
    text:=txt;
    d:=round((image.width-9*length(text))/2);
    if d<0 then begin
      scroll:=true;
      pscroll:=0;
      fscroll:=-d*2+1;
      dscroll:=1;
      d:=0;
    end else begin
      scroll:=false;
    end;
    drawtext(n,d,text);
    oldtext:=text;
  end;
end;

procedure drawscrl(n:integer);
var av:integer;
    i:integer;
begin
  with myform.scroll[n] do begin
    if enabled then begin
      av:=trunc((pos-min)/(max)*(image.width-4));
      if av<4 then av:=4;
      bitblt(image.canvas.handle,0,0,image.width,image.height,myform.bigimage.canvas.handle,backimg.x,backimg.y,SRCCOPY);
      bitblt(image.canvas.handle,2,2,2,8,myform.bigimage.canvas.handle,debimg.x,debimg.y,SRCCOPY);
      for i:=2 to av-3 do bitblt(image.canvas.handle,i+2,2,1,8,myform.bigimage.canvas.handle,midimg.x,midimg.y,SRCCOPY);
      bitblt(image.canvas.handle,av-2+2,2,2,8,myform.bigimage.canvas.handle,finimg.x,finimg.y,SRCCOPY);
    end else begin
      bitblt(image.canvas.handle,0,0,image.width,image.height,myform.bigimage.canvas.handle,backimg.x,backimg.y,SRCCOPY);
    end;
    image.refresh;
  end;
end;

procedure setpos(n:integer;v:integer);
begin
  with myform.scroll[n] do begin
    if v<min then v:=min;
    if v>max then v:=max;
    pos:=v;
    drawscrl(n);
  end;
end;

procedure disablescrl(n:integer;refresh:boolean);
begin
  with myform.scroll[n] do begin
    enabled:=false;
    if refresh then drawscrl(n);
  end;
end;

procedure enablescrl(n:integer;refresh:boolean);
begin
  with myform.scroll[n] do begin
    enabled:=true;
    if refresh then drawscrl(n);
  end;
end;

procedure disablectrl(n,i:integer);
begin
  with myform.Bloc[n].ctrl[i] do begin
    index:=0;
    enabled:=false;
    bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,disimg.x,disimg.y,srccopy);
  end;
  myform.bloc[n].image.refresh;
end;

procedure enablectrl(n,i:integer);
begin
  with myform.Bloc[n].ctrl[i] do begin
    enabled:=true;
    case state of
      1:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animup[index].y,srccopy);
      2:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animdn[index].y,srccopy);
    end;
  end;
  myform.bloc[n].image.refresh;
end;

procedure dobloc(n:integer);
var i:integer;
begin
  for i:=0 to myform.bloc[n].nctrl-1 do begin
    with myform.Bloc[n].ctrl[i] do begin
      if (diranim<>0) and enabled then begin
        if (diranim=-1) and (index=0) then diranim:=0;
        if (diranim=1) and (index=MaxImg) then diranim:=0;
        inc(index,diranim);
        case state of
          1:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animup[index].y,srccopy);
          2:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animdn[index].y,srccopy);
        end;
      end;
    end;
  end;
  myform.bloc[n].image.refresh;
end;

procedure doanim;
var t,t1,t2:string;
begin
  if inenvir then exit;
  inenvir:=true;
  if boolean(gui.getinfo(get_gui_status_isplaying)) then setpos(1,gui.getinfo(2) div 10);
  str(pmod.getmod(25) div 60:2,t);str(pmod.getmod(25) mod 60:2,t1);
  if t[1]=' ' then t[1]:='0';
  if t1[1]=' ' then t1[1]:='0';
  t:=t+':'+t1;
  t2:=t;

  str(pmod.getmod(26) div 60:2,t);str(pmod.getmod(26) mod 60:2,t1);
  if t[1]=' ' then t[1]:='0';
  if t1[1]=' ' then t1[1]:='0';
  t:=t+':'+t1;
  settext(2,t+' '+t2);
  inenvir:=false;
end;

procedure repaint;
var n,i:integer;
begin
  for n:=1 to nblocs do begin
    for i:=0 to myform.bloc[n].nctrl-1 do begin
      with myform.Bloc[n].ctrl[i] do begin
        if enabled then begin
          case state of
            1:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animup[index].y,srccopy);
            2:bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,animup[index].x,animdn[index].y,srccopy);
          end;
        end else begin
          bitblt(myform.bloc[n].image.canvas.handle,x,y,tx,ty,myform.bigimage.canvas.handle,disimg.x,disimg.y,srccopy);
        end;
      end;
    end;
    myform.bloc[n].image.refresh;
  end;
  for n:=1 to 3 do begin
    with myform.scroll[n] do begin
      drawscrl(n);
    end;
  end;
end;

procedure showpatt(t:byte);
begin
  case t of
    0:begin
      myform.image2.visible:=false;
      myform.scroll[2].image.visible:=false;
    end;
    1:begin
      vis.uninitpatt;
      myform.image2.width:=6*16*3+12;
      myform.image2.height:=80;
      myform.image2.visible:=true;
      myform.scroll[2].backimg.x:=0;
      myform.scroll[2].backimg.y:=1213;
      myform.scroll[2].image.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scroll[2].image.left:=myform.image2.left-2;
      myform.scroll[2].image.top:=myform.image2.top+myform.image2.height+8;
      myform.scroll[2].image.width:=304;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        enablescrl(2,true);
        myform.scroll[2].min:=0;
        myform.scroll[2].max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
      end else begin;
        status.pattpos:=0;
        setpos(2,0);
        disablescrl(2,true);
      end;
    end;
    2:begin
      vis.uninitpatt;
      myform.image2.width:=9*16*3+12;
      myform.image2.height:=80;
      myform.image2.visible:=true;
      myform.scroll[2].backimg.x:=0;
      myform.scroll[2].backimg.y:=1225;
      myform.scroll[2].image.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scroll[2].image.top:=myform.image2.top+myform.image2.height+5;
      myform.scroll[2].image.width:=448;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        enablescrl(2,true);
        myform.scroll[2].min:=0;
        myform.scroll[2].max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
        if status.pattpos>myform.scroll[2].max then begin
          status.pattpos:=myform.scroll[2].max;
          setpos(2,status.pattpos);
        end;
      end else begin;
        status.pattpos:=0;
        setpos(2,0);
        disablescrl(2,true);
      end;
    end;
    3:begin
      vis.uninitpatt;
      myform.image2.width:=9*16*3+12;
      myform.image2.height:=150;
      myform.image2.visible:=true;
      myform.scroll[2].backimg.x:=0;
      myform.scroll[2].backimg.y:=1225;
      myform.scroll[2].image.visible:=true;
      vis.initpatt(myform.image2.canvas.handle,myform.image2.width,myform.image2.height);
      myform.scroll[2].image.top:=myform.image2.top+myform.image2.height+5;
      myform.scroll[2].image.width:=448;
      if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
        enablescrl(2,true);
        myform.scroll[2].min:=0;
        myform.scroll[2].max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
        if status.pattpos>myform.scroll[2].max then begin
          status.pattpos:=myform.scroll[2].max;
          setpos(2,status.pattpos);
        end;
      end else begin;
        status.pattpos:=0;
        setpos(2,0);
        disablescrl(2,true);
      end;
    end;
  end;
end;

procedure showdc(t:byte);
begin
  case t of
    0:begin
      myform.image1.visible:=false;
      myform.labels[3].image.visible:=false;
    end;
    1:begin
      myform.labels[3].image.visible:=true;
      vis.uninitdc;
      myform.image1.width:=128;
      myform.image1.height:=80;
      myform.image1.left:=326;
      myform.image1.top:=111;
      myform.image1.visible:=true;
      vis.initdc(myform.image1.canvas.handle,128,80);
    end;
    2:begin
      myform.labels[3].image.visible:=false;
      vis.uninitdc;
      myform.image1.visible:=true;
      myform.image1.width:=320;
      myform.image1.height:=100;
      myform.image1.left:=(myform.form.width-myform.image1.width) div 2;
      myform.image1.top:=111;
      vis.initdc(myform.image1.canvas.handle,320,100);
    end;
    3:begin
      myform.labels[3].image.visible:=false;
      vis.uninitdc;
      myform.image1.visible:=true;
      myform.image1.width:=320;
      myform.image1.height:=200;
      myform.image1.left:=(myform.form.width-myform.image1.width) div 2;
      myform.image1.top:=110;
      vis.initdc(myform.image1.canvas.handle,320,200);
    end;
  end;
end;

procedure resizevis;
begin
  if (status.view=0) or not status.visloaded then begin
    myform.form.height:=99;
    showpatt(0);
    showdc(0);
  end;
  if status.visloaded then begin
    case status.view of
      1:begin
        myform.form.height:=99+190;
        bitblt(myform.bloc[0].image.canvas.handle,0,97,myform.form.width,myform.form.height-99,myform.bigimage.canvas.handle,0,782,SRCCOPY);
        MyForm.Bloc[0].Image.Refresh;
        showpatt(3);
        showdc(0);
      end;
      2:begin
        myform.form.height:=99+123;
        bitblt(myform.bloc[0].image.canvas.handle,0,97,myform.form.width,myform.form.height-99,myform.bigimage.canvas.handle,468,782,SRCCOPY);
        MyForm.Bloc[0].Image.Refresh;
        showpatt(2);
        showdc(0);
      end;
      3:begin
        myform.form.height:=99+130;
        bitblt(myform.bloc[0].image.canvas.handle,0,97,myform.form.width,myform.form.height-99,myform.bigimage.canvas.handle,468,1033,SRCCOPY);
        MyForm.Bloc[0].Image.Refresh;
        showpatt(1);
        showdc(1);
      end;
      4:begin
        myform.form.height:=99+128;
        bitblt(myform.bloc[0].image.canvas.handle,0,97,myform.form.width,myform.form.height-99,myform.bigimage.canvas.handle,468,905,SRCCOPY);
        MyForm.Bloc[0].Image.Refresh;
        showpatt(0);
        showdc(2);
      end;
      5:begin
        myform.form.height:=99+229;
        bitblt(myform.bloc[0].image.canvas.handle,0,97,myform.form.width,myform.form.height-99,myform.bigimage.canvas.handle,0,972,SRCCOPY);
        MyForm.Bloc[0].Image.Refresh;
        showpatt(0);
        showdc(3);
      end;
    end;
  end;
  DeleteObject(MyForm.Rgn1);
  MyForm.Rgn1:=CreateRoundRectRgn(0,0,468,98,15,15);
  DeleteObject(MyForm.Rgn2);
  MyForm.Rgn2:=CreateRoundRectRgn(0,97,468,myform.form.height-2,15,15);
  If MyForm.Form.Height>99 Then Begin
    CombineRgn(MyForm.Rgn2,MyForm.Rgn1,MyForm.Rgn2,RGN_OR);
    SetWindowRgn(MyForm.Form.Handle,MyForm.Rgn2,True);
  End Else Begin
    SetWindowRgn(MyForm.Form.Handle,MyForm.Rgn1,True);
  End;
end;

procedure doredraw;
var i,j:integer;
    t,t1:string;
label case0;
begin
  if inenvir then exit;
  inenvir:=true;
  repaint;

  case status.titlemode of
    0:begin
      case0:
      t:=gui.getinfos(get_gui_currentfilename);
      if t<>'' then begin
        t1:='';
        i:=length(t);
        repeat dec(i) until (i=0) or (t[i]='\');
        for j:=i+1 to length(t) do t1:=t1+t[j];
      end else begin
        t1:='';
      end;
      settext(1,t1);
    end;
    1:begin
      if boolean(gui.getinfo(get_gui_status_isplaying)) then begin
        settext(1,pmod.getmods(1));
      end else begin
        goto case0;
      end;
    end;
  end;

  if gui.getinfos(get_gui_currentfilename)<>'' then begin
    enablectrl(2,0);
    enablectrl(2,3);
    enablectrl(2,4);
    enablectrl(2,6);
    enablectrl(2,7);
  end else begin
    disablectrl(2,0);
    disablectrl(2,3);
    disablectrl(2,4);
    disablectrl(2,6);
    disablectrl(2,7);
  end;

  if pmod.getmod(9)>vis.getvisinfo(get_vis_nbchan) then begin
    enablescrl(2,true);
    myform.scroll[2].min:=0;
    myform.scroll[2].max:=pmod.getmod(9)-vis.getvisinfo(get_vis_nbchan);
  end else begin;
    disablescrl(2,true);
  end;
  setpos(3,gui.getinfo(get_gui_setup_volume));

  if boolean(gui.getinfo(get_gui_setup_reverb)) then begin
    myform.bloc[3].ctrl[1].pushed:=true;
    myform.bloc[3].ctrl[1].state:=2;
  end else begin
    myform.bloc[3].ctrl[1].pushed:=false;
  end;

  if boolean(gui.getinfo(get_gui_setup_surround)) then begin
    myform.bloc[3].ctrl[2].pushed:=true;
    myform.bloc[3].ctrl[2].state:=2;
  end else begin
    myform.bloc[3].ctrl[2].pushed:=false;
  end;

  if boolean(gui.getinfo(get_gui_setup_autoampli)) then begin
    myform.bloc[3].ctrl[3].pushed:=true;
    myform.bloc[3].ctrl[3].state:=2;
  end else begin
    myform.bloc[3].ctrl[3].pushed:=false;
  end;
  i:=gui.getinfo(get_gui_setup_nmodloop);
  if i=255 then i:=5;
  for j:=0 to 7 do begin
    MyForm.bloc[3].Ctrl[0].AnimUp[J].X:=J*23;
    MyForm.bloc[3].Ctrl[0].AnimUp[J].Y:=I*46;
    MyForm.bloc[3].Ctrl[0].AnimDn[J].X:=J*23;
    MyForm.bloc[3].Ctrl[0].AnimDn[J].Y:=I*46+23;
  end;

  i:=gui.getinfo(get_gui_setup_sepastereo);
  for j:=0 to 7 do begin
    MyForm.bloc[3].Ctrl[4].AnimUp[J].X:=184+J*46;
    MyForm.bloc[3].Ctrl[4].AnimUp[J].Y:=I*46+460;
    MyForm.bloc[3].Ctrl[4].AnimDn[J].X:=184+J*46;
    MyForm.bloc[3].Ctrl[4].AnimDn[J].Y:=I*46+23+460;
  end;

  i:=gui.getinfo(get_gui_setup_ampli);
  for j:=0 to 7 do begin
    MyForm.bloc[3].Ctrl[5].AnimUp[J].X:=184+J*46;
    MyForm.bloc[3].Ctrl[5].AnimUp[J].Y:=I*46+184;
    MyForm.bloc[3].Ctrl[5].AnimDn[J].X:=184+J*46;
    MyForm.bloc[3].Ctrl[5].AnimDn[J].Y:=I*46+23+184;
  end;

(*  if boolean(gui.getinfo(get_gui_status_isplaying)) then enablescrl(1,true) else disablescrl(1,true);*)
  setpos(3,gui.getinfo(get_gui_setup_volume));

  repaint;
  inenvir:=false;
end;

function SkGetInfo(param:longword):longint;stdcall;
begin
  skgetinfo:=0;
  case param of
    Get_Skin_PMPVersion:skgetinfo:=version;
  end;
end;

procedure SkMsg(txt:shortstring;glob:boolean);stdcall;
begin
  if inmsg then exit;
  inmsg:=true;
  if txt<>'' then begin
    if glob then begin
      smsg.globmsg:=txt;
      if smsg.global then settext(3,txt);
    end else begin
      smsg.global:=false;
      smsg.count:=0;
      if txt<>smsg.lastmsg then begin
        smsg.lastmsg:=txt;
        settext(3,txt);
      end;
    end;
  end else begin
    smsg.global:=true;
    smsg.count:=0;
    smsg.lastmsg:='';
    settext(3,'');
  end;
  smsg.lastmsg:=txt;
  inmsg:=false;
end;

procedure fin(Sender: TObject; var CanClose: Boolean);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,1);
end;

procedure Quitbutdontsaveplaylist1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,0);
end;

procedure Quit1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,1);
end;

procedure Setup1Click(Sender: TObject);
begin
  gui.sendmessage(msg_gui_setup,0);
end;

procedure msg(win:hwnd;msg:word;wparam,lparam:longword);stdcall;forward

procedure bring;
begin
  myform.form.visible:=true;
  showwindow(myform.form.handle,sw_shownormal);
  SetForegroundWindow(myform.form.handle);
  myform.restore1.enabled:=false;
end;

procedure Restore1Click(Sender: TObject);
begin
  bring;
end;

procedure AOTop1Click(Sender:TObject);
Begin
  myform.aotop1.checked:=not myform.aotop1.checked;
  status.aotop:=myform.aotop1.checked;
  if myform.aotop1.checked then begin
    setwindowpos(myform.form.handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  end else begin
    setwindowpos(myform.form.handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  end;
End;

Function SkSendMessage(msg:longint;param:longint):LongInt;stdcall;
begin
  sksendmessage:=0;
  case msg of
    msg_skin_entermenu:begin
      if status.aotop then begin
        setwindowpos(myform.form.handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
      end;
    end;
    msg_skin_leavemenu:begin
      if status.aotop then begin
        setwindowpos(myform.form.handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
      end;
    end;

    msg_skin_anim:begin
      inenvir:=true;
      if myform.form.visible then begin
        if isshowvis[status.view] then begin
          vis.dodc(myform.image1.canvas.handle,boolean(gui.getinfo(get_gui_status_isplaying)));
          myform.image1.refresh;
        end;
        if isshowpatt[status.view] then begin
          vis.dopatt(myform.image2.canvas.handle,status.pattpos,boolean(gui.getinfo(get_gui_status_isplaying)));
          myform.image2.refresh;
        end;  
      end;
      inenvir:=false;
      doanim;
    end;
    msg_skin_play:begin
      vis.newplay;
      setpos(1,0);
      setpos(2,0);
      status.pattpos:=0;
      enablectrl(2,1);
      enablectrl(2,2);
      enablescrl(1,true);
      if pmod.getmods(1)<>'' then myform.form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion)+' : '+trim(pmod.getmods(1)) else myform.form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion);
      StrPCopy(@Nid.Tip,MyForm.Form.Caption);
      Shell_NotifyIcon(Nim_Modify,@Nid);
      doredraw;
    end;
    msg_skin_stop:begin
      myform.Bloc[2].ctrl[1].pushed:=false;
      myform.Bloc[2].ctrl[1].state:=1;
      disablescrl(2,true);
      disablescrl(1,true);
      disablectrl(2,1);
      disablectrl(2,2);
      vis.cleanpatt(myform.image2.canvas.handle);
      vis.cleandc(myform.image1.canvas.handle);
      myform.image1.refresh;
      myform.image2.refresh;
      myform.form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion);
      StrPCopy(@Nid.Tip,MyForm.Form.Caption);
      Shell_NotifyIcon(Nim_Modify,@Nid);
      doredraw;
    end;
    msg_skin_redraw:doredraw;
    msg_skin_setwindow:begin
      case param of
        msg_skin_setwindow_enable:if myform.form.visible then myform.form.enabled:=true;
        msg_skin_setwindow_disable:if myform.form.visible then myform.form.enabled:=false;
        msg_skin_setwindow_bringtotop:begin
          if myform.form.enabled then begin
            myform.form.show;
            bringwindowtotop(myform.form.handle);
            myform.form.setfocus;

          end;
        end;
      end;
    end;
    msg_skin_pause:begin
      myform.Bloc[2].ctrl[1].pushed:=true;
      myform.Bloc[2].ctrl[1].state:=2;
    end;
    msg_skin_initgraphs:begin
      status.visloaded:=vis.initgraphs(myform.image1.canvas.handle,myform.image2.canvas.handle,myform.image1.width,myform.image1.height,myform.image2.width,myform.image2.height);
      resizevis;
    end;
    msg_skin_endgraphs:begin
      vis.endgraphs;
    end;
    msg_skin_resume:begin
      myform.Bloc[2].ctrl[1].pushed:=false;
      myform.Bloc[2].ctrl[1].state:=1;
    end;
  end;
end;

procedure loadreg;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('PMPSkin',True);
  if reg.valueexists('View') then status.view:=reg.readinteger('View') else reg.writeinteger('View',status.view);
  if reg.valueexists('TitleMode') then status.titlemode:=reg.readinteger('TitleMode') else reg.writeinteger('TitleMode',status.titlemode);
  if reg.valueexists('AOT') then status.aotop:=reg.readbool('AOT') else reg.writebool('AOT',status.aotop);
  reg.CloseKey;
  reg.Destroy;
end;

procedure savereg;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('PMPSkin',True);
  reg.writeinteger('View',status.view);
  reg.writeinteger('TitleMode',status.titlemode);
  reg.writebool('AOT',status.aotop);
  reg.CloseKey;
  reg.Destroy;
end;

procedure SkEnd;stdcall;
begin
  Shell_NotifyIcon(Nim_Delete,@Nid);
  myform.timer.interval:=0;
  myform.form.hide;
  myform.form.release;
  deleteobject(myform.rgn1);
  deleteobject(myform.rgn2);
  savereg;
end;

procedure allup;
var i,j:integer;
begin
  for i:=1 to nblocs do begin
    for j:=0 to myform.bloc[i].nctrl-1 do begin
      with myform.bloc[i].ctrl[j] do begin
        if not myform.bloc[i].ctrl[j].pushed then myform.bloc[i].ctrl[j].state:=1;
        diranim:=-1;
      end;
    end;
  end;
end;

procedure doanimtimer;
var i:integer;
begin
  if (mouse.CursorPos.x<myform.form.left) or (mouse.CursorPos.y<myform.form.top) or (mouse.CursorPos.x>=myform.form.left+myform.form.width) or (mouse.CursorPos.y>=myform.form.top+myform.form.height) then allup;
  for i:=1 to nblocs do dobloc(i);
  for i:=1 to 3 do dolabel(i);
end;

procedure clickctrl(n,i:integer);
begin
  case n of
    1:begin
      case i of
        0:gui.sendmessage(msg_gui_open,0);
        1:gui.sendmessage(msg_gui_info,0);
        2:gui.sendmessage(msg_gui_setup,0);
        3:gui.sendmessage(msg_gui_playlist,0);
      end;
    end;
    2:begin
      case i of
        0:gui.sendmessage(msg_gui_play,0);
        1:gui.sendmessage(msg_gui_pause,0);
        2:gui.sendmessage(msg_gui_stop,0);
        3:gui.sendmessage(msg_gui_prev,0);
        4:gui.sendmessage(msg_gui_next,0);
        5:gui.sendmessage(msg_gui_select,0);
        6:gui.sendmessage(msg_gui_moveto,0);
        7:gui.sendmessage(msg_gui_remove,0);
      end;
    end;
    3:begin
      case i of
        0:gui.sendmessage(msg_gui_repeat,-1);
        1:gui.sendmessage(msg_gui_reverb,-1);
        2:gui.sendmessage(msg_gui_surround,-1);
        3:gui.sendmessage(msg_gui_aampli,-1);
        4:gui.sendmessage(msg_gui_stereo,-1);
        5:gui.sendmessage(msg_gui_ampli,-1);
      end;
    end;
    4:begin
      case i of
        0:begin
          if status.view<5 then inc(status.view) else status.view:=0;;
          resizevis;
        end;
        1:begin
          if status.view>0 then dec(status.view) else status.view:=5;
          resizevis;
        end;
      end;
    end;
  end;
end;

procedure clickscrl(n,x,y:integer);
var npos:integer;
begin
  with myform.scroll[n] do begin
    npos:=round(x/(image.width-4)*(max-min)+min);
    if npos<min then npos:=min;
    if npos>max then npos:=max;
  end;
  case n of
    1:begin
      gui.sendmessage(msg_gui_goto,npos*10);
    end;
    2:begin
      status.pattpos:=npos;
      setpos(2,npos);
    end;
    3:begin
      if (npos>112) and (npos<144) then begin
        gui.sendmessage(msg_gui_volume,128);
      end else begin
        gui.sendmessage(msg_gui_volume,npos);
      end;
    end;
  end;
end;

procedure getother(x,y:integer;var u:integer);
begin
  u:=0;
  with myform do begin
    if (x>=labels[1].image.left) and (y>=labels[1].image.top) and (x<labels[1].image.left+labels[1].image.width) and (y<=labels[1].image.top+labels[1].image.height) then u:=1;
    if y<11 then u:=2;
    if (x>=443) and (y>=1) and (x<443+7) and (y<1+7) then u:=3;
    if (x>=436) and (y>=1) and (x<436+7) and (y<1+7) then u:=4;
    if image1.visible and (x>=image1.left) and (y>=image1.top) and (x<image1.left+image1.width) and (y<image1.top+image1.height) then u:=5;
    if image2.visible and (x>=image2.left) and (y>=image2.top) and (x<image2.left+image2.width) and (y<image2.top+image2.height) then u:=6;
  end;
end;

procedure getctrl(x,y:integer;var u,v:integer);
var i,j,x1,y1:integer;
begin
  u:=0;v:=0;
  for j:=1 to nblocs do begin
    x1:=x-myform.bloc[j].image.left;
    y1:=y-myform.bloc[j].image.top;
    if (x1>=0) and (y1>=0) and (x1<myform.bloc[j].image.width) and (y1<myform.bloc[j].image.height) then begin
      with myform.bloc[j] do begin
        for i:=0 to nctrl-1 do begin
          if (x1>=ctrl[i].x) and (x1<ctrl[i].x+ctrl[i].tx) and (y1>=ctrl[i].y) and (y1<ctrl[i].y+ctrl[i].ty) then begin
            u:=j;
            v:=i;
            exit;
          end;
        end;
      end;
    end;
  end;
end;

procedure getscrl(x,y:integer;var u:integer;bid:boolean);
var j,x1,y1:integer;
begin
  u:=0;
  for j:=1 to 3 do begin
    x1:=x-myform.scroll[j].image.left;
    y1:=y-myform.scroll[j].image.top;
    if not bid then begin
      if (x1>=0) and (y1>=0) and (x1<myform.scroll[j].image.width) and (y1<myform.scroll[j].image.height) then begin
        u:=j;
        exit;
      end;
    end else begin
      if (x1>=0) and (y1>=-10) and (x1<myform.scroll[j].image.width) and (y1<myform.scroll[j].image.height+10) then begin
        u:=j;
        exit;
      end;
    end;
  end;
end;


procedure mmove(x,y:integer);
var i,j:integer;
begin
  allup;
  getctrl(x,y,i,j);
  if i>0 then begin
    if myform.bloc[i].ctrl[j].animated then myform.bloc[i].ctrl[j].diranim:=1;
    if myform.mousedn then myform.bloc[i].ctrl[j].state:=2;
  end;
  getscrl(x,y,i,true);
  if i>0 then begin
    if myform.mousedn and myform.scroll[i].enabled and (myform.mousedninscroll=i) then clickscrl(i,x-myform.scroll[i].image.left,y-myform.scroll[i].image.top);
  end;
end;

procedure msg(win:hwnd;msg:word;wparam,lparam:longword);stdcall
var i,j:integer;
begin
  case msg of
    wm_size:begin
      case wparam of
        size_minimized:begin
          showwindow(myform.form.handle,sw_hide);
          myform.form.visible:=false;
          myform.restore1.enabled:=true;
        end;
        size_restored:begin
          bring;
        end;
        else callwindowproc(oldmsg,win,msg,wparam,lparam);
      end;
    end;
    wm_user:begin
      case lparam of
        wm_LBUTTONDBLCLK:bring;
        wm_RBUTTONDOWN:begin
          if myform.form.visible then bring;
          myform.TrayMenu1.popup(mouse.cursorpos.x,mouse.cursorpos.y);
        end;
      end;
    end;
    wm_mousemove:begin
      if myform.move then begin
        movewindow(myform.form.handle,mouse.CursorPos.x-myform.fromx,mouse.cursorpos.y-myform.fromy,myform.Form.width,myform.form.height,true);
      end else begin
        mmove(lparam and 65535,lparam shr 16);
      end;
    end;
    wm_lbuttondown,wm_lbuttondblclk:begin
      setcapture(myform.form.handle);
      getother(lparam and 65535,lparam shr 16,i);
      myform.mousedn:=true;
      if i<>2 then begin
        getscrl(lparam and 65535,lparam shr 16,myform.mousedninscroll,false);
        mmove(lparam and 65535,lparam shr 16);
      end else begin
        myform.move:=true;
        myform.fromx:=lparam and 65535;
        myform.fromy:=lparam shr 16;
      end;
    end;
    WM_CAPTURECHANGED:begin
      myform.move:=false;
      myform.clicked:=false;
      myform.mousedn:=false;
      mmove(lparam and 65535,lparam shr 16);
    end;
    wm_lbuttonup:begin
      if myform.mousedn then begin
        releasecapture;
        myform.move:=false;
        myform.clicked:=false;
        myform.mousedn:=false;
        getctrl(lparam and 65535,lparam shr 16,i,j);
        if myform.mousedninscroll=0 then clickctrl(i,j);
        getother(lparam and 65535,lparam shr 16,i);
        if i>0 then begin
          case i of
            1:begin
              status.TitleMode:=1-status.titlemode;
              doredraw;
            end;
            3:begin
              gui.sendmessage(msg_gui_stop,0);
              gui.sendmessage(msg_gui_quit,1);
            end;
            4:begin
              showwindow(myform.form.handle,sw_hide);
              myform.form.visible:=false;
              myform.restore1.enabled:=true;
            end;
            5:begin
              vis.setupvis;
            end;
            6:begin
              vis.setuppattern;
            end;
          end;
        end;
        mmove(lparam and 65535,lparam shr 16);
      end;  
    end;
(*    wm_lbuttondblclk:;*)
    else callwindowproc(oldmsg,win,msg,wparam,lparam);
  end;
end;

procedure timertime(sender:tobject);
begin
  doanimtimer;
end;

procedure msgtimerontimer(sender:tobject);
begin
  inc(smsg.count);
  if smsg.count>=30 then begin
    smsg.count:=0;
    settext(3,smsg.globmsg);
    smsg.global:=true;
    smsg.lastmsg:='';
  end;
end;

Var timerptime:tnotifyevent;

procedure create_my_window;
var i,j:integer;
const cy=13;
begin
  with myform do begin
    Form:=TForm.Create(Nil);
    Form.Position:=podesktopcenter;
    Form.Width:=468;
    Form.Height:=99;
    Form.borderStyle:=bsnone;
    Form.caption:='Plouf''s ModPlayer '+gui.getinfos(get_gui_PMPVersion);
    Form.Icon.LoadFromfile(dir+'pmps.ico');

    Rgn1:=CreateRoundRectRgn(0,0,468,98,15,15);
    Rgn2:=CreateRoundRectRgn(0,0,468,98,15,15);

    SetWindowRgn(Form.Handle,Rgn1,True);

    @Form.OnCloseQuery:=@Fin;
    oldmsg:=pointer(setwindowlong(form.handle,GWL_WNDPROC,longword(@msg)));

    BigImage:=TImage.Create(Form);
    BigImage.Width:=1024;
    BigImage.Height:=768;

    With Bloc[0] Do Begin
      Image:=Timage.Create(Form);
      Image.Parent:=Form;
      Image.Left:=0;
      Image.Top:=0;
      Image.Width:=Form.Width;
      Image.Height:=99+229;
      NCtrl:=1;
      SetLength(Ctrl,1);
      Ctrl[1].State:=1;
      Ctrl[1].Pushed:=False;
      Ctrl[1].Enabled:=False;
    End;

    Image1:=TImage.Create(Form);
    Image1.Width:=320;
    Image1.Height:=200;
    Image1.Parent:=Form;
    Image2:=TImage.Create(Form);
    Image2.Width:=444;
    Image2.Height:=150;
    Image2.Parent:=Form;
    Image2.Left:=12;
    Image2.Top:=111;

    With Bloc[1] Do Begin
      Image:=TImage.Create(Form);
      Image.Parent:=Form;
      Image.Left:=208;
      Image.Top:=8+Cy;
      Image.Height:=23*2;
      Image.Width:=57*2;
      NCtrl:=4;
      SetLength(Ctrl,4);
      For I:=0 To 3 Do Begin
        Ctrl[I].State:=1;
        Ctrl[I].Index:=0;
        Ctrl[I].DirAnim:=0;
        Ctrl[I].Enabled:=True;
        Ctrl[I].Tx:=57;
        Ctrl[I].Ty:=23;
        ctrl[I].Pushed:=False;
        Ctrl[I].DisImg.X:=0;
        Ctrl[I].DisImg.Y:=0;
        Ctrl[I].Animated:=True;
        For J:=0 To 7 Do Begin
          Ctrl[I].AnimUp[J].X:=184+J*57;
          Ctrl[I].AnimUp[J].Y:=I*46;
          Ctrl[I].AnimDn[J].X:=184+J*57;
          Ctrl[I].AnimDn[J].Y:=I*46+23;
        End;
      End;
      Ctrl[0].X:=00;Ctrl[0].Y:=00;
      Ctrl[1].X:=57;Ctrl[1].Y:=00;
      Ctrl[2].X:=00;Ctrl[2].Y:=23;
      Ctrl[3].X:=57;Ctrl[3].Y:=23;
    End;

    With Bloc[2] Do Begin
      Image:=TImage.Create(Form);
      Image.Parent:=Form;
      Image.Left:=8;
      Image.Top:=30+cy;
      Image.Height:=24;
      Image.Width:=24*8;
      NCtrl:=8;
      SetLength(Ctrl,8);
      For I:=0 To 7 Do Begin
        Ctrl[I].State:=1;
        Ctrl[I].Index:=0;
        Ctrl[I].DirAnim:=0;
        Ctrl[I].Enabled:=True;
        Ctrl[I].Tx:=24;
        Ctrl[I].Ty:=24;
        Ctrl[I].Pushed:=False;
        Ctrl[I].DisImg.X:=192+552;
        Ctrl[I].DisImg.Y:=I*48+184;
        Ctrl[I].Animated:=True;
        For J:=0 To 7 Do Begin
          Ctrl[I].AnimUp[J].X:=J*24+552;
          Ctrl[I].AnimUp[J].Y:=I*48+184;
          Ctrl[I].AnimDn[J].X:=J*24+552;
          Ctrl[I].AnimDn[J].Y:=I*48+24+184;
        End;
        Ctrl[I].X:=I*24;Ctrl[I].Y:=00;
      End;
    End;

    With Bloc[3] Do Begin
      Image:=TImage.Create(Form);
      Image.Parent:=Form;
      Image.Left:=330;
      Image.Top:=8+cy;
      Image.Height:=2*23;
      Image.Width:=4*23;
      NCtrl:=6;
      SetLength(Ctrl,6);
      For I:=0 To 5 Do Begin
        Ctrl[I].State:=1;
        Ctrl[I].Index:=0;
        Ctrl[I].DirAnim:=0;
        Ctrl[I].Enabled:=True;
        Ctrl[I].Ty:=23;
        Ctrl[I].Pushed:=False;

        Ctrl[I].DisImg.X:=0;
        Ctrl[I].DisImg.Y:=0;
        Ctrl[I].Animated:=True;
      End;
      For I:=0 To 3 Do Begin
        Ctrl[I].Tx:=23;
        Ctrl[I].X:=I*23;Ctrl[I].Y:=00;
      End;
      For I:=4 To 5 Do Begin
        Ctrl[I].Tx:=46;
        Ctrl[I].X:=(I-4)*46;Ctrl[I].Y:=23;
      End;
      For I:=1 To 3 Do Begin
        For J:=0 To 7 Do Begin
          Ctrl[I].AnimUp[J].X:=J*23;
          Ctrl[I].AnimUp[J].Y:=I*46+5*46;
          Ctrl[I].AnimDn[J].X:=J*23;
          Ctrl[I].AnimDn[J].Y:=I*46+23+5*46;
        End;
      End;
    End;

    With Bloc[4] Do Begin
      Image:=TImage.Create(Form);
      Image.Parent:=Form;
      Image.Left:=430;
      Image.Top:=8+cy;
      Image.Height:=2*23;
      Image.Width:=23;
      NCtrl:=2;
      SetLength(Ctrl,2);
      For I:=0 To 1 Do Begin
        Ctrl[I].State:=1;
        Ctrl[I].Index:=0;
        Ctrl[I].DirAnim:=0;
        Ctrl[I].Enabled:=True;
        Ctrl[I].Tx:=23;
        Ctrl[I].Ty:=23;
        Ctrl[I].Pushed:=False;

        Ctrl[I].DisImg.X:=0;
        Ctrl[I].DisImg.Y:=0;
        Ctrl[I].Animated:=True;
        For J:=0 To 7 Do Begin
          Ctrl[I].AnimUp[J].X:=J*23;
          Ctrl[I].AnimUp[J].Y:=I*46+9*46;
          Ctrl[I].AnimDn[J].X:=J*23;
          Ctrl[I].AnimDn[J].Y:=I*46+23+9*46;
        End;
        Ctrl[I].X:=0;Ctrl[I].Y:=I*23;
      End;
    End;


    Timer:=TTimer.Create(Form);
    @timerptime:=@timertime;
    Timer.OnTimer:=timerptime;

    MsgTimer:=TTimer.Create(Form);
    MsgTimer.Interval:=10;
    @Timerptime:=@MsgTimerOnTimer;
    MsgTimer.OnTimer:=Timerptime;


    For I:=1 To 3 Do Begin
      Labels[I].Image:=TIMage.Create(Form);
      Labels[I].Image.Parent:=Form;
      Labels[I].OldText:='';
    End;
    With Labels[1] Do Begin
      Image.Top:=9+cy;
      Image.Left:=12;
      Image.Width:=188;
      Image.Height:=17;
      BackImg.X:=480;
      BackImg.Y:=1185;
    End;
    With Labels[2] Do Begin
      Image.Top:=57+cy;
      Image.Left:=334;
      Image.Width:=119;
      Image.Height:=12;
      BackImg.X:=802;
      BackImg.Y:=1233;
    End;
    With Labels[3] Do Begin
      Image.Left:=326;
      Image.Width:=128;
      Image.Top:=197;
      Image.Height:=15;
      BackImg.X:=794;
      BackImg.Y:=1133;
    End;
    For I:=1 To 3 Do Begin
      With Scroll[I] Do Begin
        Image:=TImage.Create(Form);
        Image.Parent:=Form;
(*        NImg:=100;*)
        BackImg.X:=0;BackImg.Y:=0;
        DebImg.X:=640;DebImg.Y:=0;
        FinImg.X:=643;FinImg.Y:=0;
        MidImg.X:=642;MidImg.Y:=0;
      End;
    End;

    With Scroll[1] Do Begin
      BackImg.X:=113;
      BackImg.Y:=1201;
      Image.Left:=9;
      Image.Height:=12;
      Image.Top:=57+cy;
      Image.Width:=190;
      Min:=0;
      Max:=99;
      Enabled:=True;
    End;

    With Scroll[2] Do Begin
      Image.Left:=9;
      Image.Height:=12;
      Image.Width:=448;
      Image.Visible:=False;
      Min:=0;
      Max:=99;
      Enabled:=True;
    End;

    With Scroll[3] Do Begin
      BackImg.X:=0;
      BackImg.Y:=1201;
      Image.Left:=208;
      Image.Height:=12;
      Image.Top:=57+cy;
      Image.Width:=113;
      Min:=0;
      Max:=256;
      Enabled:=True;
    End;

    PopupMenu1:=TPopupMenu.Create(Form);
    PopupMenu1.Autopopup:=true;

    aotop1:=tmenuitem.create(popupmenu1);
    aotop1.caption:='&Always on top';
    @aotop1.OnClick:=@aotop1click;
    PopupMenu1.Items.Add(aotop1);

    Separate2:=TMenuItem.Create(PopupMenu1);
    Separate2.Caption:='-';
    PopupMenu1.Items.Add(separate2);

    setup1:=TMenuItem.Create(PopupMenu1);
    setup1.Caption:='&Setup...';
    @setup1.OnClick:=@Setup1Click;
    PopupMenu1.Items.Add(setup1);

    quit1:=TMenuItem.Create(PopupMenu1);
    quit1.Caption:='&Quit : save';
    @quit1.OnClick:=@Quit1Click;
    PopupMenu1.Items.Add(quit1);

    Quitbutdontsaveplaylist1:=TMenuItem.Create(PopupMenu1);
    Quitbutdontsaveplaylist1.Caption:='Q&uit : don''t save';
    @Quitbutdontsaveplaylist1.OnClick:=@Quitbutdontsaveplaylist1Click;
    PopupMenu1.Items.Add(Quitbutdontsaveplaylist1);

    Separate1:=TMenuItem.Create(PopupMenu1);
    Separate1.Caption:='-';

    Restore1:=TMenuItem.Create(PopupMenu1);
    Restore1.Caption:='Restore';
    Restore1.default:=true;
    restore1.enabled:=false;
    @Restore1.OnClick:=@Restore1Click;

    setup2:=TMenuItem.Create(PopupMenu1);
    setup2.Caption:='&Setup...';
    @setup2.OnClick:=@Setup1Click;

    quit2:=TMenuItem.Create(PopupMenu1);
    quit2.Caption:='&Quit : save';
    @quit2.OnClick:=@Quit1Click;

    Quitbutdontsaveplaylist2:=TMenuItem.Create(PopupMenu1);
    Quitbutdontsaveplaylist2.Caption:='Q&uit : don''t save';
    @Quitbutdontsaveplaylist2.OnClick:=@Quitbutdontsaveplaylist1Click;


    TrayMenu1:=TPopupMenu.Create(Form);
    TrayMenu1.Autopopup:=false;
    TrayMenu1.Items.Add(Restore1);
    TrayMenu1.Items.Add(Separate1);
    TrayMenu1.Items.Add(Setup2);
    TrayMenu1.Items.Add(Quit2);
    TrayMenu1.Items.Add(Quitbutdontsaveplaylist2);

    Form.PopupMenu:=PopupMenu1;

  End;
End;

procedure SkInit(loadproc:tloadproc);stdcall;
var i:integer;
begin
  status.view:=3;
  status.TitleMode:=1;
  loadreg;

  loadallstuff(loadproc);
  dir:=gui.getinfos(get_gui_skindirectory);
  status.visloaded:=false;
  create_my_window;
  inenvir:=false;
  inmsg:=false;

  Nid.cbSize:=SizeOf(TNid);
  Nid.hWnd:=MyForm.Form.Handle;
  GetWindowThreadProcessId(Application.Handle,@Nid.uId);

  Nid.uFlags:=Nif_Icon OR Nif_Message OR Nif_Tip;
  Nid.uCallbackMessage:=WM_USER;
  Nid.Icon:=MyForm.Form.Icon.Handle;
  StrPCopy(@Nid.Tip,MyForm.Form.Caption);
  Shell_NotifyIcon(Nim_Add,@Nid);

  for i:=0 to 7 do if i<>5 then disablectrl(2,i);

  myform.bigimage.picture.loadfromfile(dir+'pmp.bmp');

  bitblt(myform.bloc[0].image.canvas.handle,0,0,myform.form.width,myform.form.height-2,myform.bigimage.canvas.handle,468,1163,SRCCOPY);
  myform.bloc[0].image.refresh;

  myform.mousedn:=false;
  myform.clicked:=true;
  myform.move:=false;

  mouse:=tmouse.create;

  myform.timer.interval:=50;

  smsg.global:=false;
  smsg.lastmsg:='';
  smsg.count:=0;
  smsg.globmsg:='';

  doredraw;
  setwindowlong(myform.form.handle,gwl_exstyle,getwindowlong(myform.form.handle,gwl_exstyle) OR WS_EX_TOOLWINDOW);
  myform.form.show;
  if status.aotop then begin
    myform.aotop1.checked:=true;
    setwindowpos(myform.form.handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  end;

end;

function GetInfoStr:pstring;stdcall;
begin
  getinfostr:=@infostr;
end;


exports
  SkSendMessage index 1,
  SkMsg index 2,
  SkInit index 3,
  SkEnd index 4,
  SkGetInfo index 5,
  GetInfoStr index 6;

begin
  infostr:='Animated PMP skin using Red_Spider''s pictures';
end.
