{Unit qui porte bien son nom, il s'agit de l'unit
 qui syncronise toutes les autres dans ce fichu programme.
 Il s'agit donc vraiment de PMP, la boucle principale
 est contenue dans Domain et est appele par le thread
 MainLoop.Pas initialis dans PMPlayer.Dpr

 PMPlayer->Global
}

unit global;

interface
uses classes,forms,mloop;

const PMPVersion='1.72';
      PMPVersionLG=1 SHL 16+72;

{Structure de la configuration de pmp, sauve dans le registre}
type tsetup=record
  Freq:Byte;
  Stereo:Boolean;
  B16:Boolean;
  Device:Word;
  SepaStereo:Word;
  Ampli:Word;
  DeviceName:Array[0..31] Of ShortString;
  FreqConv:Array[0..15] Of Word;
  Devices:Array[0..31] Of LongInt;
  DeviceType:Array[0..31] Of Word;
  Reverb:Boolean;
  Surround:Boolean;
  AutoAmpli:Boolean;
  NModLoop:Byte;
  Replay:Boolean;
  Priority:TThreadPriority;
  Interpolation:Byte;
  TickRemove:Boolean;
  TailleBuffer:Byte;
  NBuffers:Word;
  Sature:Integer;
  VisFileName:ShortString;
  SkinFileName:ShortString;
  Volume:Integer;
  Pitch:Integer;
  Speed:Integer;
  PreBuff:Integer;
  CopyOnMove:Boolean;
  DeleteOnRemove:Boolean;
  Del_Nb:Byte;
  Del_Delay:LongWord;
  Del_Int:Byte;
  Sur_Nb:Byte;
  Sur_Delay:LongWord;
  Sur_Int:Byte;
  UseTimer:Boolean;
  TimerInterval:LongWord;
  TimerCount:LongWord;
  Accurate:Boolean;
  HighRefresh:Boolean;
end;

{Structure de la configuration interne  pmp, dynamique}
type tstatus=record
  InError:Boolean;
  IsPlaying:Boolean;
  IsPause:Boolean;
  Sature:Boolean;
  FileN:ShortString;
  InSetup:Boolean;
  Directory:ShortString;
  VisDirectory:ShortString;
  SkinDirectory:ShortString;
  SavePList:Boolean;
end;

{Sous-liste de la playlist}
type tsublist=record
  list:tstrings;
  name:string;
  current:longint;
end;

{Structure playlist}
type tplaylist=record
  sublist:array of tsublist;
  nblist:word;
  nlist:word;
  filename:string;
  oldnlist:word;
end;

{Configuration totale, status+config}
type tinfo=record
  Status:TStatus;
  Config:TSetup;
  PMPVersion:String;
  PMPVersionLG:LongWord;
end;

var globalinfo:tinfo;

    plist:tplaylist;

var isreadyform:array[1..32] of boolean;

var tmainloop:mainloop;

var newconfig:tsetup;
    newplist:tplaylist;

Var AppFin:Boolean;
    IsReadySkin:Boolean;

procedure receivemsg;
function loadproc(param:longint;var proc:pointer):boolean;
procedure finddevices;
procedure updatesetup(repl:boolean);
procedure playcurrent;
procedure stop;
procedure loadconfig;
procedure saveconfig;
procedure gopos(pos,note:byte);
procedure updatevisinfo;
procedure updateskininfo;
procedure playfile(f:string);
procedure regextensions;
function getdir(what:byte):string;
procedure loadplaylist(fle:string;var tolist:tplaylist);
procedure saveplaylist(list:tplaylist;fle:string);
procedure domain;
procedure zeroconfig;

implementation
uses realmain,setup,cnst,modunit,playlist,registry,select,info,sysutils,windows,comm,gui,graphs;

const per='waveOut';

function WaveOutGetNumDevs:Word;stdcall
external 'winmm.dll' name 'waveOutGetNumDevs';

function waveOutGetDevCaps(uDeviceID:Integer;LP:Pointer;cbwoc:Word):Word;stdcall
external 'winmm.dll' name 'waveOutGetDevCapsA';

type twoc=record
  wMid:Word;
  wPid:Word;
  vDriverVersion:LongWord;
  szPname:array[0..MaxPNameLen-1] of Char;
  dwFormats:LongWord;
  wChannels:Word;
  dwSupport:LongWord;
end;

{Cette procdure est appelle par Form9 quand elle reoit
 un message envoy par une autre scession de PMP}
procedure receivemsg;
var cmd,txt:string;
begin
  getmsg(cmd,txt);
  if cmd='File' then begin
    plist.nlist:=0;
    plist.sublist[0].current:=plist.sublist[0].list.add(txt);
    playcurrent;
    skin_sendmessage(msg_skin_redraw,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
  end;
  if cmd='Playlist' then begin
    plist.filename:=txt;
    LoadPlayList(txt,plist);
    playcurrent;
    skin_sendmessage(msg_skin_redraw,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
  end;
  if cmd='AddCurrent' then begin
    plist.sublist[plist.nlist].list.add(txt);
  end;
  if cmd='Add' then begin
    plist.sublist[0].list.add(txt);
  end;
end;

{Litralement : boucle principale de PMP. Cette boucle est
 appelle par le thread principal dfinit dans MainLoop.Pas}
procedure domain;
var i,j:integer;
begin
  If not globalinfo.config.usetimer then begin
    {Calcul du nombre de buffer  dcoder}
    J:=GetMod(19) Div 4+1;
    If J>10 Then J:=10;
    If J<1 Then J:=1;
    {Dcodage des buffers}
    For I:=1 To J Do DoMod;
  end;
  if getmod(24)<>0 then begin
    {Si Modunit signale qu'il est temps de passer  la musique
    suivante}
    inc(plist.sublist[plist.nlist].current);
    if plist.sublist[plist.nlist].current>=plist.sublist[plist.nlist].list.count then plist.sublist[plist.nlist].current:=0;
    playcurrent;
  end;
  {Animation de la skin}
  skin_sendmessage(msg_skin_anim,0);
end;

{Handler d'erreur, dont l'addresse est envoye  Modunit
 pour que ce dernier puisse signaler  PMP des erreurs
 ventuelles}
procedure ErrHandler(Err1,Err2:LongInt;Fatal:Boolean;Txt:String;From:Byte);
var ztxt:array[1..256] of char;
    i:integer;
begin
  if globalinfo.status.inerror then exit;
  globalinfo.status.inerror:=true;
  case from of
    (*origine : unit mod*)
    0:begin
      case err1 of
        (*file not found, corrupted*)
        1,2:begin
          if fatal then stop;
          skin_msg('Error',True);
          for i:=1 to length(txt) do ztxt[i]:=txt[i];
          ztxt[length(txt)+1]:=#0;
          application.messagebox(@ztxt,'Error',mb_iconerror);
          if globalinfo.status.isplaying then skin_msg('Playing',true) else skin_msg('Ready',true);
        end;
        (*saturation*)
        3:begin
          if globalinfo.config.autoampli then begin
            if err2>(GetMod(3)*globalinfo.Config.Sature Div 200) then begin
              if not globalinfo.status.insetup then begin
                skin_msg('Saturation',False);
                If GetMod(5)>0 Then ModOptions(5,GetMod(5)-1);
                globalinfo.Config.Ampli:=GetMod(5);
                globalinfo.Config.Volume:=GetMod(34);
                UpDateSetup(False);
                skin_sendmessage(msg_Skin_Redraw,0);
              end else begin;
                skin_msg('Saturation',False);
              end;
            end;
          end;
        end;
      end;
    end;
    (*origine : tsound*)
    1:begin
      if fatal then stop;
      skin_msg('Error',True);
      for i:=1 to length(txt) do ztxt[i]:=txt[i];
      ztxt[length(txt)+1]:=#0;
      application.messagebox(@ztxt,'Error',mb_iconerror);
      if globalinfo.status.isplaying then skin_msg('Playing',true) else skin_msg('Ready',true);
    end;
  end;
  globalinfo.status.inerror:=false;
end;

{Fonction qui retourne le rpertoire du programme, de
 la skin et de la vis}
function getdir(what:byte):string;
var t,r:string;
    i,j:integer;
begin
  case what of
    (*main prog*)
    1:begin
      t:=paramstr(0);
      i:=length(t);
      if i>0 then repeat dec(i) until t[i]='\';
      r:='';
      for j:=1 to i do r:=r+t[j];
      getdir:=r;
    end;
    (*skin*)
    2:begin
      t:=globalinfo.config.skinfilename;
      i:=length(t);
      if i>0 then repeat dec(i) until t[i]='\';
      r:='';
      for j:=1 to i do r:=r+t[j];
      getdir:=r;
    end;
    (*vis*)
    3:begin
      t:=globalinfo.config.visfilename;
      i:=length(t);
      if i>0 then repeat dec(i) until t[i]='\';
      r:='';
      for j:=1 to i do r:=r+t[j];
      getdir:=r;
    end;
  end;
end;

{Cette procdure modifie le registre afin d'enregistrer
 les extensions gres par pmp dans l'explorateur Windows}
procedure regextensions;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.rootkey:=HKEY_CLASSES_ROOT;

  if reg.KeyExists('.pmp') then reg.DeleteKey('.pmp');
  reg.openkey('.pmp',true);
  reg.writestring('','PMPlayerList');
  reg.writestring('Content Type','PMPlayerList');
  reg.closekey;
  if reg.KeyExists('.mod') then reg.DeleteKey('.mod');
  reg.openkey('.mod',true);
  reg.writestring('','PMPlayer');
  reg.writestring('Content Type','PMPlayer');
  reg.closekey;
  if reg.KeyExists('.s3m') then reg.DeleteKey('.s3m');
  reg.openkey('.s3m',true);
  reg.writestring('','PMPlayer');
  reg.writestring('Content Type','PMPlayer');
  reg.closekey;
  if reg.KeyExists('.xm') then reg.DeleteKey('.xm');
  reg.openkey('.xm',true);
  reg.writestring('','PMPlayer');
  reg.writestring('Content Type','PMPlayer');
  reg.closekey;


  if reg.keyexists('PMPlayer') then reg.deletekey('PMPlayer');
  reg.OpenKey('PMPlayer',True);
  reg.writestring('','Plouf''s ModPlayer module');
  reg.OpenKey('DefaultIcon',True);
  reg.writestring('',globalinfo.status.Directory+'pmplayer.exe,0');
  reg.closekey;

  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('shell',True);
  reg.OpenKey('open',true);
  reg.OpenKey('command',true);
  reg.writestring('',globalinfo.status.directory+'pmplayer.exe "%1"');
  reg.closekey;
  reg.closekey;

  if reg.keyexists('PMPlayerList') then reg.deletekey('PMPlayerList');
  reg.OpenKey('PMPlayerList',True);
  reg.writestring('','Plouf''s ModPlayer playlist');
  reg.OpenKey('DefaultIcon',True);
  reg.writestring('',globalinfo.status.Directory+'pmplayer.exe,0');
  reg.closekey;

  reg.OpenKey('PMPlayerList',True);
  reg.OpenKey('shell',True);
  reg.OpenKey('open',true);
  reg.OpenKey('command',true);
  reg.writestring('',globalinfo.status.directory+'pmplayer.exe /p "%1"');
  reg.closekey;
  reg.closekey;

  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('shell',True);
  reg.OpenKey('Add to current playlist',True);
  reg.OpenKey('command',true);
  reg.writestring('',globalinfo.status.directory+'pmplayer.exe /a "%1"');
  reg.closekey;
  reg.closekey;

  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('shell',True);
  reg.OpenKey('Add to "not in list"',True);
  reg.OpenKey('command',true);
  reg.writestring('',globalinfo.status.directory+'pmplayer.exe /n "%1"');
  reg.closekey;
  reg.closekey;

  reg.destroy;

end;

{Fonction appelle par PlayFile pour connaitre le nom
 du fichier .wav sous lequel le mod doit tre sauv}
function getfilen:string;
var txt,t:string;
    i,pos:word;
begin
  getfilen:='';
  txt:=plist.sublist[plist.nlist].list.strings[plist.sublist[plist.nlist].current];
  pos:=ansipos('.',txt);
  t:=txt;
  if pos<>0 then begin
    t:='';
    for i:=1 to pos-1 do t:=t+txt[i];
  end;
  t:=t+'.wav';
  form9.savedialog1.filename:=t;
  if form9.savedialog1.Execute then begin
    getfilen:=form9.savedialog1.FileName;
  end;
end;

{Cette procdure modifie la position actuelle du module}
procedure gopos(pos,note:byte);
begin
  if globalinfo.config.devicetype[globalinfo.Config.Device]=1 then begin
    stop;
    exit;
  end;
  if updatesoundconfig(globalinfo.config.devicetype[globalinfo.Config.Device],globalinfo.Config.Devices[globalinfo.Config.Device],globalinfo.config.freqconv[globalinfo.config.freq],globalinfo.config.stereo,globalinfo.config.b16,pos,note,globalinfo.status.filen,globalinfo.config.prebuff/1000,form9.handle) then begin
    if globalinfo.status.ispause then modoptions(7,1);
    updatesetup(false);
  end else begin
    stop;
  end;
end;

{Cette procdure rinitialise la carte son par exemple
 aprs une modification dans le setup qui l'exige}
procedure replay;
var note,pos:byte;
begin
  if globalinfo.status.isplaying then begin
    if globalinfo.config.accurate then note:=getmod(7) else note:=1;
    pos:=getmod(8);
    gopos(pos,note);
  end;
end;

{Routine de convertion des formats de playlist}
procedure convert(from:integer;fle:string);
var f,t:text;
    txt:string;
    i,n:longword;
    var bid:array[0..255] of char;
begin
  case from of
    1:begin
      assign(f,fle);
      reset(f);
      assign(t,'c:\pmplayer.tmp');
      rewrite(t);
      readln(f,txt);
      writeln(t,'PMPList02');

      writeln(t,1);
      writeln(t,0);  (*current playlist*)

      writeln(t,fle);
      readln(f,n);
      writeln(t,n);
      writeln(t,0); (*current file*)
      for i:=1 to n do begin
        readln(f,txt);
        writeln(t,txt);
      end;
      close(f);
      close(t);
      erase(f);
      copyfile('c:\pmplayer.tmp',strpcopy(bid,fle),false);
      erase(t);
    end;
  end;
end;

{fonction qui vrifie si le fichier Fle est un fichier
 playlist valide}
function verifyplaylistformat(fle:string):boolean;
Var f:text;
    t:string;
begin
  {$i-}
  verifyplaylistformat:=false;
  assign(f,fle);
  reset(f);
  if ioresult=0 then begin
    readln(f,t);
    close(f);
    if ioresult=0 then begin
      if t='PMPList01' then begin
        if application.messagebox('This is an old playlist file version.'+#13+'PMP can convert it to the new version.'+#13+'Convert it now?','Old version',mb_yesno or MB_ICONQUESTION)=id_yes then begin
          convert(1,fle);
          verifyplaylistformat:=true;
        end;
      end;
      if t='PMPList02' then begin
        verifyplaylistformat:=true;
      end;
    end;
  end;
  {$i+}
end;

{Sauvegarde de la playlist List dans le fichier Fle}
procedure saveplaylist(list:tplaylist;fle:string);
Var f:text;
    i:integer;
    il:integer;
begin
  assign(f,fle);
  {$i-}
  rewrite(f);
  if ioresult<>0 then exit;
  writeln(f,'PMPList02');
  if ioresult<>0 then exit;
  writeln(f,list.nblist);
  writeln(f,list.nlist);

  for il:=1 to list.nblist do begin
    writeln(f,list.sublist[il].name);
    writeln(f,list.sublist[il].list.count);
    writeln(f,list.sublist[il].current);
    for i:=0 to list.sublist[il].list.count-1 do writeln(f,list.sublist[il].list.strings[i]);
  end;
  close(f);
  {$i+}
end;

{Chargement de la playlist Fle dans la liste ToList}
procedure loadplaylist(fle:string;var tolist:tplaylist);

Var f:text;
    i,n:integer;
    il:integer;
    t:string;
    p:array[0..255] of char;
begin
  {$i-}
  if fle='' then exit;
  strpcopy(p,'Unable to load playlist '+fle);
  if not verifyplaylistformat(fle) then begin
    application.MessageBox(p,'Error',MB_ICONERROR);
    exit;
  end;
  assign(f,fle);
  reset(f);
  if ioresult=0 then begin
    readln(f,t);
    if ioresult=0 then begin
      readln(f,tolist.nblist);
      setlength(tolist.sublist,tolist.nblist+1);
      readln(f,tolist.nlist);
      for il:=1 to tolist.nblist do begin
        tolist.sublist[il].list:=TStringList.Create;
        tolist.sublist[il].list.clear;
        readln(f,tolist.sublist[il].name);
        readln(f,n);
        readln(f,tolist.sublist[il].current);
        for i:=0 to n-1 do begin
          readln(f,t);
          tolist.sublist[il].list.add(t);
        end;
      end;
    end;
    close(f);
  end;
  {$i+}
end;

{Cette procdure vrifie que toutes les entres du registre
 o PMP va sauver sa configuration sont bien prsentes, et
 les cre avec des valeurs par dfaut si tel n'est pas le
 cas}
procedure verifconfig;
var reg:tregistry;
    prio:tthreadpriority;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  reg.OpenKey('PMPlayer',True);
  if not reg.valueexists('Frequency') Then reg.WriteInteger('Frequency',2);
  if not reg.valueexists('Stereo') then reg.WriteBool('Stereo',True);
  if not reg.valueexists('16Bits') then reg.WriteBool('16Bits',True);
  if not reg.valueexists('DeviceIndex') then reg.WriteInteger('DeviceIndex',0);
  if not reg.valueexists('SepaStereo') then reg.WriteInteger('SepaStereo',3);
  if not reg.valueexists('Surround') then reg.WriteBool('Surround',True);
  if not reg.valueexists('Reverb') then reg.WriteBool('Reverb',True);
  if not reg.valueexists('Ampli') then reg.WriteInteger('Ampli',0);
  if not reg.valueexists('AutoAmpli') then reg.WriteBool('AutoAmpli',True);
  if not reg.valueexists('NModLoop') then reg.WriteInteger('NModLoop',0);
  if not reg.valueexists('PListFileName') then reg.WriteString('PListFileName','');
  if not reg.valueexists('Replay') then reg.WriteBool('Replay',False);
  if not reg.valueexists('Volume') then reg.WriteInteger('Volume',128);
  if not reg.valueexists('Pitch') then reg.WriteInteger('Pitch',128);
  if not reg.valueexists('Speed') then reg.WriteInteger('Speed',128);
  prio:=tpidle;
  if not reg.valueexists('Priority') then reg.WriteBinaryData('Priority',prio,2);
  if not reg.valueexists('Interpolation') then reg.writeinteger('Interpolation',1);
  if not reg.valueexists('TickRemove') then reg.writebool('TickRemove',True);
  if not reg.valueexists('TailleBuffer') then reg.writeinteger('TailleBuffer',11);
  if not reg.valueexists('NBuffers') then reg.writeinteger('NBuffers',128);
  if not reg.valueexists('Sature') then reg.writeinteger('Sature',30);
  if not reg.valueexists('VisFileName') then reg.WriteString('VisFileName','');
  if not reg.valueexists('SkinFileName') then reg.WriteString('SkinFileName','');
  if not reg.valueexists('PreBuff') then reg.WriteInteger('PreBuff',500);
  if not reg.valueexists('CopyOnMove') then reg.WriteBool('CopyOnMove',False);
  if not reg.valueexists('DeleteOnRemove') then reg.WriteBool('DeleteOnRemove',False);
  if not reg.valueexists('Del_Nb') then reg.writeinteger('Del_Nb',1);
  if not reg.valueexists('Del_Delay') then reg.writeinteger('Del_Delay',10000);
  if not reg.valueexists('Del_Int') then reg.writeinteger('Del_Int',6);
  if not reg.valueexists('Sur_Nb') then reg.writeinteger('Sur_Nb',1);
  if not reg.valueexists('Sur_Delay') then reg.writeinteger('Sur_Delay',5000);
  if not reg.valueexists('Sur_Int') then reg.writeinteger('Sur_Int',6);
  if not reg.valueexists('UseTimer') then reg.writebool('UseTimer',False);
  if not reg.valueexists('TimerInterval') then reg.writeinteger('TimerInterval',50);
  if not reg.valueexists('TimerCount') then reg.writeinteger('TimerCount',10);
  if not reg.valueexists('Accurate') then reg.writebool('Accurate',false);
  if not reg.valueexists('HighRefresh') then reg.writebool('HighRefresh',true);

  reg.CloseKey;
  reg.Destroy;
end;

{Cette procdure charge la configuration depuis le registre}
procedure loadconfig;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  verifconfig;
  reg.openkey('PMPlayer',False);
  globalinfo.config.freq:=reg.readinteger('Frequency');
  globalinfo.config.stereo:=reg.readbool('Stereo');
  globalinfo.config.b16:=reg.readBool('16Bits');
  globalinfo.config.device:=reg.readInteger('DeviceIndex');
  globalinfo.config.sepastereo:=reg.readInteger('SepaStereo');
  globalinfo.config.surround:=reg.readBool('Surround');
  globalinfo.config.reverb:=reg.readBool('Reverb');
  globalinfo.config.ampli:=reg.readInteger('Ampli');
  globalinfo.config.autoampli:=reg.readBool('AutoAmpli');
  globalinfo.config.nmodloop:=reg.readInteger('NModLoop');
  plist.filename:=reg.readString('PListFileName');
  globalinfo.config.replay:=reg.readbool('Replay');
  globalinfo.config.volume:=reg.readInteger('Volume');
  globalinfo.config.pitch:=reg.readInteger('Pitch');
  globalinfo.config.speed:=reg.readInteger('Speed');
  reg.readbinarydata('Priority',globalinfo.config.priority,2);
  globalinfo.config.interpolation:=reg.readinteger('Interpolation');
  globalinfo.config.tickremove:=reg.readbool('TickRemove');
  globalinfo.config.TailleBuffer:=reg.readinteger('TailleBuffer');
  globalinfo.config.nbuffers:=reg.readinteger('NBuffers');
  globalinfo.config.sature:=reg.readinteger('Sature');
  globalinfo.config.visfilename:=reg.readstring('VisFileName');
  globalinfo.config.skinfilename:=reg.readstring('SkinFileName');
  globalinfo.config.prebuff:=reg.readinteger('PreBuff');
  globalinfo.config.copyonmove:=reg.readbool('CopyOnMove');
  globalinfo.config.deleteonremove:=reg.readbool('DeleteOnRemove');
  globalinfo.config.del_nb:=reg.readinteger('Del_Nb');
  globalinfo.config.del_delay:=reg.readinteger('Del_Delay');
  globalinfo.config.del_int:=reg.readinteger('Del_Int');
  globalinfo.config.sur_nb:=reg.readinteger('Sur_Nb');
  globalinfo.config.sur_delay:=reg.readinteger('Sur_Delay');
  globalinfo.config.sur_int:=reg.readinteger('Sur_Int');
  globalinfo.config.usetimer:=reg.readbool('UseTimer');
  globalinfo.config.timerinterval:=reg.readinteger('TimerInterval');
  globalinfo.config.timercount:=reg.readinteger('TimerCount');
  globalinfo.config.accurate:=reg.readbool('Accurate');
  globalinfo.config.highrefresh:=reg.readbool('HighRefresh');

  reg.CloseKey;
  reg.Destroy;
end;

{Cette procdure sauve la configuration de PMP dans le registre}
procedure saveconfig;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  verifconfig;
  reg.OpenKey('PMPlayer',False);
  reg.WriteInteger('Frequency',globalinfo.config.freq);
  reg.WriteBool('Stereo',globalinfo.config.stereo);
  reg.WriteBool('16Bits',globalinfo.config.b16);
  reg.WriteInteger('DeviceIndex',globalinfo.config.device);
  reg.WriteInteger('SepaStereo',globalinfo.config.sepastereo);
  reg.WriteBool('Surround',globalinfo.config.surround);
  reg.WriteBool('Reverb',globalinfo.config.reverb);
  reg.WriteInteger('Ampli',globalinfo.config.ampli);
  reg.WriteBool('AutoAmpli',globalinfo.config.autoampli);
  reg.WriteInteger('NModLoop',globalinfo.config.nmodloop);
  reg.WriteString('PListFileName',plist.filename);
  reg.WriteBool('Replay',globalinfo.config.replay);
  reg.WriteInteger('Volume',globalinfo.config.volume);
  reg.WriteInteger('Pitch',globalinfo.config.pitch);
  reg.WriteInteger('Speed',globalinfo.config.speed);
  reg.writebinarydata('Priority',globalinfo.config.priority,2);
  reg.writeinteger('Interpolation',globalinfo.config.interpolation);
  reg.writebool('TickRemove',globalinfo.config.tickremove);
  reg.writeinteger('TailleBuffer',globalinfo.config.taillebuffer);
  reg.writeinteger('NBuffers',globalinfo.config.nbuffers);
  reg.writeinteger('Sature',globalinfo.config.sature);
  reg.writestring('VisFileName',globalinfo.config.visfilename);
  reg.writestring('SkinFileName',globalinfo.config.skinfilename);
  reg.writeinteger('PreBuff',globalinfo.config.prebuff);
  reg.writebool('CopyOnMove',globalinfo.config.copyonmove);
  reg.writebool('DeleteOnRemove',globalinfo.config.deleteonremove);
  reg.writeinteger('Del_Nb',globalinfo.config.del_nb);
  reg.writeinteger('Del_Delay',globalinfo.config.del_delay);
  reg.writeinteger('Del_Int',globalinfo.config.del_int);
  reg.writeinteger('Sur_Nb',globalinfo.config.sur_nb);
  reg.writeinteger('Sur_Delay',globalinfo.config.sur_delay);
  reg.writeinteger('Sur_Int',globalinfo.config.sur_int);
  reg.writebool('UseTimer',globalinfo.config.usetimer);
  reg.writeinteger('TimerInterval',globalinfo.config.timerinterval);
  reg.writeinteger('TimerCount',globalinfo.config.timercount);
  reg.writebool('Accurate',globalinfo.config.accurate);
  reg.writebool('HighRefresh',globalinfo.config.highrefresh);
  reg.CloseKey;
  reg.Destroy;
end;

{Cette procdure efface le rpertoire de PMP dans le registre}
procedure zeroconfig;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  if reg.KeyExists('PMPlayer') then reg.DeleteKey('PMPlayer');
  reg.CloseKey;
  reg.Destroy;
end;

{Procdure qui arrte le dcodage du mod en cours}
procedure stop;
begin
  if globalinfo.status.isplaying then begin
    skin_msg('Stoping...',False);
    globalinfo.status.isplaying:=false;
    globalinfo.status.ispause:=false;
    uninitmod;
    skin_sendmessage(msg_skin_stop,0);
    skin_msg('Ready',True);
  end;
end;

{On appelle cette procdure pour charger et jouer un
 fichier F}
procedure playfile(f:string);
begin
  stop;
  if globalinfo.config.devicetype[globalinfo.Config.Device]=1 then begin
    globalinfo.status.filen:=getfilen;
    if globalinfo.status.filen='' then exit;
  end;
  skin_msg('Loading mod...',False);
  if initmod(f,ErrHandler,globalinfo.Config.FreqConv[globalinfo.Config.Freq],globalinfo.Config.Stereo,globalinfo.Config.B16,globalinfo.Config.devicetype[globalinfo.Config.Device],globalinfo.Config.Devices[globalinfo.Config.Device],globalinfo.Config.AutoAmpli,globalinfo.Config.NModLoop,globalinfo.Status.FileN,globalinfo.Config.PreBuff/1000,form9.handle) then begin
    if globalinfo.config.autoampli then begin
      globalinfo.config.ampli:=getmod(5);
      skin_sendmessage(msg_skin_redraw,0);
    end;
    prepareinfo;
    globalinfo.status.isplaying:=true;
    globalinfo.status.ispause:=false;
    skin_sendmessage(msg_skin_play,0);
    skin_msg('Playing',True);
  end;
end;

{Joue le fichier actif dans la playlist}
procedure playcurrent;
var cn,cu:longword;
begin
  cn:=plist.sublist[plist.nlist].list.count;
  cu:=plist.sublist[plist.nlist].current;
  if (cn>0) and (cu<cn) then playfile(plist.sublist[plist.nlist].list.strings[plist.sublist[plist.nlist].current]) else stop;
end;

{Recherche tous les priphriques son disponibles sur
 le systme, et sauve cette liste dans le status ainsi
 que sur la fentre du setup}
procedure finddevices;
var index,j,n:word;
    k:integer;
    woc:twoc;
    t:string;
begin
  form2.combobox1.items.clear;
  n:=WaveOutGetNumDevs;
  k:=-1;
  (*trouver les devices du wavemapper*)
  repeat
    if waveOutGetDevCaps(k,@woc,sizeof(woc))=0 then begin
      t:='';
      j:=0;
      while (not (woc.szPname[j]=#0)) and (j<32) do begin
        t:=t+woc.szpname[j];
        inc(j);
      end;
      index:=form2.combobox1.items.add(t);
      globalinfo.config.devices[index]:=k;
      globalinfo.config.devicetype[index]:=0;
      globalinfo.config.devicename[index]:=t;
    end;
    inc(k);
  until k=n;
  (*le disque dur*)
  index:=form2.combobox1.items.add('Save to wav');
  globalinfo.config.devices[index]:=0;
  globalinfo.config.devicetype[index]:=1;
  globalinfo.config.devicename[index]:='Save to wav';
  (*dsound*)
  index:=form2.combobox1.items.add('Direct Sound');
  globalinfo.config.devices[index]:=0;
  globalinfo.config.devicetype[index]:=2;
  globalinfo.config.devicename[index]:='Direct Sound';
end;

{Mes  jour la configuration de pmp aprs une modification
 de celle-ci}
procedure updatesetup(repl:boolean);
begin
  if globalinfo.config.Reverb then modoptions(1,1) else modoptions(1,0);
  if globalinfo.config.Surround then modoptions(2,1) else modoptions(2,0);
  modoptions(6,globalinfo.config.sepastereo);
  modoptions(5,globalinfo.config.ampli);
  modoptions(8,globalinfo.config.nmodloop);
  modoptions(10,globalinfo.config.interpolation);
  modoptions(12,1 shl globalinfo.config.taillebuffer);
  modoptions(13,globalinfo.config.nbuffers);
  modoptions(14,globalinfo.Config.Volume);
  modoptions(15,globalinfo.config.pitch);
  modoptions(16,globalinfo.config.speed);

  modoptions(17,globalinfo.Config.Del_Nb);
  modoptions(18,globalinfo.Config.Del_Delay);
  modoptions(19,globalinfo.Config.Del_Int);
  modoptions(20,globalinfo.Config.Sur_Nb);
  modoptions(21,globalinfo.Config.Sur_Delay);
  modoptions(22,globalinfo.Config.Sur_Int);

  if globalinfo.config.tickremove then modoptions(11,1) else modoptions(11,0);

  form9.timer1.interval:=globalinfo.config.timerinterval;
  form9.timer1.enabled:=globalinfo.config.usetimer;

  tmainloop.Priority :=globalinfo.config.priority;
  if tmainloop.Suspended and globalinfo.config.HighRefresh then tmainloop.resume;
  if not tmainloop.Suspended and not globalinfo.config.HighRefresh then tmainloop.Suspend;


  if repl then begin
    replay;
    if globalinfo.status.isplaying then skin_msg('Device reset',False);
  end;
end;

{Cette procdure modifie le contenu du setup et refresh
 la partie d'information du le plug-in de visualisation}
procedure updatevisinfo;
type pinfo=function:pstring;
var handle:integer;
    info:pinfo;
    t:string;
begin
  t:=newconfig.visfilename+#0;
  handle:=loadlibrary(@t[1]);
  form2.label14.caption:='Not a PMP vis plugin';
  if handle<>0 then begin
    @info:=getprocaddress(handle,'GetInfoStr');
    if @info<>nil then form2.label14.caption:=info^;
    freelibrary(handle);
  end;
end;

{Cette procdure modifie le contenu du setup et refresh
 la partie d'information de la dll skin}
procedure updateskininfo;
type pinfo=function:pstring;
var handle:integer;
    info:pinfo;
    t:string;
begin
  t:=newconfig.skinfilename+#0;
  handle:=loadlibrary(@t[1]);
  form2.label25.caption:='Not a PMP vis plugin';
  if handle<>0 then begin
    @info:=getprocaddress(handle,'GetInfoStr');
    if @info<>nil then form2.label25.caption:=info^;
    freelibrary(handle);
  end;
end;

{Procdure LoadProc bien connue des programmeurs de skin
 et de plug-ins}
function loadproc(param:longint;var proc:pointer):boolean;
begin
  loadproc:=true;
  case param of
    addr_mod_getmod:proc:=@GetMod;
    addr_mod_getmods:proc:=@GetModS;
    addr_mod_getpattern:proc:=@GetPattern;
    addr_mod_getpatterns:proc:=@GetPatternS;
    addr_mod_getinstrs:proc:=@GetInstrS;
    addr_mod_getsmpls:proc:=@GetSmplS;
    addr_mod_getstringmod:proc:=@GetStringMod;
    addr_vis_newplay:proc:=@graphs.newplay;
    addr_vis_initdc:proc:=@graphs.initdc;
    addr_vis_uninitdc:proc:=@graphs.uninitdc;
    addr_vis_dodc:proc:=@graphs.dodc;
    addr_vis_cleandc:proc:=@graphs.cleandc;
    addr_vis_initpatt:proc:=@graphs.initpatt;
    addr_vis_uninitpatt:proc:=@graphs.uninitpatt;
    addr_vis_dopatt:proc:=@graphs.dopatt;
    addr_vis_cleanpatt:proc:=@graphs.cleanpatt;
    addr_vis_getvisinfo:proc:=@graphs.getvisinfo;
    addr_vis_initgraphs:proc:=@graphs.initgraphs;
    addr_vis_endgraphs:proc:=@graphs.endgraphs;
    addr_vis_setupvis:proc:=@graphs.setupvis;
    addr_vis_setuppattern:proc:=@graphs.setuppattern;

    addr_gui_sendmessage:proc:=@gui.gui_sendmessage;
    addr_gui_getinfo:proc:=@gui.gui_getinfo;
    addr_gui_getinfos:proc:=@gui.gui_getinfos;
    addr_gui_setplaylist:proc:=@gui.gui_setplaylist;
    addr_gui_getplaylist:proc:=@gui.gui_getplaylist;
    addr_gui_setinfo:proc:=@gui.gui_setinfo;

    else loadproc:=false;
  end;
end;

begin
  globalinfo.config.freqconv[0]:=11025;
  globalinfo.config.freqconv[1]:=22050;
  globalinfo.config.freqconv[2]:=44100;
  globalinfo.config.freqconv[3]:=48000;
  globalinfo.status.IsPlaying:=false;
  globalinfo.status.IsPause:=false;
  globalinfo.status.sature:=false;
  globalinfo.status.filen:='';
  globalinfo.PMPVersion:=PMPVersion;
  globalinfo.PMPVersionLG:=PMPVersionLG;
  globalinfo.status.insetup:=false;
  globalinfo.status.isplaying:=false;
  Globalinfo.status.InError:=false;

  setlength(plist.sublist,1);
  plist.nblist:=0;
  plist.nlist:=0;
  plist.sublist[0].current:=0;
  plist.sublist[0].name:='Not in list';
  plist.sublist[0].list:=TStringList.Create;

  IsReadySkin:=False;
end.
