unit newutils;

interface

function nfileopen(f:string):longword;
procedure nfileread(handle:longword;pnt:pointer;count:longword;var lu:longword);
procedure nfileclose(handle:longword);
function fileposit(handle:longword):longword;
procedure nfileseek(handle:longword;count:longint);
function GetLastError:LongWord;stdcall;
external 'kernel32.dll' name 'GetLastError';

implementation
uses cnst;

function dfilecreate(lpFileName:Pointer;dwDesiredAccess,dwShareMode:LongWord;lpSecurityAttributes:Pointer;dwCreationDistribution,dwFlagsAndAttributes:LongWord;hTemplateFile:Pointer):LongWord;stdcall;
external 'kernel32.dll' name 'CreateFileA';

function dreadfile(handle:longword;buff:pointer;count:longword;toread,overlap:pointer):Boolean;stdcall;
external 'kernel32.dll' name 'ReadFile';

function dclosehandle(handle:longword):Boolean;stdcall;
external 'kernel32.dll' name 'CloseHandle';

function dsetfilepointer(handle:longword;Count:LongInt;High:Pointer;dwMoveMethod:LongWord):LongWord;stdcall;
external 'kernel32.dll' name 'SetFilePointer';


function nfileopen(f:string):longword;
var nf:array[1..255] of byte;
    i:byte;
begin
  for i:=1 to length(f) do nf[i]:=Ord(f[i]);
  nf[length(f)+1]:=0;
  nfileopen:=dfilecreate(@nf,GENERIC_READ,FILE_SHARE_READ,Nil,OPEN_EXISTING,0,Nil);
end;

procedure nfileread(handle:longword;pnt:pointer;count:longword;var lu:longword);
begin
  dreadfile(handle,pnt,count,@lu,Nil);
end;

procedure nfileclose(handle:longword);
begin
  dclosehandle(handle);
end;

function fileposit(handle:longword):longword;
Begin
  fileposit:=dsetfilepointer(handle,0,Nil,FILE_CURRENT);
End;

procedure nfileseek(handle:longword;count:longint);
Begin
  dsetfilepointer(handle,count,Nil,FILE_BEGIN);
End;

end.
