unit setup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    Label1: TLabel;
    ComboBox4: TComboBox;
    CheckBox2: TCheckBox;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    CheckBox3: TCheckBox;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Edit1: TEdit;
    ComboBox2: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    TrackBar2: TTrackBar;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    TabSheet3: TTabSheet;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    Button4: TButton;
    Label14: TLabel;
    Label15: TLabel;
    TabSheet4: TTabSheet;
    Label20: TLabel;
    Edit2: TEdit;
    Label21: TLabel;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Image1: TImage;
    Label22: TLabel;
    Label16: TLabel;
    Label19: TLabel;
    ScrollBar2: TScrollBar;
    ScrollBar1: TScrollBar;
    Label17: TLabel;
    Label18: TLabel;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Label23: TLabel;
    Button6: TButton;
    Label24: TLabel;
    Label25: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    ComboBox3: TComboBox;
    ComboBox5: TComboBox;
    Edit3: TEdit;
    ComboBox6: TComboBox;
    Edit4: TEdit;
    ComboBox7: TComboBox;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    CheckBox8: TCheckBox;
    Edit5: TEdit;
    Edit6: TEdit;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    CheckBox9: TCheckBox;
    Bevel1: TBevel;
    CheckBox10: TCheckBox;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ComboBox7Change(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure Edit6Exit(Sender: TObject);
    procedure Label36Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure preparesetup;

var
  Form2: TForm2;
implementation

uses global, gui;

var needreplay:boolean;
    newskin,newvis:boolean;

{$R *.DFM}

procedure preparesetup;
var t:string;
begin
  newconfig:=globalinfo.config;
  needreplay:=false;
  newskin:=false;
  newvis:=false;
  form2.combobox4.itemindex:=globalinfo.config.freq;
  form2.combobox1.itemindex:=globalinfo.config.device;
  form2.checkbox2.checked:=globalinfo.config.B16;
  form2.checkbox1.checked:=globalinfo.config.stereo;
  form2.checkbox3.checked:=globalinfo.config.autoampli;
  if globalinfo.config.interpolation<>0 then form2.checkbox4.checked:=true else form2.checkbox4.checked:=false;
  form2.checkbox5.checked:=globalinfo.config.tickremove;
  finddevices;
  form2.combobox1.itemindex:=globalinfo.config.device;
  case globalinfo.config.priority of
    tpidle:form2.TrackBar1.position:=1;
    tplowest:form2.TrackBar1.position:=2;
    tplower:form2.TrackBar1.position:=3;
    tpnormal:form2.TrackBar1.position:=4;
    tphigher:form2.TrackBar1.position:=5;
    tphighest:form2.TrackBar1.position:=6;
    tptimecritical:form2.TrackBar1.position:=7;
  end;
  form2.trackbar2.position:=10-(globalinfo.config.sature div 10);

  form2.combobox2.itemindex:=globalinfo.config.TailleBuffer-11;
  str(globalinfo.config.nbuffers,t);
  form2.edit1.text:=t;
  form2.label13.caption:=globalinfo.config.VisFileName;
  form2.label23.caption:=globalinfo.config.SkinFileName;
  updatevisinfo;
  updateskininfo;
  form2.scrollbar1.position:=globalinfo.config.pitch;
  str(globalinfo.config.pitch*100 div 128,t);
  form2.label17.caption:=t+'%';
  form2.scrollbar2.position:=globalinfo.config.speed;
  str(globalinfo.config.speed*100 div 128,t);
  form2.label18.caption:=t+'%';

  str(globalinfo.config.prebuff,t);
  form2.edit2.text:=t;

  form2.checkbox6.checked:=newconfig.copyonmove;
  form2.checkbox7.checked:=newconfig.deleteonremove;

  form2.combobox3.itemindex:=globalinfo.config.del_nb-1;
  form2.combobox5.itemindex:=globalinfo.config.del_int-1;
  str(globalinfo.config.del_delay/1000:4:4,t);
  form2.edit3.text:=t;

  form2.combobox6.itemindex:=globalinfo.config.sur_nb-1;
  form2.combobox7.itemindex:=globalinfo.config.sur_int-1;
  str(globalinfo.config.sur_delay/1000:4:4,t);
  form2.edit4.text:=t;

  form2.checkbox8.checked:=globalinfo.config.usetimer;
  form2.edit5.enabled:=globalinfo.config.usetimer;
  form2.edit6.enabled:=globalinfo.config.usetimer;

  str(globalinfo.config.timerinterval,t);
  form2.edit5.text:=t;
  str(globalinfo.config.timercount,t);
  form2.edit6.text:=t;

  form2.checkbox9.checked:=globalinfo.config.accurate;
  form2.checkbox10.checked:=globalinfo.config.highrefresh;
  form2.trackbar1.enabled:=form2.checkbox10.Checked;
  form2.checkbox8.enabled:=form2.checkbox10.Checked;

  needreplay:=false;
end;


procedure calcduree;
var t:string;
    dble:double;
begin
  dble:=newconfig.nbuffers;
  dble:=dble*(1 shl newconfig.taillebuffer);
  dble:=dble*1000/newconfig.Freqconv[newconfig.freq];
  if newconfig.stereo then dble:=dble/2;
  if newconfig.b16 then dble:=dble/2;
  if dble<1000 then begin
    str(dble:10:0,t);
    form2.label8.caption:=t+'ms';
  end else begin
    if dble<1000*60 then begin
      str((dble/1000):10:3,t);
      form2.label8.caption:=t+'s';
    end else begin
      str((dble/60000):10:3,t);
      form2.label8.caption:=t+'min';
    end;
  end;

end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  globalinfo.config:=newconfig;
  updatesetup(needreplay);
  if newvis then begin
    skin_sendmessage(msg_skin_endgraphs,0);
    skin_sendmessage(msg_skin_initgraphs,0);
    newvis:=false;
  end;
  if newskin then begin
    skin_end;
    skin_init(loadproc);
    skin_sendmessage(msg_skin_initgraphs,0);
    skin_sendmessage(msg_skin_entermenu,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_disable);
    skin_sendmessage(msg_skin_redraw,0);
    if globalinfo.status.isplaying then skin_sendmessage(msg_skin_play,0);
    newskin:=false;
    form2.setfocus;
  end;

  needreplay:=false;
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
(*  skin_getwindowhandle.enabled:=true;*)
  form2.hide;
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
(*  skin_getwindowhandle.setfocus;*)
  globalinfo.status.insetup:=false;
end;

procedure TForm2.ComboBox4Change(Sender: TObject);
begin
  needreplay:=true;
  newconfig.freq:=combobox4.ItemIndex;
  calcduree;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
  needreplay:=true;
  newconfig.device:=combobox1.ItemIndex;
end;

procedure TForm2.CheckBox2Click(Sender: TObject);
begin
  needreplay:=true;
  newconfig.b16:=checkbox2.Checked;
  calcduree;
end;

procedure TForm2.CheckBox1Click(Sender: TObject);
begin
  needreplay:=true;
  newconfig.stereo:=checkbox1.Checked;
  calcduree;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  globalinfo.config:=newconfig;
  updatesetup(needreplay);
  if newvis then begin
    skin_sendmessage(msg_skin_endgraphs,0);
    skin_sendmessage(msg_skin_initgraphs,0);
    newvis:=false;
  end;
  if newskin then begin
    skin_end;
    skin_init(loadproc);
    skin_sendmessage(msg_skin_initgraphs,0);
    skin_sendmessage(msg_skin_entermenu,0);
    skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_disable);
    skin_sendmessage(msg_skin_redraw,0);
    if globalinfo.status.isplaying then skin_sendmessage(msg_skin_play,0);
    newskin:=false;
    form2.setfocus;
  end;
  needreplay:=false;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
(*  cancelsetup;*)
(*  skin_getwindowhandle.enabled:=true;*)
  skin_sendmessage(msg_skin_leavemenu,0);
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_enable);
  form2.hide;
(*  skin_getwindowhandle.setfocus;*)
  skin_sendmessage(msg_skin_setwindow,msg_skin_setwindow_bringtotop);
  globalinfo.status.insetup:=false;
end;

procedure TForm2.CheckBox3Click(Sender: TObject);
begin
  newconfig.autoampli:=checkbox3.Checked;
end;

procedure TForm2.TrackBar1Change(Sender: TObject);
begin
  case trackbar1.position of
    1:newconfig.priority:=tpidle;
    2:newconfig.priority:=tplowest;
    3:newconfig.priority:=tplower;
    4:newconfig.priority:=tpnormal;
    5:newconfig.priority:=tphigher;
    6:newconfig.priority:=tphighest;
    7:newconfig.priority:=tptimecritical;
  end;
end;

procedure TForm2.CheckBox4Click(Sender: TObject);
begin
  if checkbox4.checked then newconfig.interpolation:=1 else newconfig.interpolation:=0;
end;

procedure TForm2.CheckBox5Click(Sender: TObject);
begin
  newconfig.tickremove:=checkbox5.checked;
end;

procedure TForm2.Edit1Change(Sender: TObject);
var bid:integer;
begin
  val(edit1.text,newconfig.nbuffers,bid);
  if newconfig.nbuffers<2 then newconfig.nbuffers:=2;
  calcduree;
  needreplay:=true;
end;

procedure TForm2.ComboBox2Change(Sender: TObject);
begin
  needreplay:=true;
  newconfig.taillebuffer:=combobox2.ItemIndex+11;
  calcduree;
end;

procedure TForm2.Edit1Exit(Sender: TObject);
var bid:integer;
    t:string;
begin
  val(edit1.text,newconfig.nbuffers,bid);
  if newconfig.nbuffers<2 then newconfig.nbuffers:=2;
  str(newconfig.nbuffers,t);
  edit1.text:=t;
  calcduree;
end;

procedure TForm2.TrackBar2Change(Sender: TObject);
begin
  newconfig.sature:=100-trackbar2.position*10;
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  if opendialog1.Execute then begin
    label13.caption:=opendialog1.filename;
    newconfig.visfilename:=label13.caption;
    updatevisinfo;
    newvis:=true;
  end;
end;

procedure TForm2.ScrollBar1Change(Sender: TObject);
var t:string;
begin
  if (scrollbar1.position>120) and (scrollbar1.position<136) then begin
    newconfig.pitch:=128;
    scrollbar1.position:=128;
  end else begin
    newconfig.pitch:=scrollbar1.position;
  end;
  str(newconfig.pitch*100 div 128,t);
  label17.caption:=t+'%';
end;

procedure TForm2.ScrollBar2Change(Sender: TObject);
var t:string;
begin
  if (scrollbar2.position>120) and (scrollbar2.position<136) then begin
    newconfig.speed:=128;
    scrollbar2.position:=128;
  end else begin
    newconfig.speed:=scrollbar2.position;
  end;
  str(newconfig.speed*100 div 128,t);
  label18.caption:=t+'%';
end;

procedure TForm2.Button5Click(Sender: TObject);
begin
  regextensions;
end;

procedure TForm2.Edit2Exit(Sender: TObject);
var bid:integer;
    t:string;
begin
  val(edit2.text,newconfig.prebuff,bid);
  str(newconfig.prebuff,t);
  edit2.text:=t;
  val(edit2.text,newconfig.prebuff,bid);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  pagecontrol1.activepage:=tabsheet1;
  label22.caption:='Plouf''s ModPlayer V'+PMPVersion+#13+'Detournay Philippe 1999'+#13+'Mail : theplouf@yahoo.com'+#13+#13;;
  label22.caption:=label22.caption+#13+'This program''s a Freeware, its code''s a Mailware'+#13;
  label22.caption:=label22.caption+#13+'If the mail doesn''t work :'+#13+'Philippe Detournay'+#13+'17, rue de Floreffe'+#13+'5150 Franire Belgium';
end;

procedure TForm2.Button6Click(Sender: TObject);
begin
  if opendialog1.Execute then begin
    label23.caption:=opendialog1.filename;
    newconfig.skinfilename:=label23.caption;
    newskin:=true;
    updateskininfo;
  end;
end;

procedure TForm2.CheckBox6Click(Sender: TObject);
begin
  newconfig.copyonmove:=checkbox6.Checked;
end;

procedure TForm2.CheckBox7Click(Sender: TObject);
begin
  newconfig.deleteonremove:=checkbox7.Checked;
end;

procedure TForm2.ComboBox3Change(Sender: TObject);
begin
  newconfig.del_nb:=combobox3.itemindex+1;
end;

procedure TForm2.ComboBox6Change(Sender: TObject);
begin
  newconfig.sur_nb:=combobox6.itemindex+1;
end;

procedure TForm2.ComboBox5Change(Sender: TObject);
begin
  newconfig.del_int:=combobox5.itemindex+1;
end;

procedure TForm2.ComboBox7Change(Sender: TObject);
begin
  newconfig.sur_int:=combobox7.itemindex+1;
end;

procedure TForm2.Edit3Exit(Sender: TObject);
var bid:integer;
    d:double;
begin
  val(edit3.text,d,bid);
  if d<0.1 then begin
    d:=1;
    edit3.text:='1.0000';
  end;
  newconfig.del_delay:=trunc(d*1000);
end;

procedure TForm2.Edit4Exit(Sender: TObject);
var bid:integer;
    d:double;
begin
  val(edit4.text,d,bid);
  if d<0.1 then begin
    d:=1;
    edit4.text:='1.0000';
  end;
  newconfig.sur_delay:=trunc(d*1000);
end;

procedure TForm2.CheckBox8Click(Sender: TObject);
begin
  newconfig.usetimer:=checkbox8.checked;
  edit5.enabled:=newconfig.usetimer;
  edit6.enabled:=newconfig.usetimer;
end;

procedure TForm2.Edit5Exit(Sender: TObject);
var bid:integer;
    t:string;
begin
  val(edit5.text,newconfig.timerinterval,bid);
  str(newconfig.timerinterval,t);
  edit5.text:=t;
end;

procedure TForm2.Edit6Exit(Sender: TObject);
var bid:integer;
    t:string;
begin
  val(edit6.text,newconfig.timercount,bid);
  str(newconfig.timercount,t);
  edit6.text:=t;
end;

procedure ShellExecute(win:hwnd;op,fle,param,dir:pchar;show:longword);stdcall
external 'shell32.dll' name 'ShellExecuteA';


procedure TForm2.Label36Click(Sender: TObject);
begin
  shellexecute(application.handle,nil,'http://www.citeweb.net/pmplayer/',nil,nil,0);
end;

procedure TForm2.CheckBox9Click(Sender: TObject);
begin
  newconfig.accurate:=checkbox9.checked;
end;

procedure TForm2.CheckBox10Click(Sender: TObject);
begin
  trackbar1.enabled:=checkbox10.checked;
  newconfig.HighRefresh:=checkbox10.Checked;
  checkbox8.enabled:=newconfig.highrefresh;
  if not newconfig.highrefresh then begin
    checkbox8.checked:=true;
    CheckBox8Click(Form2);
  end;
end;

procedure TForm2.Button7Click(Sender: TObject);
begin
  label13.caption:='';
  newconfig.visfilename:=label13.caption;
  updatevisinfo;
  newvis:=true;
end;

end.
