Function GetCPU(T:Byte):Double;
Var Tm:Double;
Begin
  Tm:=GetTickCount-DebTimer;
  GetCpu:=LastCpu;
  If (T<>0) Or (Tm>1000) Then Begin
    If Tm>0 Then Begin
      LastCpu:=TotTimer/Tm;
      TotTimer:=0;
      DebTimer:=GetTickCount;
    End;  
  End;
End;

Function GetMod(Cmd:Byte):LongInt;
Var I,J:Word;
    Adr:LongWord;
Begin
  GetMod:=0;
  Case Cmd Of
    (*get cpu*)
    2:GetMod:=Round(GetCpu(0)*100);
    (*get taillebuffer*)
(*    3:GetMod:=GetSb(19);*)
    3:GetMod:=SoundDevice.BufferSize;
    (*get dsp version*)
    4:GetMod:=0;
    (*get ampli*)
    5:GetMod:=E.Ampli;
    (*get pattern*)
    6:If Joue And SoundDevice.Playing Then GetMod:=PatPos[GetMod(8)];
    (*get note*)
    7:If Joue And SoundDevice.Playing Then Begin
(*      Adr:=GetSb(6) SHR 8;*)
(*      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].Note;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].Note;
    End;
    (*get pos*)
    8:If Joue And SoundDevice.Playing Then Begin
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].Pos;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].Pos;
    End;
    (*get maxchan*)
    9:If Joue Then GetMod:=D.NChan;
    (*get reverb*)
    10:If E.UseDel Then GetMod:=1 Else GetMod:=0;
    (*get surround*)
    11:If E.UseSur Then GetMod:=1 Else GetMod:=0;
    (*get stereo*)
    12:If Stereo Then GetMod:=1 Else GetMod:=0;
    (*get numpos*)
    13:If Joue Then GetMod:=D.Max;
    (*sepa stereo*)
    14:Begin
      Case Sepa_Stereo Of
        1:GetMod:=0;
        2:GetMod:=1;
        4:GetMod:=2;
        8:GetMod:=3;
        16:GetMod:=4;
        32:GetMod:=5;
        64:GetMod:=6;
      End;
    End;
    (*get mcipos*)
(*    15:If Joue Then GetMod:=GetSb(4);*)
    15:If Joue And SoundDevice.Playing Then GetMod:=SoundDevice.PlayedBytes;
    (*get currbuff*)
(*    16:If Joue Then GetMod:=GetSb(5);*)
    16:If Joue And SoundDevice.Playing Then GetMod:=SoundDevice.CurrentBufferIndex;
    (*get currofs*)
(*    17:If Joue Then GetMod:=GetSb(6);*)
    17:If Joue And SoundDevice.Playing Then GetMod:=SoundDevice.OffsetInCurrentBuffer;
    (*get reserve*)
(*    18:If Joue Then GetMod:=GetSb(9);*)
    18:If Joue And SoundDevice.Playing Then GetMod:=SoundDevice.BuffersReady;
    (*get empty*)
    19:If Joue And SoundDevice.Playing Then GetMod:=SoundDevice.BufferCount-SoundDevice.BuffersReady;
    (*get currbuffofs*)
(*    20:If Joue Then GetMod:=GetSb(10);*)
    20:If Joue And SoundDevice.Playing Then GetMod:=LongWord(SoundDevice.CurrentBufferAddress);
    (*get b16*)
    21:If Joue Then If Out16B Then GetMod:=1 Else GetMod:=0;
    (*get usedchan*)
    22:If Joue Then Begin
      J:=0;
      For I:=0 To MaxChan-1 Do If Chan[I].Used Then Inc(J);
      GetMod:=J;
    End;
    (*get loopcount*)
    23:If joue And SoundDevice.Playing Then Begin
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].LoopCount;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].LoopCount;
    End;
    (*get shouldstop*)
    24:If Joue And SoundDevice.Playing Then Begin
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=0;
      If TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].ShouldStop Then GetMod:=1;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=0;
      If TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].ShouldStop Then GetMod:=1;
    End;
    (*get duree*)
    25:If Joue Then GetMod:=Duree;
    (*get dureeplay*)
    26:If Joue And SoundDevice.Playing Then GetMod:=Round((BaseTimer+SoundDevice.Timer)/1000);
    (*get ninstr*)
    27:If Joue Then If MType=3 Then GetMod:=D.NInstr Else GetMod:=0;
    (*get nsmpl*)
    28:If Joue Then If MType=3 Then GetMod:=D.NSmpl Else GetMod:=D.NInstr;
    (*get interpolation type*)
    29:GetMod:=E.Interpolation;
    (*get tickremove*)
    30:If E.TickRemove Then GetMod:=1 Else GetMod:=0;
    (*get modtype*)
    31:GetMod:=MType;
    (*get speed*)
    32:If Joue And SoundDevice.Playing Then Begin
(*      GetMod:=GetSb(14);*)
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].Speed;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].Speed;
    End;
    (*get mixspeed*)
    33:GetMod:=MixSpeed;
    (*get volume*)
    34:If SoundDevice.Volume<>65535 Then GetMod:=SoundDevice.Volume SHR 8 Else GetMod:=256;
    (*get pitch*)
    35:GetMod:=Round(E.Pitch*128);
    (*get espeed*)
    36:GetMod:=Round(E.Speed*128);
    (*get tempo*)
    37:If Joue And SoundDevice.Playing Then Begin
(*    GetMod:=GetSb(15);*)
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].Tempo;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].Tempo;
    End;
    (*get tick*)
    38:If Joue And SoundDevice.Playing Then Begin
(*    GetMod:=GetSb(16);*)
(*      Adr:=GetSb(6) SHR 8;
      GetMod:=TInfoBuff(GetNFo(GetSb(5))^).Nfo[Adr].Tick;*)
      Adr:=SoundDevice.OffsetInCurrentBuffer Shr 8;
      GetMod:=TInfoBuff(SoundDevice.Info[SoundDevice.CurrentBufferIndex]^).Nfo[Adr].Tick;
    End;
    (*get del nb*)
    39:GetMod:=E.NDel;
    (*get del delay*)
    40:GetMod:=Trunc(E.DelD*1000000);
    (*get del int*)
    41:GetMod:=E.ValD;
    (*get sur nb*)
    42:GetMod:=E.NSur;
    (*get sur delay*)
    43:GetMod:=Trunc(E.DelS*1000000);
    (*get sur int*)
    44:GetMod:=E.ValS;
    (*get imm shouldstop*)
    45:If Info.ShouldStop Then GetMod:=1;
  End;
End;

Function GetPattern(Patt,Note,Chan,What:Byte):Word;
Begin
  GetPattern:=0;
  if chan>=D.nchan then exit;
  Case What Of
    (*instru*)
    1:GetPattern:=Pattern[Patt,Chan]^.Instru[Note];
    (*period*)
    2:GetPattern:=Pattern[Patt,Chan]^.Period[Note];
    (*command*)
    3:Begin
      GetPattern:=Pattern[Patt,Chan]^.EffCmd[Note];
    End;
    (*command param*)
    4:Begin
      GetPattern:=Pattern[Patt,Chan]^.EffParam[Note];
    End;
    (*volume*)
    5:Begin
      GetPattern:=Pattern[Patt,Chan]^.VolCmd[Note];
    End;
    (*size*)
    6:GetPattern:=PRow[PatPos[Patt]];
  End;
End;

Function GetPatternS(Patt,Note,Chan,What:Byte):ShortString;


Const ModPer:Array[0..12*5] Of Word=(0,
  1712,1616,1525,1440,1357,1281,1209,1141,1077,1017, 961, 907,
   856, 808, 762, 720, 678, 640, 604, 570, 538, 508, 480, 453,
   428, 404, 381, 360, 339, 320, 302, 285, 269, 254, 240, 226,
   214, 202, 190, 180, 170, 160, 151, 143, 135, 127, 120, 113,
   107, 101,  95,  90,  85,  80,  76,  71,  67,  64,  60,  57);
Const ModStr:Array[0..12*5] Of String[3]=('---',
  'C-0','C#0','D-0','D#0','E-0','F-0','F#0','G-0','G#0','A-0','A#0','B-0',
  'C-1','C#1','D-1','D#1','E-1','F-1','F#1','G-1','G#1','A-1','A#1','B-1',
  'C-2','C#2','D-2','D#2','E-2','F-2','F#2','G-2','G#2','A-2','A#2','B-2',
  'C-3','C#3','D-3','D#3','E-3','F-3','F#3','G-3','G#3','A-3','A#3','B-3',
  'C-4','C#4','D-4','D#4','E-4','F-4','F#4','G-4','G#4','A-4','A#4','B-3');

Const S3mNotes:Array[0..11] Of String[2]=('C-','C#','D-','D#','E-','F-','F#','G-','G#','A-','A#','B-');
      S3mOct:Array[0..7] Of String[1]=('1','2','3','4','5','6','7','8');
Const XMNotes:Array[0..11] Of String[2]=('C-','C#','D-','D#','E-','F-','F#','G-','G#','A-','A#','B-');
      XMOct:Array[0..7] Of String[1]=('1','2','3','4','5','6','7','8');

Var N1,N2:Byte;
Var V:Word;
Var I:Byte;
Begin
  GetPatternS:='';
  if chan>=D.nchan then exit;
  Case What Of
    (*what to show*)
    1:Begin
      V:=Pattern[Patt,Chan]^.Period[Note];
      Case MTYpe Of
        1:Begin
          GetPatternS:='???';
          For I:=0 To 12*5 Do
            If ModPer[I]=V Then GetPatternS:=ModStr[I];
        End;
        2:Begin
          If V>0 Then Begin
            N1:=V AND $f;
            N2:=V SHR 4;
            GetPatternS:=S3mNotes[N1]+S3mOct[N2];
          End Else Begin
            GetPatternS:='---';
          End;
        End;
        3:Begin
          If V>0 Then Begin
            If V<>97 Then Begin
              N1:=(V-1) DIV 12;
              N2:=(V-1) MOD 12;
              GetPatternS:=XMNotes[N2]+XMOct[N1];
            End Else GetPatternS:='===';
          End Else Begin
            GetPatternS:='---';
          End;
        End;
      End;
    End;
  End;
End;


Function GetModS(Cmd:Byte):ShortString;
Begin
  GetModS:='';
  Case Cmd Of
    (*get mod title*)
    1:If Joue Then GetModS:=ModTitle Else GetModS:='';
  End;
End;

Function GetInstrS(Cmd:Word):ShortString;
Begin
  GetInstrS:=Instr[Cmd].FileName;
End;

Function GetSmplS(Cmd:Word):ShortString;
Begin
  If MType=3 Then Dec(Cmd);
  GetSmplS:=Smpl[Cmd].FileName;
End;

procedure redel;
var i,j:integer;
begin
  SetLength(E.MaxDel,E.NDel);
  SetLength(E.TaDel,E.NDel);
  For I:=0 To E.NDel-1 Do Begin
    E.MaxDel[I]:=Trunc(E.DelD*MixSpeed/1000000*(2 SHL I));
    E.TaDel[I]:=Trunc(E.ValD/(I+1));
  End;
  SetLength(E.Del.L,E.NDel);
  SetLength(E.Del.R,E.NDel);
  For I:=0 To E.NDel-1 Do Begin
    SetLength(E.Del.L[I].D,E.MaxDel[I]);
    SetLength(E.Del.R[I].D,E.MaxDel[I]);
  End;
  SetLength(D.Del,E.NDel);
  For J:=0 To E.NDel-1 Do Begin
    For I:=0 To E.MaxDel[J]-1 Do Begin
      E.Del.L[J].D[I]:=0;
      E.Del.R[J].D[I]:=0;
    End;
    D.Del[J]:=0;
  End;
end;

procedure resur;
var i,j:integer;
begin
  SetLength(E.MaxSur,E.NSur);
  SetLength(E.TaSur,E.NSur);

  For I:=0 To E.NSur-1 Do Begin
    E.MaxSur[I]:=Trunc(E.DelS*MixSpeed/1000000*(2 SHL I));
    E.TaSur[I]:=Trunc(E.ValS/(I+1));
  End;

  SetLength(E.Sur.L,E.NSur);
  SetLength(E.Sur.R,E.NSur);

  For I:=0 To E.NSur-1 Do Begin
    SetLength(E.Sur.L[I].S,E.MaxSur[I]);
    SetLength(E.Sur.R[I].S,E.MaxSur[I]);
  End;

  SetLength(D.Sur,E.NSur);

  For J:=0 To E.NSur-1 Do Begin
    For I:=0 To E.MaxSur[J]-1 Do Begin
      E.Sur.L[J].S[I]:=0;
      E.Sur.R[J].S[I]:=0;
    End;
    D.Sur[J]:=0;
  End;
end;

Procedure ModOptions(Cmd,Param:LongWord);
Var I,J:Word;
    Last:Boolean;
Begin
  Case Cmd Of
    (*reverb on/off*)
    1:Begin
      Last:=E.UseDel;
      If Param=255 Then E.UseDel:=Not E.UseDel Else
        If Param=0 Then E.UseDel:=False Else E.UseDel:=True;
      If E.UseDel And Joue And (Last<>E.UseDel) Then Begin
        (*vider les buffers*)
        For J:=0 To E.NDel-1 Do Begin
          For I:=0 To E.MaxDel[J]-1 Do Begin
            E.Del.L[J].D[I]:=0;
            E.Del.R[J].D[I]:=0;
          End;
          D.Del[J]:=0;
        End;
      End;
    End;
    (*suround on/off*)
    2:Begin
      Last:=E.UseSur;
      If Param=255 Then E.UseSur:=Not E.UseSur Else
        If Param=0 Then E.UseSur:=False Else E.UseSur:=True;
      If E.UseSur And Joue And (Last<>E.UseSur) Then Begin
        (*vider les buffers*)
        For J:=0 To E.NSur-1 Do Begin
          For I:=0 To E.MaxSur[J]-1 Do Begin
            E.Sur.L[J].S[I]:=0;
            E.Sur.R[J].S[I]:=0;
          End;
          D.Sur[J]:=0; 
        End;
      End;
    End;
    (*resetcpu*)
    3:Begin
      TotTimer:=0;
      DebTimer:=GetTickCount;
    End;
    (*autocall*)
(*    4:SetSb(1,Param);*)
    (*ampli*)
    5:E.Ampli:=Param;
    (*separation stereo*)
    6:Sepa_Stereo:=1 SHL Param;
    (*pause on/off*)
(*    7:setsb(2,param);*)
    7:If Param=0 Then SoundDevice.Resume Else SoundDevice.Pause;
    (*set new nloop*)
    8:Info.NLoop:=Param;
    (*set master volume*)
    9:D.MVol:=Param;
    (*set interpolation type*)
    10:E.Interpolation:=Param;
    (*set tickremove*)
    11:If Param<>0 Then Begin
         E.TickRemove:=True;
         D.BaseLeft:=0;
         D.BaseRight:=0;
         D.LastLeft:=0;
         D.LastRight:=0;
         D.BaseSpeedLeft:=0;
         D.BaseSpeedRight:=0;
       End Else Begin
         E.TickRemove:=False;
       End;
    (*set taillebuffer*)
(*    12:SetSb(3,Param);*)
    12:SoundDevice.BufferSize:=Param;
    (*set nbuffers*)
(*    13:SetSb(4,Param);*)
    13:SoundDevice.BufferCount:=Param;
    (*set volume*)
    14:If Param<>256 Then SoundDevice.Volume:=Param*256 Else SoundDevice.Volume:=65535;
    (*set pitch*)
    15:E.Pitch:=Param/128;
    (*set espeed*)
    16:Begin
      If Param/128<>E.Speed Then Begin
        E.Speed:=Param/128;
        If Joue Then Begin
          D.OpTicks:=Round(MixSpeed/(D.Bpm*2/5*E.Speed)*256);
          D.TickOfs:=1;
          D.PosSend:=0;
          D.CurSend:=D.OpTicks;
        End;
      End;
    End;
    (*set del nb*)
    17:Begin
      If Param<>E.NDel Then Begin
        E.NDel:=Param;
        ReDel;
      End;
    End;
    (*set del delay*)
    18:Begin
      If Param<>E.DelD Then Begin
        E.DelD:=Param;
        ReDel;
      End;
    End;
    (*set del int*)
    19:Begin
      If Param<>E.ValD Then Begin
        E.ValD:=Param;
        ReDel;
      End;
    End;
    (*set sur nb*)
    20:Begin
      If Param<>E.NSur Then Begin
        E.NSur:=Param;
        ReSur;
      End;
    End;
    (*set sur delay*)
    21:Begin
      If Param<>E.DelS Then Begin
        E.DelS:=Param;
        ReSur;
      End;
    End;
    (*set sur int*)
    22:Begin
      If Param<>E.ValS Then Begin
        E.ValS:=Param;
        ReSur;
      End;
    End;

  End;
End;

Function UpdateSoundConfig(DeviceType:Word;Device:LongInt;Speed:Word;Vs,Vb:Boolean;Pos,Note:Byte;FileN:String;Pre:Single;CBWin:HWnd):Boolean;
Var C:Byte;
    I:Integer;
Begin
  UpdateSoundConfig:=False;

  If Joue Then Begin
    Inc(BaseTimer,Round(SoundDevice.Timer));
    SoundDevice.Stop;
    For C:=0 To MaxChan-1 Do Chan[C].Used:=False;
    For I:=0 To 255 Do PUsed[I]:=False;
    MixSpeed:=Speed;
    D.Pos:=Pos;
    VerifPos;
    For I:=0 To Pos Do PUsed[I]:=True;
    D.Pattern:=PatPos[D.Pos];
    D.Note:=Note;

    D.Speed:=PosSpeed[D.Pos];
    D.Bpm:=PosTempo[D.Pos];

    If D.Bpm=0 Then Exit;

    D.OpTicks:=Round(MixSpeed/(D.Bpm*2/5*E.Speed)*256);
    D.Tick:=0;
    D.TickOfs:=1;
    D.PosSend:=0;
    D.CurSend:=D.OpTicks;
    Do_Note;
    Do_Effects;

    Stereo:=Vs;
    Out16B:=Vb;
    If Stereo Then
      If Out16B Then D.Mode:=4 Else D.Mode:=2
    Else
      If Out16B Then D.Mode:=3 Else D.Mode:=1;

    SoundDevice.DeviceType:=DeviceType;
    SoundDevice.DeviceIndex:=Device;
    SoundDevice.OutFrequency:=MixSpeed;
    SoundDevice.OutStereo:=Stereo;
    SoundDevice.Out16Bits:=Out16B;
    SoundDevice.DecodeHandler:=Decode;
    SoundDevice.ErrorHandler:=ErrHandler;
    SoundDevice.InfoStructureSize:=SizeOf(TInfoBuff);
    SoundDevice.OutFileName:=FileN;
    SoundDevice.PreBuffering:=Pre;
    If SoundDevice.Play Then Begin
      Joue:=True;
      TotTimer:=0;
      DebTimer:=GetTickCount;
      UpdateSoundConfig:=True;
      SoundDevice.Perform;
    End Else Begin
      UnInitMod;
    End;
  End;
End;
